--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_update_clock = class("frame_update_clock", function() return ImageView:create() end)

function frame_update_clock:ctor()
    
end

function frame_update_clock:init()
    self.fTimer = 0;
    self.callback_id = 0;
    self.callback_list = {};

    self:scheduleUpdateWithPriorityLua(function(dt) self:update(dt) end, 0);
end

function frame_update_clock:destroy()
    self:unscheduleUpdate();
end

function frame_update_clock:add_callbcak(callback, param)
    if callback == 0 then return; end

    self.callback_id = self.callback_id + 1;

    local callback_data = {};
    callback_data.id = self.callback_id;
    callback_data.func = callback;
    callback_data.param = param;
    
    table.insert(self.callback_list, callback_data);

    return callback_data.id;
end

function frame_update_clock:delete_callback(id)
    if id == nil then return;end

    for k,v in pairs(self.callback_list) do
        if v.id == id then
            table.remove(self.callback_list, k);
            break;
        end
    end
end

function frame_update_clock:update(dt)
    self.fTimer=self.fTimer+dt;
    if self.fTimer >= 1 then
        self.fTimer = self.fTimer - 1
    else
        return 
    end
    
    for k,v in pairs(self.callback_list) do
        if v.func then
            v.func(v.param);
        else
            self:delete_callback(v.id);
        end
    end

end

--endregion
