--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_chat_left_win = class("frame_chat_left_win",function() return frame_window:new() end)

function frame_chat_left_win:ctor()
    self.m_str_text = {
        "测试1",
        "测试2",
        "哎，一手的烂牌臭到底,哎，一手的烂牌臭到底,臭到底,底到臭",
        "保子冒出来了啊",
        "打一个来碰噻",
        "都不细刺挠你",
        "杠熟米来",
    }
    
    self._list_text_label = {};
    self._list_text_btn = {};
    self._list_text_line = {};

    self._list_emotion_label = {};
    self._list_emotion_line = {};
end

function frame_chat_left_win:init()
    self:setVisible(false);

    self.__back:setVisible(false);

    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_chat_win/frame_chat_bg.png");
    self._bg:setTouchEnabled(true);
    --常用语按钮
    self._btn_text = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_text);
    self._btn_text:setPosition(ccp(-196, 106));
    self._btn_text:loadTextures("frame_chat_left_1.png","frame_chat_left_1.png","frame_chat_left_2.png", 1);
    self._btn_text:addTouchEventListener(function(sender, touchType) self:on_btn_text(sender, touchType) end);
    self._btn_text:setBright(false);
    --表情按钮
    self._btn_emotion = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_emotion);
    self._btn_emotion:setPosition(ccp(-196, -107));
    self._btn_emotion:loadTextures("frame_chat_left_emotion_1.png","frame_chat_left_emotion_1.png","frame_chat_left_emotion_2.png", 1);
    self._btn_emotion:addTouchEventListener(function(sender, touchType) self:on_btn_emotion(sender, touchType) end);


    --常用语
    self.m_width_scroll = 410;
    self._text_scroll = ScrollView:create();
    self._bg:addChild(self._text_scroll);
    self._text_scroll:setAnchorPoint(ccp(0.5, 0.5) );
    self._text_scroll:setPosition(ccp(25, 0 ) );
    self._text_scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
    self._text_scroll:setSize(CCSizeMake(self.m_width_scroll,420));

--    self:set_text_list(self.m_str_text);
    
    --表情
    self._emotion_scroll = ScrollView:create();
    self._bg:addChild(self._emotion_scroll);
    self._emotion_scroll:setAnchorPoint(ccp(0.5, 0.5) );
    self._emotion_scroll:setPosition(ccp(35, 0 ) );
    self._emotion_scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
    self._emotion_scroll:setSize(CCSizeMake(self.m_width_scroll,420));

    self._emotion_scroll:setVisible(false);

    local item_height = 82;
    local gap_width = 35;
    local item_width = (self.m_width_scroll - gap_width * 2 ) / 8;
    local emotion_count = 31;
    local line_count = emotion_count / 4;
    for i=1,emotion_count do
        local emotion = ImageView:create();
        self._emotion_scroll:addChild(emotion);
        emotion:loadTexture("frame_emotion_"..i..".png",1);
        table.insert(self._list_emotion_label, emotion);
        local width = emotion:getSize().width;
        emotion:setScale(60/width);
        local index = i - 1;
        local line_index = (index - (index % 4) ) / 4 + 1;
        local list_index = (index % 4); 
        emotion:setPosition(ccp( list_index * 2 * item_width + item_width + gap_width, ( (line_count - line_index + 0.5) * item_height + 20) ) )
        emotion:setTouchEnabled(true);
        emotion:addTouchEventListener(function(sender, touchType) self:on_btn_emotion_item(sender, touchType, i) end);

        if list_index == 3 and line_index ~= line_count then
            local line = ImageView:create()
            self._emotion_scroll:addChild(line);
            line:loadTexture("frame_chat_line.png",1);
            line:setPosition(ccp(self.m_width_scroll / 2, (line_count - line_index) * item_height + 20 ) );

            table.insert(self._list_emotion_line, line);
        end
    end

    local height = item_height * line_count + 20;
    if height < 400 then height = 400 end;
    print("height:", height)
    self._emotion_scroll:setInnerContainerSize(CCSizeMake(self.m_width_scroll, height) );

end

function frame_chat_left_win:set_text_list(list_text)
    self.m_str_text = list_text;

    if type(self.m_str_text) == "table" then
        local item_height = 82;
        local nTextCount = #self.m_str_text;
        for k,v in pairs(self.m_str_text) do
            --文字
            local text = nil;
            if k > #self._list_text_label  then
                text = UILabelEx3:new();
                self._text_scroll:addChild(text);
                text:setFontSize(24);
                text:setColor(ccc3(147,106,76));
                text:setAnchorPoint(ccp(0, 0.5) );
                table.insert(self._list_text_label, text);
            else
                text = self._list_text_label[k];
            end
            text:setTextEx(v, 350, 1);
            text:setPosition(ccp(35, (nTextCount - k + 0.5) * item_height ) );

            --按钮
            local button = nil
            if k > #self._list_text_btn then
                button = ImageView:create();
                self._text_scroll:addChild(button);
                button:loadTexture("frame/image/lucency.png");
                button:setScale9Enabled(true);
                button:setAnchorPoint(ccp(0, 0.5) );
                button:setSize(CCSizeMake(self.m_width_scroll, item_height) );
                table.insert(self._list_text_btn, button);
                button:setTouchEnabled(true);
                button:addTouchEventListener(function(sender, touchType) self:on_btn_text_item(sender, touchType, k) end);
            else
                button = self._list_text_btn[k];
            end
            button:setPosition(ccp(35, (nTextCount - k + 0.5) * item_height ) );

            if k == #self.m_str_text then break; end
            --分割线
            local line = nil
            if k > #self._list_text_line then
                line = ImageView:create()
                self._text_scroll:addChild(line);
                line:loadTexture("frame_chat_line.png",1);
                table.insert(self._list_text_line, line);
            else
                line = self._list_text_line[k];
            end
            line:setPosition(ccp(self.m_width_scroll / 2, (nTextCount - k) * item_height ) );
        end
        local height = item_height * nTextCount;
        if height < 400 then height = 400 end;
        print("height:", height)
        self._text_scroll:setInnerContainerSize(CCSizeMake(self.m_width_scroll, height) );
    end

end

function frame_chat_left_win:on_btn_text(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self._btn_text:setTouchEnabled(false);
    self._btn_text:setBright(false);

    self._btn_emotion:setTouchEnabled(true);
    self._btn_emotion:setBright(true);

    self._text_scroll:setVisible(true);
    self._emotion_scroll:setVisible(false);
end

function frame_chat_left_win:on_btn_emotion(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self._btn_text:setTouchEnabled(true);
    self._btn_text:setBright(true);

    self._btn_emotion:setTouchEnabled(false);
    self._btn_emotion:setBright(false);

    self._text_scroll:setVisible(false);
    self._emotion_scroll:setVisible(true);
end

function frame_chat_left_win:on_btn_text_item(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local send_data = {};
    send_data.userid = frame_tools:get_self_user_id();
    send_data.touserid = 0;
    send_data.id = index;
    send_data.mask = 0;

    frame_tools:send_user_chat_data(send_data);

    --test
--    frame_tools:show_chat_text(2, self.m_str_text[index]);

    self:show_window(false, false);
end

function frame_chat_left_win:on_btn_emotion_item(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local send_data = {};
    send_data.userid = frame_tools:get_self_user_id();
    send_data.touserid = 0;
    send_data.id = index + 1000;
    send_data.mask = 0;

    frame_tools:send_user_chat_data(send_data);

--    frame_tools:show_emotion_ani(2, index);

    self:show_window(false, false);
end



------------------------------------------------------------------------------------------------------------------------
---
------------------------------------------------------------------------------------------------------------------------
frame_chat_right_win = class("frame_chat_right_win",function() return frame_window:new() end)

function frame_chat_right_win:ctor()
    self.m_str_text = {
        "测试1",
        "测试2",
        "哎，一手的烂牌臭到底,哎，一手的烂牌臭到底,臭到底,底到臭",
        "保子冒出来了啊",
        "打一个来碰噻",
        "都不细刺挠你",
        "杠熟米来",
    }
    
    self._list_text_label = {};
    self._list_text_btn = {};
    self._list_text_line = {};

    self._list_emotion_label = {};
    self._list_emotion_line = {};
end

function frame_chat_right_win:init()
    self:setVisible(false);

    self.__back:setVisible(false);

    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_chat_win/frame_chat_bg.png");
    self._bg:setTouchEnabled(true);
    --常用语按钮
    self._btn_text = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_text);
    self._btn_text:setPosition(ccp(196, 106));
    self._btn_text:loadTextures("frame_chat_left_1.png","frame_chat_left_1.png","frame_chat_left_2.png", 1);
    self._btn_text:addTouchEventListener(function(sender, touchType) self:on_btn_text(sender, touchType) end);
    self._btn_text:setBright(false);
    --表情按钮
    self._btn_emotion = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_emotion);
    self._btn_emotion:setPosition(ccp(196, -107));
    self._btn_emotion:loadTextures("frame_chat_left_emotion_1.png","frame_chat_left_emotion_1.png","frame_chat_left_emotion_2.png", 1);
    self._btn_emotion:addTouchEventListener(function(sender, touchType) self:on_btn_emotion(sender, touchType) end);


    --常用语
    self.m_width_scroll = 410;
    self._text_scroll = ScrollView:create();
    self._bg:addChild(self._text_scroll);
    self._text_scroll:setAnchorPoint(ccp(0.5, 0.5) );
    self._text_scroll:setPosition(ccp(-25, 0 ) );
    self._text_scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
    self._text_scroll:setSize(CCSizeMake(self.m_width_scroll,420));

--    self:set_text_list(self.m_str_text);
    
    --表情
    self._emotion_scroll = ScrollView:create();
    self._bg:addChild(self._emotion_scroll);
    self._emotion_scroll:setAnchorPoint(ccp(0.5, 0.5) );
    self._emotion_scroll:setPosition(ccp(-35, 0 ) );
    self._emotion_scroll:setDirection(_G.SCROLLVIEW_DIR_VERTICAL)
    self._emotion_scroll:setSize(CCSizeMake(self.m_width_scroll,420));

    self._emotion_scroll:setVisible(false);

    local item_height = 82;
    local gap_width = 35;
    local item_width = (self.m_width_scroll - gap_width * 2 ) / 8;
    local emotion_count = 31;
    local line_count = emotion_count / 4;
    for i=1,emotion_count do
        local emotion = ImageView:create();
        self._emotion_scroll:addChild(emotion);
        emotion:loadTexture("frame_emotion_"..i..".png",1);
        table.insert(self._list_emotion_label, emotion);
        local width = emotion:getSize().width;
        emotion:setScale(60/width);
        local index = i - 1;
        local line_index = (index - (index % 4) ) / 4 + 1;
        local list_index = (index % 4); 
        emotion:setPosition(ccp( list_index * 2 * item_width + item_width + gap_width, ( (line_count - line_index + 0.5) * item_height + 20 ) ) )
        emotion:setTouchEnabled(true);
        emotion:addTouchEventListener(function(sender, touchType) self:on_btn_emotion_item(sender, touchType, i) end);

        if list_index == 3 and line_index ~= line_count then
            local line = ImageView:create()
            self._emotion_scroll:addChild(line);
            line:loadTexture("frame_chat_line.png",1);
            line:setPosition(ccp(self.m_width_scroll / 2, (line_count - line_index) * item_height + 20 ) );

            table.insert(self._list_emotion_line, line);
        end
    end

    local height = item_height * line_count + 20;
    if height < 400 then height = 400 end;
    print("height:", height)
    self._emotion_scroll:setInnerContainerSize(CCSizeMake(self.m_width_scroll, height) );

end

function frame_chat_right_win:set_text_list(list_text)
    self.m_str_text = list_text;

    if type(self.m_str_text) == "table" then
        local item_height = 82;
        local nTextCount = #self.m_str_text;
        for i=1,nTextCount do
            local k = i
            local v = self.m_str_text[i];
             --文字
            local text = nil;
            if k > #self._list_text_label  then
                text = UILabelEx3:new();
                self._text_scroll:addChild(text);
                text:setFontSize(24);
                text:setColor(ccc3(147,106,76));
                text:setAnchorPoint(ccp(0, 0.5) );
                table.insert(self._list_text_label, text);
            else
                text = self._list_text_label[k];
            end
            text:setTextEx(v, 350, 1);
            text:setPosition(ccp(35, (nTextCount - k + 0.5) * item_height ) );

            --按钮
            local button = nil
            if k > #self._list_text_btn then
                button = ImageView:create();
                self._text_scroll:addChild(button);
                button:loadTexture("frame/image/lucency.png");
                button:setScale9Enabled(true);
                button:setAnchorPoint(ccp(0, 0.5) );
                button:setSize(CCSizeMake(self.m_width_scroll, item_height) );
                table.insert(self._list_text_btn, button);
                button:setTouchEnabled(true);
                button:addTouchEventListener(function(sender, touchType) self:on_btn_text_item(sender, touchType, k) end);
            else
                button = self._list_text_btn[k];
            end
            button:setPosition(ccp(35, (nTextCount - k + 0.5) * item_height ) );

            if k == #self.m_str_text then break; end
            --分割线
            local line = nil
            if k > #self._list_text_line then
                line = ImageView:create()
                self._text_scroll:addChild(line);
                line:loadTexture("frame_chat_line.png",1);
                table.insert(self._list_text_line, line);
            else
                line = self._list_text_line[k];
            end
            line:setPosition(ccp(self.m_width_scroll / 2, (nTextCount - k) * item_height ) );
        end

        local height = item_height * nTextCount;
        if height < 400 then height = 400 end;
        print("height:", height)
        self._text_scroll:setInnerContainerSize(CCSizeMake(self.m_width_scroll, height) );
    end

end

function frame_chat_right_win:on_btn_text(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self._btn_text:setTouchEnabled(false);
    self._btn_text:setBright(false);

    self._btn_emotion:setTouchEnabled(true);
    self._btn_emotion:setBright(true);

    self._text_scroll:setVisible(true);
    self._emotion_scroll:setVisible(false);
end

function frame_chat_right_win:on_btn_emotion(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self._btn_text:setTouchEnabled(true);
    self._btn_text:setBright(true);

    self._btn_emotion:setTouchEnabled(false);
    self._btn_emotion:setBright(false);

    self._text_scroll:setVisible(false);
    self._emotion_scroll:setVisible(true);
end

function frame_chat_right_win:on_btn_text_item(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local send_data = {};
    send_data.userid = frame_tools:get_self_user_id();
    send_data.touserid = 0;
    send_data.id = index;
    send_data.mask = 0;

    frame_tools:send_user_chat_data(send_data);

    --test
--    frame_tools:show_chat_text(2, self.m_str_text[index]);

    self:show_window(false, false);
end

function frame_chat_right_win:on_btn_emotion_item(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local send_data = {};
    send_data.userid = frame_tools:get_self_user_id();
    send_data.touserid = 0;
    send_data.id = index + 1000;
    send_data.mask = 0;

    frame_tools:send_user_chat_data(send_data);

--    frame_tools:show_emotion_ani(2, index);

    self:show_window(false, false);
end




--endregion
