--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_hint_win = class("frame_hint_win", function() return frame_window:new() end );

function frame_hint_win:ctor()
    self.callback_left = nil;
    self.callback_right = nil;
end

function frame_hint_win:init()
    self:setVisible(false);

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_hint_win/frame_hint_bg.png");
    self._bg:setTouchEnabled(true)
    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_hint_btn_close.png","frame_hint_btn_close.png","frame_hint_btn_close.png",1);
    self._btn_close:setPosition(ccp(270, 170));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_hint_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 180));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_hint_title.png",1);

    --内容
    self._label_content = Label:create();
    self._bg:addChild(self._label_content);
    self._label_content:setPosition(ccp(0,30));
    self._label_content:setFontSize(30);
    self._label_content:setColor(ccc3(121,57,21) );

    --右按钮
    self._btn_right = frame_tools:get_a_btn();
    self._btn_right:loadTextureNormal("frame_hint_btn_left.png", 1);
    self._bg:addChild(self._btn_right);
    self._btn_right:setPosition(ccp(150,-120));
    self._btn_right:addTouchEventListener(function(sender, touchType) self:on_btn_ok(sender, touchType) end);

    self._label_right = LabelBMFont:create();  
    self._label_right:setFntFile("frame/image/frame_hint_win/left/1.fnt");
    self._btn_right:addChild(self._label_right);

    --左按钮(位置换了)
    self._btn_left = frame_tools:get_a_btn();
    self._btn_left:loadTextureNormal("frame_hint_btn_right.png", 1);
    self._bg:addChild(self._btn_left);
    self._btn_left:setPosition(ccp(-150,-120));
    self._btn_left:addTouchEventListener(function(sender, touchType) self:on_btn_cancle(sender, touchType) end);

    self._label_left = LabelBMFont:create();  
    self._label_left:setFntFile("frame/image/frame_hint_win/right/1.fnt");
    self._btn_left:addChild(self._label_left);
end

function frame_hint_win:set_data(table_data)
    self.callback_left = table_data.callback_left;
    self.callback_right = table_data.callback_right;

    local str_con = table_data.str_con;
    if str_con == nil then
        str_con = "";
    end
    self._label_content:setText(str_con);

    local str_left = table_data.str_left;
    if str_left == nil then
        str_left = "确定" ;
    end
    self._label_left:setText(str_left);

    local str_right = table_data.str_right;
    if str_right == nil then
        str_right = "取消";
    end
    self._label_right:setText(str_right);

    if table_data.type == 0 then
        self._btn_left:setPosition(ccp(0,-120));
        self._btn_right:setVisible(false);
    else
        self._btn_left:setPosition(ccp(-150,-120));
        self._btn_right:setPosition(ccp(150,-120));
        self._btn_right:setVisible(true);
    end
end

function frame_hint_win:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_hint_win:on_btn_cancle(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.callback_left then
        self.callback_left(sender, touchType);
    end

    self:show_window(false);
end

function frame_hint_win:on_btn_ok(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.callback_right then
        self.callback_right(sender, touchType);
    end

    self:show_window(false);
end


--endregion
