--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_test_win = class("frame_test_win",function() return ImageView:create() end);

function frame_test_win:ctor()
    self._text_list = {};
end

function frame_test_win:init()
    self._bg = ScrollView:create();
    self:addChild(self._bg);
    self._bg:setAnchorPoint(ccp(0.5,0.5));
    self._bg:setSize(CCSizeMake(330,300));
    self._bg:setDirection( _G.SCROLLVIEW_DIR_VERTICAL);
    self._bg:setTouchEnabled(true);

    self._btn_open_close = frame_tools:get_a_btn();
    self._btn_open_close:loadTextureNormal("frame/image/frame_task_win/frame_task_open_btn.png");
    self:addChild(self._btn_open_close);
    self._btn_open_close:setPosition(ccp(-330/2, 0));
    self._btn_open_close:addTouchEventListener(function(sender, touchType) self:on_btn_open(sender, touchType) end);
end

function frame_test_win:on_btn_open(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

--    self._btn_open_close:setVisible(false);
    self._bg:setVisible(not self._bg:isVisible() );
end

function frame_test_win:add_text(str_text)
    table.insert(self._text_list, str_text);

    if #self._text_list > 30 then
        table.remove(self._text_list, 1);
    end

    self:show_text();
end

function frame_test_win:show_text()
    if self._text_list == nil or next(self._text_list) == nil then return; end

    self._width = 330;
    self._bg:removeAllChildrenWithCleanup(true);
    local itemCount = #self._text_list;
    local allHeight = 0;
    local height = 0;
    for k,v in pairs(self._text_list) do
        local label = UILabelEx3:new();
        self._bg:addChild(label);
        label:setTextEx(v,310,1);
        height = label:getSize().height;
        label:setPosition(ccp(self._width / 2, height / 2 + allHeight));

        allHeight = allHeight + height;
    end
    allHeight = allHeight + height/2;
    if allHeight < 300 then
        allHeight = 300;
    end 
    self._bg:setInnerContainerSize(CCSizeMake(self._width, allHeight));
    self._bg:jumpToTop()
end

--endregion
