--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

------------------------------------------------------------------------------------------------------
--头像

frame_user_head = class("frame_user_head", function() return ImageView:create() end)

function frame_user_head:ctor()
    --用户ID
    self.__m_userid = -1;
    --头像id
    self.__m_faceid = -1;
    --性别
    self.__m_sex = -1;
    --金币
    self.__m_gold = 0;
    --姓名
    self.__m_name = "";
    --vip等级
    self.__m_vip = 0;
    --缩放倍数
    self.__m_head_scale = 1;
    --名字长度
    self.__m_name_length = 150;
    --
    self:init();
end

function frame_user_head:init()
    --头像背景
    self.__head_bg = ImageView:create();
    self:addChild(self.__head_bg);
    --头像
    self.__head = UICustomImage:create()
    self.__head_bg:addChild(self.__head);
    self.__head:setTouchEnabled(true);
    self.__head:setPosition(ccp(0,0));
    self.__head:addTouchEventListener(function(sender, touchType) self:__on_btn_head(sender, touchType) end);
    --头像框
    self.__head_fg = ImageView:create();
    self.__head_bg:addChild(self.__head_fg);
    self.__head_fg:loadTexture("frame_userinfo_head_bg.png", 1);
--    self._head_fg:setScale9Enabled(true);
--    self._head_fg:setSize(CCSizeMake(120, 120));

    --魅力
    --底图
    self.__img_charm_up = ImageView:create();
    self:addChild(self.__img_charm_up);
    self.__img_charm_up:loadTexture("frame_userinfo_gift_charm.png", 1);
    self.__img_charm_up:setPosition(ccp(0,0));
    self.__img_charm_up:setVisible(false);
    --魅力label
    self.__label_charm_up = Label:create();
    self.__img_charm_up:addChild(self.__label_charm_up);
    self.__label_charm_up:setPosition(ccp(5, 2));
    self.__label_charm_up:setFontSize(20);
    self.__label_charm_up:setText("+35");
    --名字背景
    self.__name_bg = ImageView:create();
    self:addChild(self.__name_bg);
    self.__name_bg:setPosition(ccp(0, -70));
    --名字label
    self.__name_label = UILabelEx3:new()
    self.__name_bg:addChild(self.__name_label);
    self.__name_label:setFontSize(22);   
--    self.__name_label:setPosition(ccp(0, -70));
    self.__name_label:setTextEx("这只是个测试",self.__m_name_length);
    --金币背景
    self.__gold_bg = ImageView:create()
    self:addChild(self.__gold_bg);
--    self._gold_bg:loadTexture(); 
    self.__gold_bg:setPosition(ccp(0,-100));
    --金币图标
    self.__gold_img = ImageView:create()
    self.__gold_bg:addChild(self.__gold_img);
    self.__gold_img:loadTexture("frame_userinfo_gift_gold.png",1);
    self.__gold_img:setPosition(ccp(0, 7));
    self.__gold_img:setScale(0.6)
    --金币label
    self.__gold_label = LabelBMFont:create();
    self.__gold_bg:addChild(self.__gold_label);
    self.__gold_label:setFntFile("frame_config/num_tx.fnt");
    self.__gold_label:setAnchorPoint(ccp(0,0.5));
    self.__gold_label:setPosition(ccp(0, 0));
    self.__gold_label:setText("1000000");
    --四角角标
    self.__img_corner = {};
    self.__corner_pos = { ccp(-40,-40),ccp(-40,40),ccp(40,40),ccp(40,-40) };
    for i = 1, 4 do
        local corner = ImageView:create()
        self.__head_bg:addChild(corner);
        corner:setPosition(self.__corner_pos[i]);
        corner:setVisible(false);
        corner:setZOrder(100);
        table.insert(self.__img_corner, corner);

--        self:set_head_corner(i, "frame_userinfo_vip1.png", 1);
    end
    --消息监听
    self.__m_update_user_data_listen_id = frame_tools:add_event_listen("update_user_data",function(user_data) 
        if self == nil or self.__update_user_data == nil then return; end
        self:__update_user_data(user_data)
        end
    );

    self.__m_update_gift_charm_listen_id = frame_tools:add_event_listen("update_gift_charm",function(data) 
        if self == nil or self.__update_gift_charm == nil then return; end
        self:__update_gift_charm(data)
        end
    );
end

function frame_user_head:__destroy()
    frame_tools:delete_event_listen("update_user_data", self.__m_update_user_data_listen_id);
    frame_tools:delete_event_listen("update_gift_charm", self.__m_update_gift_charm_listen_id);
end

--角标（层级100）index: 1,左下角、2，左上角、3，右上角、 --4，右下角（已用，贵族）
function frame_user_head:__show_head_corner(index, isShow)
    self.__img_corner[index]:setVisible(isShow);
end
--角标（层级100）index: 1,左下角、2，左上角、3，右上角、 --4，右下角（已用，贵族）
function frame_user_head:__set_head_corner(index, str_path, type)
    self.__img_corner[index]:loadTexture(str_path, type);
    local width = self.__img_corner[index]:getSize().width;
--    self.__img_corner[index]:setScale(60/width);

    self.__img_corner[index]:setVisible(true);
end
--设置头像框图片
function frame_user_head:__set_head_fg(str_path, type)
    self.__head_fg:loadTexture(str_path, type);
end
--设置金币图标
function frame_user_head:__set_gold_img(str_path, type)
    self.__gold_img:loadTexture(str_path, type);
end
--设置金币字体
function frame_user_head:__set_gold_fnt(str_path)
    self.__gold_label:setFntFile(str_path);
end
--设置userid,以显示头像
function frame_user_head:__set_userid(userid)
    local user_data = frame_logic:get_user_data_with_userid(userid);
    if user_data == nil then print("frame_log:get user data fail when user head set userid") end
    
    self:__set_user_data(user_data);
end
--消息监听回调
function frame_user_head:__update_user_data(user_data)
    if user_data.user_id ~= self.__m_userid then
        return;
    end

    self:__set_user_data(user_data);
end
--设置用户信息
function frame_user_head:__set_user_data(user_data)
    self.__m_userid = user_data.user_id;
    self.__m_faceid = user_data.face_id;
    self.__m_gold = user_data.gold;

    if frame_tools:is_score_kind() then
        self.__gold_img:loadTexture("frame/image/frame_user_head_score.png");
        self.__m_gold = user_data.socre;
    end

    self.__m_name = user_data.nickname
    self.__m_sex = user_data.sex;
    self.__m_vip = user_data.member;

    self:__update_window()
end
--刷新头像界面
function frame_user_head:__update_window()
    if self.__m_vip > 0 then
        self:__set_head_corner(4, "frame_userinfo_vip"..self.__m_vip..".png", 1);
    else
        self:__show_head_corner(4, false);
    end
    
    self.__name_label:setTextEx(self.__m_name, self.__m_name_length);
    self.__head:set_head(110, 110, self.__m_userid, self.__m_faceid, self.__m_sex)   

    local gold = self.__m_gold;
    local str_gold = tostring(gold)
    if gold >= 10000000 then
        local int_wan = math.modf(gold/10000)
        str_gold = int_wan.."万"
    elseif gold >= 100000 then
        local int_gold = gold / 10000;
        local int_woqu = (gold % 10000 - gold % 1000)/1000;
        if int_woqu == 0 then
            str_gold = ((gold - gold % 10000)/10000).."万"
        else
            str_gold = ((gold - gold % 1000)/10000).."万"
        end
    elseif gold >= 10000 then
        local int_gold = gold / 10000;
        local int_woqu = (gold % 10000 - gold % 100)/100;
        if int_woqu == 0 then
            str_gold = ((gold - gold % 10000)/10000).."万"
        elseif int_woqu % 10 == 0 then
            str_gold = ((gold - gold % 1000)/10000).."万"   
        else
            str_gold = ((gold - gold % 100)/10000).."万"
        end
    end
    self.__gold_label:setText(str_gold);

    local width_img = self.__gold_img:getContentSize().width * 0.6;
    local width_label = self.__gold_label:getContentSize().width;
    local width = width_img + width_label;

    self.__gold_img:setPosition(ccp( -width_label/2, 7 ) );
    self.__gold_label:setPosition(ccp( width_img-width/2, 0 ))
end
--设置名字label 长度
function frame_user_head:__set_name_length(length)
    self.__m_name_length = length;    
end
--设置头像（背景，头像，头像框，角标）缩放
function frame_user_head:__set_head_scale(scale)
--    print("set_head_scale:",scale);
    self.__head_scale = scale or 1;
    self.__head_bg:setScale(self.__head_scale);
end
--更新头像
function frame_user_head:__updata_head()
    self.__head:updata_head();
end
--头像点击事件
function frame_user_head:__on_btn_head(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    
    print("user_head_click");
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.__m_userid > 0 then
        frame_tools:open_user_info_win_with_userid(self.__m_userid);
    end

    self.__head:updata_head();
end
--消息监听回调
function frame_user_head:__update_gift_charm(data)
    if data == nil then return;end
    if data.charm == 0 then return;end
    if data.userid == self.__m_userid then
        self:__show_charm_up(math.abs(data.charm));
    elseif data.touserid == self.__m_userid then
        self:__show_charm_up(data.charm);
    end

end
--显示魅力值变化动画
function frame_user_head:__show_charm_up(charm)
    if charm > 0 then 
        self.__label_charm_up:setText("+"..charm);
    else
        self.__label_charm_up:setText(charm);
    end;
    self.__img_charm_up:stopAllActions();    
    self.__img_charm_up:setPosition(ccp(0,0));
    self.__img_charm_up:setOpacity(0);
    self.__img_charm_up:setVisible(true);

    local array1 = CCArray:create();
    array1:addObject(CCDelayTime:create(1.5) );
    array1:addObject(CCFadeIn:create(0.1) )
    self.__img_charm_up:runAction(CCSequence:create(array1) );

    local height = self.__head:getSize().height/2 * self.__head_scale;

    local array = CCArray:create();
    array:addObject(CCDelayTime:create(1.5));
    array:addObject(CCMoveTo:create(0.5, ccp(0, height + 13) ) );
    array:addObject(CCDelayTime:create(2) );
    array:addObject(CCFadeOut:create(0.1) );
    array:addObject(CCCallFunc:create(function() self.__img_charm_up:setVisible(false) end) )

    self.__img_charm_up:runAction(CCSequence:create(array) );
end

--endregion
