--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_user_info_self = class("frame_user_info_self", function() return frame_window:new() end );

function frame_user_info_self:ctor()
    self.m_game_id = 0;

    self.m_vip = 0;
    self.m_face_id = 0;
    self.m_str_name = "";
    self.m_gold = 0;
    self.m_score = 0;
    self.m_win_count = 0;
    self.m_lose_count = 0; 
    self.m_draw_count = 0; 
    self.m_like = 0;
    self.m_charm = 0;
    self.m_sex = 0;
    self.m_userid = 0;
    self.m_chair_id = 0;
    self.m_level_name = "";

    self.m_amulet = 0;
    self.m_double_card = 0;
    self.m_score_clear_card = 0;

    self.m_prop_data_amulet = "";
    self.m_prop_data_double_card  = "";

    self.m_amulet_time = 0;
    self.m_double_card_time = 0;
end

function frame_user_info_self:init(game_id)
    self:setVisible(false);
 
    self.m_prop_data_amulet = frame_tools:get_prop_data_by_id(FRAME_USER_PROP_ID.amulet).caption;
    self.m_prop_data_double_card = frame_tools:get_prop_data_by_id(FRAME_USER_PROP_ID.double_card).caption;

    self.m_game_id = game_id;

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_user_info_win/frame_userinfo_self_bg.png");
    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_userinfo_close.png","frame_userinfo_close.png","frame_userinfo_close.png",1);
    self._btn_close:setPosition(ccp(265, 155));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_userinfo_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 170));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_userinfo_title.png",1);
    
    --左
    --vip 
    self._vip = ImageView:create();
    self._bg:addChild(self._vip);
    self._vip:loadTexture("frame_userinfo_vip0.png",1);
    self._vip:setPosition(ccp(-245,95));

    --
    self._vip_label = LabelBMFont:create();
    self._vip_label:setFntFile("frame/image/frame_user_info_win/1.fnt");
    self._vip:addChild(self._vip_label);
    self._vip_label:setText("贵族0");
    self._vip_label:setPosition(ccp(75, -5));

    --头像
    self._head_bg = ImageView:create();
    self._bg:addChild(self._head_bg);
    self._head_bg:setPosition(ccp(-200,20));
    self._head_bg:loadTexture("frame_userinfo_head_bg.png", 1);
    self._head_bg:setScale(86/120);

    self._head = UICustomImage:create()
    self._bg:addChild(self._head);
    self._head:setTouchEnabled(false);
    self._head:setPosition(ccp(-200,21));

    --双倍卡
    self._btn_double_card = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_double_card);
    self._btn_double_card:loadTextureNormal("frame_userinfo_btn_get_double.png", 1);
    self._btn_double_card:setPosition(ccp(-195,-60));
    self._btn_double_card:addTouchEventListener(function(sender, touchType) self:on_btn_double_card(sender, touchType) end);

    self._img_double_card = ImageView:create();
    self._img_double_card:setPosition(ccp(-50,0));
    self._btn_double_card:addChild(self._img_double_card);
    self._img_double_card:loadTexture("frame_userinfo_double_card.png", 1);
--    self._img_double_card:setScale(0.5);

    self._label_double_card = Label:create();
    self._btn_double_card:addChild(self._label_double_card);
    self._label_double_card:setFontSize(20);
    self._label_double_card:setText("获取");
    self._label_double_card:setPosition(ccp(16,0));

    --护身符
    self._btn_amulet = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_amulet);
    self._btn_amulet:loadTextureNormal("frame_userinfo_btn_amulet.png", 1);
    self._btn_amulet:setPosition(ccp(-195,-120));
    self._btn_amulet:addTouchEventListener(function(sender, touchType) self:on_btn_amulet(sender, touchType) end);

    self._img_amulet = ImageView:create();
    self._img_amulet:setPosition(ccp(-50,0));
    self._btn_amulet:addChild(self._img_amulet);
    self._img_amulet:loadTexture("frame_userinfo_amulet.png", 1);
--    self._img_amulet:setScale(0.5);

    self._label_amulet = Label:create();
    self._btn_amulet:addChild(self._label_amulet);
    self._label_amulet:setFontSize(20);
    self._label_amulet:setText("使用(12)");
    self._label_amulet:setPosition(ccp(16,0));

    --右
    --性别
    self._sex = ImageView:create();
    self._bg:addChild(self._sex);
    self._sex:setPosition(ccp(-60, 90));
    self._sex:loadTexture("frame_userinfo_man.png", 1);

    --名字
    self._name = UILabelEx3:new();
    self._bg:addChild(self._name);
    self._name:setPosition(ccp(-35,90) );
    self._name:setFontSize(26);
    self._name:setAnchorPoint(ccp(0,0.5));
    self._name:setColor(ccc3(123,56,38));
    self._name:setTextEx("玩家tes353452456", 230);

    --金币
    self._gold_bg = ImageView:create();
    self._bg:addChild(self._gold_bg);
    self._gold_bg:loadTexture("frame_userinfo_gold_bg.png", 1);
    self._gold_bg:setPosition(ccp(40, 40));

    self._gold_img = ImageView:create();
    self._gold_bg:addChild(self._gold_img);
    self._gold_img:loadTexture("frame_userinfo_gift_gold.png",1);
    self._gold_img:setPosition(ccp(-100, 0));

    self._gold = Label:create();
    self._gold_bg:addChild(self._gold);
    self._gold:setFontSize(26);
    self._gold:setColor(ccc3(123,56,38));
    self._gold:setText("99999999999");

    --积分
    self._score = Label:create();
    self._bg:addChild(self._score);
    self._score:setFontSize(26);
    self._score:setAnchorPoint(ccp(0,0.5));
    self._score:setColor(ccc3(123,56,38));
    self._score:setText("积分:10000（从四品）");
    self._score:setPosition(ccp(-75, -10))

    --积分清零卡
    self._btn_score_clear = frame_tools:get_a_btn();
    self._btn_score_clear:loadTextureNormal("frame_userinfo_clear_score.png",1);
    self._score:addChild(self._btn_score_clear);
    self._btn_score_clear:setPosition(ccp(305, 0))
    self._btn_score_clear:addTouchEventListener(function(sender, touchType) self:on_btn_score_clear(sender, touchType) end);

    --胜率
    self._win_rate = Label:create();
    self._bg:addChild(self._win_rate);
    self._win_rate:setFontSize(26);
    self._win_rate:setAnchorPoint(ccp(0,0.5));
    self._win_rate:setColor(ccc3(123,56,38));
    self._win_rate:setText("胜率:20%");
    self._win_rate:setPosition(ccp(-75, -50))

    --战绩
    self._record = Label:create();
    self._bg:addChild(self._record);
    self._record:setFontSize(26);
    self._record:setAnchorPoint(ccp(0,0.5));
    self._record:setColor(ccc3(123,56,38));
    self._record:setText("战绩:20胜/12平/30负");
    self._record:setPosition(ccp(-75, -90))

    --魅力
    self._charm_img = ImageView:create();
    self._bg:addChild(self._charm_img);
    self._charm_img:loadTexture("frame_userinfo_charm.png",1)
    self._charm_img:setPosition(ccp(-60, -135) );

    self._charm = Label:create();
    self._charm_img:addChild(self._charm);
    self._charm:setFontSize(24);
    self._charm:setColor(ccc3(123,56,38));
    self._charm:setAnchorPoint(ccp(0,0.5));
    self._charm:setText("24151");
    self._charm:setPosition(ccp(30, 0))

    --点赞
    self._like_img = ImageView:create();
    self._bg:addChild(self._like_img);
    self._like_img:loadTexture("frame_userinfo_like.png",1)
    self._like_img:setPosition(ccp(110, -135) );

    self._like = Label:create();
    self._like_img:addChild(self._like);
    self._like:setFontSize(24);
    self._like:setColor(ccc3(123,56,38));
    self._like:setAnchorPoint(ccp(0,0.5));
    self._like:setText("24151");
    self._like:setPosition(ccp(30, 0))


    self.m_update_user_data_listen_id = frame_tools:add_event_listen("update_user_data", function(user_data)
        if self == nil or self.update_user_data == nil then return; end
        self:update_user_data(user_data) 
        end 
    );
end

function frame_user_info_self:destroy()
    frame_tools:delete_event_listen("update_user_data", self.m_update_user_data_listen_id);    
end

function frame_user_info_self:update_user_data(user_data)
    if user_data == nil then return; end
    if self.m_userid ~= user_data.user_id then return; end

    self:set_user_data(user_data);
end

function frame_user_info_self:set_user_data(user_data)
    if user_data == nil then return;end

    self.m_userid = user_data.user_id or 0;
    self.m_face_id = user_data.face_id or 0;
    self.m_vip = user_data.member or 0;
    self.m_str_name = user_data.nickname or "";
    self.m_gold = user_data.gold or 0;
    self.m_score = user_data.socre or 0;
    self.m_win_count = user_data.win_count or 0;
    self.m_lose_count = user_data.lose_count or 0;
    self.m_draw_count = user_data.draw_count or 0;
    self.m_like = user_data.praise or 0;
    self.m_charm = user_data.charm or 0;
    self.m_sex = user_data.sex or 0;
    self.m_chair_id = user_data.chair_id or -1;

    local level_data = frame_tools:get_score_level(self.m_score);
    if level_data ~= nil and level_data.name ~= nil then
        self.m_level_name = level_data.name;
    end
    
    self:load_prop_info();

    self:refresh_user_data();
    self:refresh_user_prop();
end

function frame_user_info_self:load_prop_info()
    --道具
    --护身符
    self.m_amulet = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.amulet) or 0;
    self.m_double_card = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.double_card) or 0;
    self.m_score_clear_card = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.score_clear_card) or 0;

    self.m_amulet_time = frame_tools:get_status_time_by_id(FRAME_USER_PROP_ID.amulet);
    self.m_double_card_time = frame_tools:get_status_time_by_id(FRAME_USER_PROP_ID.double_card);
    
end

function frame_user_info_self:refresh_user_prop()
    local now_time = os.time();

    if self.m_amulet_time > 0 and self.m_amulet_time > now_time then
        self._btn_amulet:setVisible(true);
      
        if self.m_amulet_time <= now_time then
            self.m_amulet_time = 0
        else
            local time_left = self.m_amulet_time - os.time();
            time_left = time_left - time_left % 60;
--            local time_day =  (time_left - time_left % 86400) / 86400 ;
--            time_left = time_left % 86400;
            local time_hour = (time_left - time_left % 3600) / 3600;
            local time_min =  (time_left % 3600) / 60;
--            if time_day > 0 then 
--                self._label_amulet:setText(time_day.."天"..time_hour.."时"..time_min.."分");
--            else
                self._label_amulet:setText(time_hour.."时"..time_min.."分");
--            end
        end
    else
        if self.m_amulet > 0  then
            self._label_amulet:setText("使用("..self.m_amulet..")");
        else
            self._label_amulet:setText("获取");
            if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) <= 0 then
                self._btn_amulet:setVisible(false);
            end
        end
    end

    if self.m_double_card_time > 0 and self.m_double_card_time > now_time then
        self._btn_double_card:setVisible(true);

        if self.m_double_card_time <= now_time then
            self.m_double_card_time = 0
        else
            local time_left = self.m_double_card_time - os.time();
            time_left = time_left - time_left % 60;
--            local time_day =  (time_left - time_left % 86400) / 86400 ;
--            time_left = time_left % 86400;
            local time_hour = (time_left - time_left % 3600) / 3600;
            local time_min =  (time_left % 3600) / 60;
--            if time_day > 0 then 
--                self._label_double_card:setText(time_day.."天"..time_hour.."时"..time_min.."分");
--            else
                self._label_double_card:setText(time_hour.."时"..time_min.."分");
--            end
        end
    else
        if self.m_double_card > 0  then
            self._label_double_card:setText("使用("..self.m_double_card..")");
        else
            self._label_double_card:setText("获取");
            if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) <= 0 then
                self._btn_double_card:setVisible(false);
            end
        end
    end

end

function frame_user_info_self:refresh_user_data()
        --设置性别
    if self.m_sex == 1 then
        self._sex:loadTexture("frame_userinfo_man.png", 1);
    else   
        self._sex:loadTexture("frame_userinfo_woman.png", 1);
    end

    --显示积分清零卡
    if self.m_score < 0 then
        if self.m_score_clear_card <= 0 then
            if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) <= 0 then
                self._btn_score_clear:setVisible(false);
            end
        else    
            self._btn_score_clear:setVisible(true);
        end
    else
        self._btn_score_clear:setVisible(false);
    end
    

    --计算胜率（去除小数点）
    local game_count = self.m_win_count + self.m_lose_count + self.m_draw_count;
    local win_rate = 0;
    if game_count > 0 then
        win_rate = (self.m_win_count / game_count) * 100;
        win_rate = win_rate - (win_rate % 1);
    end
    --设置VIP
    self:set_vip(self.m_vip);
    --头像
    self._head:set_head(76, 76, self.m_userid, self.m_face_id, self.m_sex)
    --金币
    self._gold:setText(tostring(self.m_gold) );
    --积分
    if self.m_level_name == "" or self.m_level_name == nil then
        self._score:setText("积分:"..tostring(self.m_score));
    else
        self._score:setText("积分:"..tostring(self.m_score).."("..self.m_level_name..")" );
    end
    --昵称
    self._name:setTextEx(self.m_str_name, 230);
    --战绩
    self._record:setText("战绩:"..self.m_win_count.."胜/"..self.m_lose_count.."平/"..self.m_draw_count.."负");
    --胜率
    self._win_rate:setText("胜率:"..tostring(win_rate).."%")
    --魅力
    if self.m_charm >= 10000 then
        self._charm:setText(string.format("%.1f", self.m_charm/1000).."K");
    elseif self.m_charm >= 1000  then
        self._charm:setText(string.format("%.2f", self.m_charm/1000).."K");
    else
        self._charm:setText(tostring(self.m_charm));
    end

    --点赞
    if self.m_like >= 10000 then
        self._like:setText(string.format("%.1f", self.m_like/1000).."K");
    elseif self.m_like >= 1000  then
        self._like:setText(string.format("%.2f", self.m_like/1000).."K");
    else
        self._like:setText(tostring(self.m_like));
    end

end

function frame_user_info_self:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_user_info_self:on_btn_double_card(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    local now_time = os.time();
    if self.m_double_card_time > now_time then return; end

    if self.m_double_card <= 0 then
        frame_tools:open_shop(2)
    else 
        frame_tools:open_hint_win( {
            str_con = "是否立即使用双倍积分卡？", 
            type = 1,
            str_left = "确定", 
            str_right = "取消", 
            callback_left = function() self:use_prop(FRAME_USER_PROP_ID.double_card) end,
            callback_right = nil, 
        } );
--        frame_tools:request_use_prop(FRAME_USER_PROP_ID.double_card, "", function(code) self:user_prop_callback(code, FRAME_USER_PROP_ID.double_card) end);
    end
end

function frame_user_info_self:on_btn_amulet(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    local now_time = os.time();
    if self.m_amulet_time > now_time then return; end

    if self.m_amulet <= 0 then
        frame_tools:open_shop(2)
    else 
        frame_tools:open_hint_win( {
            str_con = "是否立即使用积分护身符？", 
            type = 1,
            str_left = "确定", 
            str_right = "取消", 
            callback_left = function() self:use_prop(FRAME_USER_PROP_ID.amulet) end,
            callback_right = nil, 
        } );
--        frame_tools:request_use_prop(FRAME_USER_PROP_ID.amulet, "", function(code) self:user_prop_callback(code,FRAME_USER_PROP_ID.amulet) end);
    end
end

function frame_user_info_self:on_btn_score_clear(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

--    print("on_btn_score_clear");

    if self.m_score > 0 then
        return;
    end

    if self.m_score_clear_card <= 0 then
        frame_tools:open_shop(2)
    else 
        frame_tools:request_use_prop(FRAME_USER_PROP_ID.score_clear_card, self.m_game_id, function(code) self:user_prop_callback(code,FRAME_USER_PROP_ID.score_clear_card) end);
    end
end

function frame_user_info_self:set_vip(vip_level)
    if vip_level == 0 then
        self._vip:setVisible(false);
        return;
    end

    self._vip:loadTexture("frame_userinfo_vip"..vip_level..".png",1);
    self._vip_label:setText("贵族"..vip_level);
end

function frame_user_info_self:user_prop_callback(code, prop_id)
    if code ~= 1 then return; end

    if prop_id == FRAME_USER_PROP_ID.amulet then
        self.m_amulet = self.m_amulet - 1;
        if self.m_prop_data_amulet and self.m_prop_data_amulet ~= "" then
            frame_tools:show_hinting("护身符使用成功！");
        end
    elseif prop_id == FRAME_USER_PROP_ID.double_card then
        self.m_double_card = self.m_double_card - 1;
        if self.m_prop_data_amulet and self.m_prop_data_amulet ~= "" then
            frame_tools:show_hinting("双倍积分卡使用成功！");
        end
    elseif prop_id == FRAME_USER_PROP_ID.score_clear_card then
        self.m_score_clear_card = self.m_score_clear_card - 1;
    end
--    self:refresh_user_prop();
end

function frame_user_info_self:use_prop(prop_id)
--    if prop_id == FRAME_USER_PROP_ID.double_card then
        frame_tools:request_use_prop(prop_id, "", function(code) self:user_prop_callback(code, prop_id) end);
--    end
end

function frame_user_info_self:__update()
    if self:isVisible() == false then return; end

    self:load_prop_info();
    self:refresh_user_prop();
end
















------------------------------------------------------------------------------------------------------------------
--
------------------------------------------------------------------------------------------------------------------
frame_user_info_other = class("frame_user_info_other", function() return frame_window:new() end );

function frame_user_info_other:ctor()
    self.m_vip = 0;
    self.m_str_name = "";
    self.m_gold = 0;
    self.m_score = 0;
    self.m_win_count = 0;
    self.m_lose_count = 0; 
    self.m_draw_count = 0; 
    self.m_like = 0;
    self.m_charm = 0;
    self.m_sex = 0;
    self.m_chair_id = 0;
    self.m_level_name = "";

    self.m_shilian = 0;

    self.m_ti_card = 0;
    self.m_gift_card = 0;

    self.m_gift_info = {};

    self.m_prop_count = {};
end

function frame_user_info_other:init(gift_info)
    self:setVisible(false);
    
    if gift_info == nil then gift_info = {} end
    self.m_gift_info = gift_info;
    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_user_info_win/frame_userinfo_other_bg.png");
    self._bg:setTouchEnabled(true);
    --关闭
    self._btn_close = Button:create();
    self._bg:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_userinfo_close.png","frame_userinfo_close.png","frame_userinfo_close.png",1);
    self._btn_close:setPosition(ccp(265, 220));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_userinfo_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 230));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_userinfo_title.png",1);
    
    --左
    --vip 
    self._vip = ImageView:create();
    self._bg:addChild(self._vip);
    self._vip:loadTexture("frame_userinfo_vip0.png",1);
    self._vip:setPosition(ccp(-245,155));

    --
    self._vip_label = LabelBMFont:create();
    self._vip_label:setFntFile("frame/image/frame_user_info_win/1.fnt");
    self._vip:addChild(self._vip_label);
    self._vip_label:setText("贵族0");
    self._vip_label:setPosition(ccp(75,-5));

    --头像
    self._head_bg = ImageView:create();
    self._bg:addChild(self._head_bg);
    self._head_bg:setPosition(ccp(-195,70));
    self._head_bg:loadTexture("frame_userinfo_head_bg.png", 1);
    self._head_bg:setScale(85/120);

    self._head = UICustomImage:create()
    self._bg:addChild(self._head);
    self._head:setTouchEnabled(false);
    self._head:setPosition(ccp(-195,71));

    --踢人
    self._btn_ti = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_ti);
    self._btn_ti:setPosition(ccp(-195,-30))
    self._btn_ti:loadTextureNormal("frame_userinfo_btn_ti.png", 1);
    self._btn_ti:addTouchEventListener(function(sender, touchType) self:on_btn_ti(sender, touchType) end);

    --右
    --性别
    self._sex = ImageView:create();
    self._bg:addChild(self._sex);
    self._sex:setPosition(ccp(-60, 160));
    self._sex:loadTexture("frame_userinfo_man.png", 1);

    --名字
    self._name = UILabelEx3:new();
    self._bg:addChild(self._name);
    self._name:setPosition(ccp(-35,160) );
    self._name:setFontSize(26);
    self._name:setAnchorPoint(ccp(0,0.5));
    self._name:setColor(ccc3(123,56,38));
    self._name:setTextEx("玩家tes353452456", 230);

    --举报
    self._btn_report = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_report);
    self._btn_report:setPosition(ccp(250 ,145));
    self._btn_report:loadTextureNormal("frame_userinfo_btn_report.png", 1);
    self._btn_report:addTouchEventListener(function(sender, touchType) self:on_btn_report(sender, touchType) end);

    --金币
    self._gold_bg = ImageView:create();
    self._bg:addChild(self._gold_bg);
    self._gold_bg:loadTexture("frame_userinfo_gold_bg.png", 1);
    self._gold_bg:setPosition(ccp(40, 110));

    self._gold_img = ImageView:create();
    self._gold_bg:addChild(self._gold_img);
    self._gold_img:loadTexture("frame_userinfo_gift_gold.png",1);
    self._gold_img:setPosition(ccp(-100, 0));

    self._gold = Label:create();
    self._gold_bg:addChild(self._gold);
    self._gold:setFontSize(26);
    self._gold:setColor(ccc3(123,56,38));
    self._gold:setText("99999999999");

    --积分
    self._score = Label:create();
    self._bg:addChild(self._score);
    self._score:setFontSize(26);
    self._score:setAnchorPoint(ccp(0,0.5));
    self._score:setColor(ccc3(123,56,38));
    self._score:setText("积分:10000（从四品）");
    self._score:setPosition(ccp(-75, 60))

    --胜率
    self._win_rate = Label:create();
    self._bg:addChild(self._win_rate);
    self._win_rate:setFontSize(26);
    self._win_rate:setAnchorPoint(ccp(0,0.5));
    self._win_rate:setColor(ccc3(123,56,38));
    self._win_rate:setText("胜率:20%");
    self._win_rate:setPosition(ccp(-75, 20))

    --战绩
    self._record = Label:create();
    self._bg:addChild(self._record);
    self._record:setFontSize(26);
    self._record:setAnchorPoint(ccp(0,0.5));
    self._record:setColor(ccc3(123,56,38));
    self._record:setText("战绩:20胜/12平/30负");
    self._record:setPosition(ccp(-75, -20))

    --魅力
    self._charm_img = ImageView:create();
    self._bg:addChild(self._charm_img);
    self._charm_img:loadTexture("frame_userinfo_charm.png",1)
    self._charm_img:setPosition(ccp(-60, -65) );

    self._charm = Label:create();
    self._charm_img:addChild(self._charm);
    self._charm:setFontSize(24);
    self._charm:setColor(ccc3(123,56,38));
    self._charm:setAnchorPoint(ccp(0,0.5));
    self._charm:setText("24151");
    self._charm:setPosition(ccp(30, 0))

    --点赞
    self._like_btn = frame_tools:get_a_btn();
    self._bg:addChild(self._like_btn);
    self._like_btn:loadTextureNormal("frame_userinfo_like.png",1)
    self._like_btn:setPosition(ccp(110, -65) );
    self._like_btn:addTouchEventListener(function(sender, touchType)  self:on_btn_like(sender, touchType) end)

    self._like = Label:create();
    self._like_btn:addChild(self._like);
    self._like:setFontSize(24);
    self._like:setColor(ccc3(123,56,38));
    self._like:setAnchorPoint(ccp(0,0.5));
    self._like:setText("24151");
    self._like:setPosition(ccp(30, 0))

    --礼物
    self.m_gift_pos = { ccp(-226,-145), ccp(-113,-145), ccp(0,-145), ccp(113,-145), ccp(226,-145) }
    self.m_charm = {-1, -2, -5, 2, 1 };
    self._gifts = {};
    self.m_gift_count = 5;
    for i=1,self.m_gift_count do
        local gift = frame_userinfo_gift_item:new();
        gift:init(function(sender, touchType, index) self:on_btn_gift(sender, touchType, index, i) end);
        self._bg:addChild(gift);
        gift:set_gift_id(1010 + i);
        local gift_gold = math.abs(gift_info[i]*1000) or 0
        gift:set_gold(2, gift_gold);
        if gift_gold == 0 then gift:set_charm(0);
        else gift:set_charm((tonumber(gift_info[i]))); end      
        gift:setPosition(self.m_gift_pos[i]);

        table.insert(self._gifts, gift)
    end

    --表情券
    self._ticket_bg = ImageView:create();
    self._bg:addChild(self._ticket_bg);
    self._ticket_bg:setPosition(ccp(-180,-228));
    self._ticket_bg:loadTexture("frame_userinfo_ticket_bg.png",1);
    self._ticket_bg:setTouchEnabled(true);
    self._ticket_bg:addTouchEventListener(function(sender, touchType) self:on_btn_add_ticket(sender, touchType) end);

    self._ticket_img = ImageView:create();
    self._ticket_bg:addChild(self._ticket_img);
    self._ticket_img:setPosition(ccp(-90, -2));
    self._ticket_img:loadTexture("frame_userinfo_ticket.png",1);

    self._ticket_add = frame_tools:get_a_btn();
    self._ticket_add:loadTextureNormal("frame_userinfo_add_ticket.png", 1);
    self._ticket_bg:addChild(self._ticket_add);
    self._ticket_add:setPosition(ccp(90, -2));
    self._ticket_add:addTouchEventListener(function(sender, touchType) self:on_btn_add_ticket(sender, touchType) end);
    self._ticket_add:setTouchEnabled(false);

    self._ticket = Label:create();
    self._ticket_bg:addChild(self._ticket);
    self._ticket:setPosition(ccp(0, 0));
    self._ticket:setFontSize(24);
    self._ticket:setText("99999999");

    --十连
    self._select_btn = ImageView:create()
    self._bg:addChild(self._select_btn);
    self._select_btn:loadTexture("frame/image/lucency.png");
    self._select_btn:setScale9Enabled(true);
    self._select_btn:setSize(CCSizeMake(150,30) );
    self._select_btn:setPosition(ccp(210,-228));
    self._select_btn:setTouchEnabled(true);
    self._select_btn:addTouchEventListener(function(sender, touchType) self:on_btn_select_box(sender, touchType) end);

    self._select_box = frame_tools:get_a_btn();
    self._bg:addChild(self._select_box);
    self._select_box:setPosition(ccp(150,-228));
    self._select_box:loadTextures("frame_userinfo_btn_selectbox.png","frame_userinfo_btn_selectbox.png","frame_userinfo_btn_selectbox.png",1);
    self._select_box:addTouchEventListener(function(sender, touchType) self:on_btn_select_box(sender, touchType) end);
    self._select_box:setTouchEnabled(false);

    self._select = ImageView:create();
    self._select_box:addChild(self._select);
    self._select:setPosition(ccp(0,0));
    self._select:loadTexture("frame_userinfo_btn_select.png", 1);
    self._select:setVisible(false);

    self._select_label = Label:create();
    self._select_box:addChild(self._select_label);
    self._select_label:setFontSize(22);
    self._select_label:setAnchorPoint(ccp(0,0.5));
    self._select_label:setPosition(ccp(20,0));
    self._select_label:setText("10连发(5折)");


    self.m_update_user_data_listen_id = frame_tools:add_event_listen("update_user_data", function(user_data) 
        if self == nil or self.update_user_data == nil then return; end
        self:update_user_data(user_data) 
        end 
    );
end

function frame_user_info_other:destroy()
    frame_tools:delete_event_listen("update_user_data", self.m_update_user_data_listen_id);    
end

function frame_user_info_other:update_user_data(user_data)
    if user_data == nil then return; end
    if self.m_userid ~= user_data.user_id then return; end

    self:set_user_data(user_data);
end

function frame_user_info_other:set_user_data(user_data)
    if user_data == nil then return;end

    self.m_userid = user_data.user_id or 0;
    self.m_face_id = user_data.face_id or 0;
    self.m_vip = user_data.member or 0;
    self.m_str_name = user_data.nickname or "";
    self.m_gold = user_data.gold or 0;
    self.m_score = user_data.socre or 0;
    self.m_win_count = user_data.win_count or 0;
    self.m_lose_count = user_data.lose_count or 0;
    self.m_draw_count = user_data.draw_count or 0;
    self.m_like = user_data.praise or 0;
    self.m_charm = user_data.charm or 0;
    self.m_sex = user_data.sex or 0;
    self.m_chair_id = user_data.chair_id or -1;

    local level_data = frame_tools:get_score_level(self.m_score);
    if level_data ~= nil and level_data.name ~= nil then
        self.m_level_name = level_data.name;
    end
    
    self:load_prop_info();
    self:refresh_user_data();
    self:refresh_user_prop();
end

function frame_user_info_other:load_prop_info()
     --踢人卡
    self.m_ti_card = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.kick_ticket) or 0;
    self.m_gift_card = frame_tools:get_prop_count_by_id(FRAME_USER_PROP_ID.gift_card) or 0;

--    print(self.m_gift_card);

    self.m_prop_count = {};
    for i = FRAME_USER_PROP_ID.egg, FRAME_USER_PROP_ID.thumb do
        local count = frame_tools:get_prop_count_by_id(i);
        table.insert(self.m_prop_count,count);
    end
end

function frame_user_info_other:refresh_user_prop()
    if bit._and(frame_tools:get_module_mask(), FRAME_MASK_MODULE.MASK_MODULE_SHOP) <= 0 then
        if self.m_ti_card <= 0 then
            self._btn_ti:setVisible(false);
        end
        if self.m_gift_card <= 0 then
            self._ticket_add:setVisible(false);
            self._ticket_bg:setTouchEnabled(false);
        end
    end
            
    self._ticket:setText(self.m_gift_card);

    
    for i=1,self.m_gift_count do
        if self.m_prop_count[i] > 0 then
            local gift_card_cost = math.abs(self.m_gift_info[i]);
            if gift_card_cost > 0 then gift_card_cost = 1;end
            self._gifts[i]:set_gold(FRAME_USER_PROP_ID.egg + i - 1, gift_card_cost);
        else
            local gift_gold = math.abs(self.m_gift_info[i]*1000)or 0;
            local gift_card_cost = math.abs(self.m_gift_info[i]);
            if self.m_gift_card >= gift_card_cost then
                self._gifts[i]:set_gold(1, gift_card_cost);
            else    
                self._gifts[i]:set_gold(2, gift_gold);
            end
        end
    end
    
end

function frame_user_info_other:refresh_user_data()
        --设置性别
    if self.m_sex == 1 then
        self._sex:loadTexture("frame_userinfo_man.png", 1);
    else   
        self._sex:loadTexture("frame_userinfo_woman.png", 1);
    end
    --计算胜率（去除小数点）
    local game_count = self.m_win_count + self.m_lose_count + self.m_draw_count;
    local win_rate = 0;
    if game_count > 0 then
        win_rate = (self.m_win_count / game_count) * 100;
        win_rate = win_rate - (win_rate % 1);
    end
    --设置VIP
    self:set_vip(self.m_vip);
    --头像
    self._head:set_head(76, 76, self.m_userid, self.m_face_id, self.m_sex)
    --金币
    self._gold:setText(tostring(self.m_gold) );
    --积分
    if self.m_level_name == "" or self.m_level_name == nil then
        self._score:setText("积分:"..tostring(self.m_score));
    else
        self._score:setText("积分:"..tostring(self.m_score).."("..self.m_level_name..")" );
    end
    --昵称
    self._name:setTextEx(self.m_str_name, 230);
    --战绩
    self._record:setText("战绩:"..self.m_win_count.."胜/"..self.m_lose_count.."平/"..self.m_draw_count.."负");
    --胜率
    self._win_rate:setText("胜率:"..tostring(win_rate).."%")
    --魅力
    if self.m_charm >= 10000 then
        self._charm:setText(string.format("%.1f", self.m_charm/1000).."K");
    elseif self.m_charm >= 1000  then
        self._charm:setText(string.format("%.2f", self.m_charm/1000).."K");
    else
        self._charm:setText(tostring(self.m_charm));
    end

    --点赞
    if self.m_like >= 10000 then
        self._like:setText(string.format("%.1f", self.m_like/1000).."K");
    elseif self.m_like >= 1000  then
        self._like:setText(string.format("%.2f", self.m_like/1000).."K");
    else
        self._like:setText(tostring(self.m_like));
    end
end

function frame_user_info_other:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_user_info_other:on_btn_ti(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.m_ti_card > 0 then
        local send_data = {};
        send_data.userid = frame_tools:get_self_user_id();
        send_data.touserid = self.m_userid;

        frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_KICKOUT, send_data);
    else
        frame_tools:open_hint_win( {
            str_con = "您当前没有踢人卡，是否立即购买？", 
            type = 1,
            str_left = "立即购买", 
            str_right = "稍后再说", 
            callback_left = function() frame_tools:open_shop(2); end,
            callback_right = nil, 
        } );
    end
end

function frame_user_info_other:on_btn_report(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

--    self._bg:setVisible(false);

--    if self._report_win == nil then
--        self._report_win = frame_report_win_single:new();
--        self:addChild(self._report_win);
--        self._report_win:init();
--    end 
--    self._report_win:clear();
--    self._report_win:set_name(self.m_str_name);
--    self._report_win:set_userid(self.m_userid);
--    self._report_win:setVisible(true);

    frame_tools:open_single_report_win(self.m_userid, self.m_str_name);

    self:show_window(false);
end

function frame_user_info_other:on_btn_add_ticket(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if Frame_Prop_OEM_Id.gift_card == nil or Frame_Prop_OEM_Id.gift_card == 0 then
        frame_tools:open_shop(2)
    else
        frame_tools:buy(Frame_Prop_OEM_Id.gift_card)
    end
end

function frame_user_info_other:on_btn_gift(sender, touchType, gift_id, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
--    frame_tools:playEffect("frame/sound/click.mp3");

--    print("on_btn_gift:",gift_id," ",index);

    local gift_data = {};
    gift_data.to_chair_id = self.m_chair_id;
    gift_data.from_chair_id = frame_tools:get_self_chair_id();
    gift_data.to = self.m_userid;
    gift_data.from = frame_tools:get_self_user_id();
    gift_data.gift_id = index - 1 + FRAME_USER_PROP_ID.egg;

    if self.m_shilian == 1 then
        gift_data.count = 10;
    else    
        gift_data.count = 1;
    end 

    frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_GIFT, gift_data);

    self:show_window(false);
end

function frame_user_info_other:on_btn_like(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

--    print("on_btn_like");

    local send_data = {};
    send_data.userid = frame_tools:get_self_user_id();
    send_data.touserid = self.m_userid;

    frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_PRAISE, send_data);
end

function frame_user_info_other:on_btn_select_box(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");
--    print("on_btn_select_box");

    if self.m_shilian == 0 then
        self.m_shilian = 1;
        self._select:setVisible(true);
    else    
        self.m_shilian = 0;
        self._select:setVisible(false);
    end
end

function frame_user_info_other:get_shilian()
    return self.m_shilian;
end

function frame_user_info_other:set_shilian(shilian)
    if shilian == 0 then
        self.m_shilian = 0;
        self._select:setVisible(false);
    else
        self.m_shilian = 1;
        self._select:setVisible(true);
    end
end

function frame_user_info_other:set_vip(vip_level)
    if vip_level == 0 then
        self._vip:setVisible(false);
        return;
    end

    self._vip:loadTexture("frame_userinfo_vip"..vip_level..".png",1);
    self._vip_label:setText("贵族"..vip_level);
end

function frame_user_info_other:use_prop(prop_id)   
   
end

function frame_user_info_other:__update()
    if self:isVisible() == false then return; end

    self:load_prop_info();
    self:refresh_user_prop();
end


--------------------------------------------------------------------------------------
frame_userinfo_gift_item = class("frame_userinfo_gift_item", function() return Button:create() end );

function frame_userinfo_gift_item:ctor()
    self.m_gift_id = 1011
end

function frame_userinfo_gift_item:init(callback)
    self.callback = callback;

    self:loadTextures("frame_userinfo_gift_bg.png","frame_userinfo_gift_bg.png","frame_userinfo_gift_bg.png",1);
    self:addTouchEventListener(function(sender, touchType) self:on_btn_gift(sender, touchType) end);
    --gift
    self._gift = ImageView:create();
    self:addChild(self._gift);
    self._gift:setPosition(ccp(0,10));
    self._gift:loadTexture("frame_userinfo_prop_1011.png",1);
    self._gift:setScale(0.7);

    --魅力
    self._charm_bg = ImageView:create();
    self:addChild(self._charm_bg);
    self._charm_bg:setPosition(ccp(30,40));
    self._charm_bg:loadTexture("frame_userinfo_charm_bg.png",1);

    self._charm_img = ImageView:create();
    self._charm_bg:addChild(self._charm_img);
    self._charm_img:setPosition(ccp(-10, 0));
    self._charm_img:loadTexture("frame_userinfo_charm.png",1);
    self._charm_img:setScale(0.4);

    self._charm = Label:create();
    self._charm_bg:addChild(self._charm);
    self._charm:setPosition(ccp(10, 0));
    self._charm:setFontSize(18);
    self._charm:setText("-1");

    --金币
    self._gold_img = ImageView:create();
    self:addChild(self._gold_img);
    self._gold_img:setPosition(ccp(-35, -32));
    self._gold_img:loadTexture("frame_userinfo_gift_gold.png",1);
    self._gold_img:setScale(0.6);

    self._gold = Label:create();
    self:addChild(self._gold);
    self._gold:setPosition(ccp(5, -32));
    self._gold:setFontSize(20);
    self._gold:setColor(ccc3(123,56,38));
    self._gold:setText("1000");
end

function frame_userinfo_gift_item:on_btn_gift(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    
    if self.callback then
        self.callback(sender, touchType, self.m_gift_id);
    end

    frame_tools:playEffect("frame/sound/click.mp3");
end

function frame_userinfo_gift_item:set_gift_id(gift_id)
    if gift_id < 1011 or gift_id > 1015 then
        return
    end
    self.m_gift_id = gift_id;

    self._gift:loadTexture("frame_userinfo_prop_"..self.m_gift_id..".png",1);
end

--function frame_userinfo_gift_item:set_charm(charm)
--    self._charm:setText(tostring(charm));
--end

function frame_userinfo_gift_item:set_gold(type_id, count)
    if count == 0 then 
        self._gold:setText("免费");
        self._gold_img:setVisible(false);
        self._gold:setPosition(ccp(0, -32));
    else
        if type_id == 1 then
            self._gold_img:loadTexture("frame_userinfo_ticket.png",1);
            self._gold_img:setScale(0.6);
        elseif type_id == 2 then 
            self._gold_img:loadTexture("frame_userinfo_gift_gold.png",1);
            self._gold_img:setScale(0.6);
        else
            self._gold_img:loadTexture("../5000/prop_"..type_id..".png");
            self._gold_img:setScale(0.3);
        end
--        local width = self._gold_img:getSize().width;
--        self._gold_img:setScale(26/width);

        self._gold_img:setVisible(true);
        self._gold:setPosition(ccp(5, -32));
        self._gold:setText(tostring(count));
    end
end

function frame_userinfo_gift_item:set_charm(charm)
    if charm >= 0 then
        self._charm:setText("+"..tostring(charm));
    else
        self._charm:setText(tostring(charm));
    end
end

--endregion
