require "frame/src/frame"

function init(layer)
    local visibleSize = CCDirector:sharedDirector():getWinSize()
    -- 初始化游戏界面
    -- 初始化游戏界面
    m_frame_layer = frame_layer:new();
    m_frame_layer:init(layer, visibleSize)
end
--玩家进入
function on_game_user_enter(userid, chairid, look)
    m_frame_layer:on_game_user_enter(userid, chairid, look);
end
--玩家离开
function on_game_user_left(userid, chairid, look)
    m_frame_layer:on_game_user_left(userid, chairid, look);
end

function destroy()
    m_frame_layer:destroy();
    return
end
--游戏消息接收
function on_game_message(id, data)
    m_frame_layer:on_game_message(id, data);
end

function on_game_scene_message(status, look, data)
	m_frame_layer:on_game_scene_message(status, look, data);
end

function on_game_user_chat(userid, chairid, chat)

end

function on_system_message(kind, chat)
    m_frame_layer:on_system_message(kind, chat);
end

--获取玩家状态
function on_game_user_status(userid, chairid, look, offline)
    m_frame_layer:on_game_user_status(userid, chairid, look);
end

function on_game_user_data(userid, chairid, look)
	m_frame_layer:on_game_user_data(userid, chairid, look);
end

function on_game_user_score(userid, chairid, look)
    m_frame_layer:on_game_user_score(userid, chairid, look);
end

function on_click_back()
     m_frame_layer:on_click_back();
end

function on_click_menu()
	m_frame_layer:on_click_menu();
end

function on_push_data(param_id, param_data)
    m_frame_layer:on_push_data(param_id, param_data);
end

function on_tip_data(param_id, bool_show)
    m_frame_layer:on_tip_data(param_id, bool_show)
end

function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    print(debug.traceback())
    print("----------------------------------------")

    if write_online_logs then
        write_online_logs(tostring(msg));
    end
    if frame_tools then
        frame_tools:add_test_win_text(tostring(msg))
        frame_tools:add_test_win_text(debug.traceback())
    end
end

function main()
    print("main")
    collectgarbage("collect")
    collectgarbage("setpause", 100) 
    collectgarbage("setstepmul", 5000)
end
xpcall(main, __G__TRACKBACK__)