-- 常量定义，检查以下常量是否在原本游戏中有定义，如果有并且值相同，可以删掉或不管，如果有并且值不同，要用这里的值
LayoutFrameworkVersion=1.16

--配置序号
LayoutIndex={
    heap_bottm = 1, heap_left = 2,  heap_right = 3, heap_top = 4,
    hua_bottm = 5,  hua_left = 6,   hua_right = 7,  hua_top = 8,
    out_bottm = 9,  out_left = 10,  out_right = 11, out_top = 12,
    show_bottm = 13,show_left = 14, show_right = 15,show_top = 16,
    wall_bottm = 17,wall_left = 18, wall_right = 19,wall_top = 20,
}

--默认牌值
InvalidValue = 0

--操作类型
HandleType={
    null=0,         -- no use
    pass=1,         -- no use
    jiang=2,        -- no use
    b_chi_left=3,   -- 左吃
    b_chi_mid=4,    -- 中吃
    b_chi_right=5,  -- 右吃
    b_peng=6,       -- 碰
    b_gang=7,       -- 明杠 自己有三张，别人打出来的杠
    d_chi=8,        -- no use
    d_peng=9,       -- no use
    d_gang=10,      -- 暗杠 自己有四张的杠
    a_gang=11,      -- 补杠 自己碰过的牌，又摸到一张一样的杠
    hu=12,          -- 胡
    ting=13,		   --听
}

--层级
LayoutZOrder={
    LastOutCardIndicator=1900,
    HandleSelect=2000,
    HandleAni=3000,
    Topest=9999,
}

--用户配置
UserIndex={
    left=1,down=2,right=3,up=4
}

--桌面风位
TableFeng={
    none=0, east=1, north=2, west=3, south=4
}

--牌堆序号
LayoutCardsType={
    hand=1,heap=2,out=3,hua=4
}

-- 操作序号

HandleButtonIndex={
    Chi=1,
    Peng=2,
    Gang=3,
    Hu=4,
    Ting=5,
    Pass=6
}

DarkGangConfig={
    Value = 1,
    Back = 2,
}

--牌面替换
CardExchangeTable={}

--资源路径
Layout3DPath="layout3d/"
Layout3DpListPath="layout3d/plist/"
Layout3DTablePath="layout3d/table/"
Layout3DAnimationPath="layout3d/animation/"
Layout3DFontPath="layout3d/fnt/"

LayoutConfig={
    log_enable = false,                     -- 是否启用log
    print_enable = false,                   -- 是否启用实时输出
    show_card_value_on_dark_gang = true,    -- 暗杠的第四张牌是否可见
    show_heap_arrow = true,                -- 是否显示吃碰杠堆的指向箭头
    tile_hua_card = true,                  -- 是否堆叠花牌
    play_insert_card = true,                -- 是否播放插入自己手牌的动画
    custom_self_handcard_scale = 1.0,       -- 单款可调自己手牌缩放
    show_self_dark_gang_card_value = true,  -- 自己暗杠的第四张牌是否永远可见
    auto_hide_handle_select = true,         -- 吃碰杠按钮点击完后是否自动隐藏
    show_chi_hint_mask = true,              -- 多吃选择窗口，是否显示被吃牌遮罩
}

