--region button_event_majiang.lua
--Author : Bookse
--Date   : 2017/3/28
--此文件由[BabeLua]插件自动生成

--------------------------------------------------------------------------------
-- button
--------------------------------------------------------------------------------
button_event = class("button_event")

function button_event.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, button_event)
	return target
end

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
button_event.tag = 0

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function on_btn_changetable()
	if frame_tools:get_game_status() ~= GameStatus.free then
		return
	end
	--[[好友场的再来一局
	if ROOM_MODE==ROOM_MODE_FRIEND then
		UIHelper.clear_data()
		on_btn_ready(2)
		return
	end ]]

    if frame_tools:is_short_of_gold() == true then
        return;
    end

	-- 金币检查
--	local c = require("cjson")
--	local tbl_json = frame_tools:get_room_data()
--	if bit._and(ROOM_KIND,ROOM_KIND_SCORE)<=0 then
--        local c = require "cjson"
--        local user_json = frame_tools:get_self_user_data()
--        if user_json ~= nil then
--		    if user_json.gold <= 0 then
--			    frame_tools:open_broke_win();
--                return;
--		    end
--
--		    -- 房间下限金币检查
--		    if tbl_json == nil then
--			    return
--		    end
--
--		    if bit._and(tbl_json.limit_mask, RoomLimit.gold_min) ~= 0 then
--			    if user_json.gold < tbl_json.min_gold then 
--				    frame_tools:open_broke_win();
--                    return;
--			    end
--		    end
--        end
--
--	end

	frame_tools:re_sit_down()
end

function on_btn_ready(tag)
	if frame_tools:get_game_status() ~= GameStatus.free then
		return
	end

    if frame_tools:is_short_of_gold() == true then
        return;
    end

	-- 金币检查
--	if bit._and(ROOM_KIND,ROOM_KIND_SCORE)<=0 then
--        local c = require "cjson"
--        local user_json = frame_tools:get_self_user_data()
--        if user_json ~= nil then
--            if user_json.gold == 0 then
--                frame_tools:open_broke_win();
--                return;
--		    end
--
--		    -- 房间下限金币检查
--		    local c = require("cjson")
--		    local tbl_json = frame_tools:get_room_data()
--		    if tbl_json == nil then
--			    return
--		    end
--
--		    if bit._and(tbl_json.limit_mask, RoomLimit.gold_min) ~= 0 then
--			    if user_json.gold < tbl_json.min_gold then 
--				    frame_tools:open_broke_win();
--                    return;
--			    end
--		    end
--        end	
--	end

    if ROOM_MODE ~= ROOM_MODE_FRIEND then
        game_layer.ptr_btn_start:setBright(false);
        game_layer.ptr_btn_start:setTouchEnabled(false);
        game_layer.ptr_btn_start:setVisible(true);
        game_layer.ptr_btn_changetable:setVisible(true);
        game_layer.table_id_bg:setVisible(false);
    end

   if tag == 1 then
    	do_ready_game()
    else
    	frame_tools:send_ready_data()
        audio_engine.ready_effect()	
	    game_layer.ptr_btn_start:setBright(false)
	    game_layer.ptr_btn_start:setTouchEnabled(false)
    end

    for i=1,GAME_PLAYER,1 do
        game_layer.int_hand_card_count[i]=0;
    end
    
    game_layer.client_out_card=0
    game_layer.finish_layer:hide_layer();

    cards_3d_layout:reset();
    cards_3d_layout:setHandCardsCanTouch(true);

    game_layer.left_card_bg:setVisible(false);

    if game_layer.play_liuju then
        game_layer.play_liuju(false);
    end

    game_layer.caishen_bg:setVisible(false);
    game_layer.caishen_img:setVisible(false);
    game_layer.friends_base_label:setVisible(false);
    game_layer.btn_finish_layer:setVisible(false);
    game_layer.int_hu_view = -1;
    game_layer.game_user:reset();
    game_layer.ready_lock:set_ready_clock(-1);
--    game_layer.ting_hint_layer:setVisible(false);
    table_3d_layout:showTime(false)

    for i=1,39 do
        game_layer.table_remain_card_count[i]=4;
    end

    game_layer.int_game_status = GameStatus.free;
end

function on_btn_return_ok()
	audio_engine.endBackground()
	audio_engine.stopAllEffects()
--	game_layer.timer_bg:unscheduleUpdate()
	frame_tools:close_game()
end

function on_btn_return_cancel()
end 

function on_btn_return()
--	if frame_tools:get_game_status() == GameStatus.free then
--		on_btn_return_ok()
--	else
--		game_layer.back_layer:show_back_layer()
--	end

    if frame_tools:get_game_status() == GameStatus.free then
		frame_tools:open_exit_win();
	else
        frame_tools:open_hint_win( {
        str_con = "当前正在游戏中，是否返回大厅？", 
        type = 1,
        str_left = "确定", 
        str_right = "取消", 
        callback_left = function() on_btn_return_ok() end,
        callback_right = nil, 
        } );
	end
end

function on_btn_menu()
	game_layer.menu_bar:show_right_bar()
end

function on_btn_config()
--    show_setting(0)
    frame_tools:open_config_win(1);
end

function on_btn_chat()
--[[    if game_layer.touch_enable == false then
        frame_tools:show_hinting("请等待游戏开始后进行操作");
        return;
    end ]]

--	show_game_chat()

    frame_tools:open_chat_win(2);
end

function on_btn_voice(tag)
--	game_talk(tag)

    if open_gvoice then		
		if game_layer.voice_status ~= 2 then
			open_gvoice(1)	-- 打开
		elseif game_layer.voice_status ~= 3 then
			open_gvoice(0)	-- 关闭
		end
	end
end

function on_btn_voice_1(tag)
	game_talk(tag)
end

function on_btn_dissolve()

end

function on_btn_help()
    game_layer.help_layer:show_layer()
end

function on_btn_copy()
	copy_to_pasteboard("我在福州麻将".. game_layer.friend_info.code .."，等你来战！");
	frame_tools:show_hinting(tostring("已成功复制到剪贴板"))
end

function on_btn_invite()
	frame_tools:share_private_wechat("福州麻将-房间号[".. game_layer.friend_info.code.."]", "房间模式:4人局;点击加入游戏！", tostring(game_layer.friend_info.code))
end

function on_btn_grade()
    game_layer.tips_bg:setVisible(false)
    
    if game_layer.friend_info.currcount > 0  then
        if show_game_grade then
            local table_data={};
            table_data.room_code = game_layer.friend_info.code;
            table_data.grade_list = game_layer.grade_list;
		    show_game_grade(game_tools.encode(table_data))
	    end
    end
end

function on_btn_no_trust()
    frame_tools:send_data(MessageType.SUB_C_NO_TRUST, "");
end

function on_btn_game_rule()
    local game_rule_type = type(show_game_rule);
    if game_rule_type == "function" then
        show_game_rule();
        return
    end     

--    game_layer.game_rule_bg:setVisible(not game_layer.game_rule_bg:isVisible())
end

function on_btn_ting(args)
    if args == _G.TOUCH_EVENT_BEGAN then
        game_layer.ting_hint_layer:setVisible(true);
    elseif args == _G.TOUCH_EVENT_ENDED then
        game_layer.ting_hint_layer:setVisible(false);
    elseif args == _G.TOUCH_EVENT_CANCELED then
        game_layer.ting_hint_layer:setVisible(false);
    end
end

function on_btn_finish_layer(args)
    local isting = game_layer.finish_layer:isVisible();
    game_layer.finish_layer:setVisible(not isting);
end

function on_btn_gift(gift_id, int_num)
	local c = require "cjson"
    local table_json = frame_tools:get_user_data_by_user_id(game_layer.gift_show_user_id);
    local self_json = frame_tools:get_self_user_data()
    if table_json == nil then
    	return 
    end

    if table_json.user_id == self_json.user_id then
		frame_tools:show_hinting(tostring("该表情只能对他人使用"))
		return 
	end

	local tbl = {}
	tbl.gift_id = gift_id
	tbl.from_chair_id = self_json.chair_id
	tbl.to_chair_id = table_json.chair_id
	tbl.from_user_id = self_json.user_id
	tbl.to_user_id = table_json.user_id
	tbl.int_num = int_num

	frame_tools:send_data(MessageType.SUB_C_SEND_GIFT, tbl)
end

local function touchEvent(sender, eventType)
--    game_layer.card_layer.big_card_bg:setVisible(false);
    if sender.tag == ButtonEventType.btn_ting_layer then
        on_btn_ting(eventType)
    end
	if eventType == _G.TOUCH_EVENT_BEGAN then
        if sender.tag < ButtonEventType.btn_chi or sender.tag > ButtonEventType.btn_cancel then
	    	audio_engine.playEffect(-1)
        end
		if sender.tag == ButtonEventType.btn_voice_1 then
	        on_btn_voice_1(Touch.began)
	    end
	elseif eventType == _G.TOUCH_EVENT_MOVED then
		if sender.tag == ButtonEventType.btn_voice_1 then
			local move_pos = sender:getTouchMovePos()
			if sender:hitTest(move_pos) == false then
	        	on_btn_voice_1(Touch.moved)
	        end
	    end
	elseif eventType == _G.TOUCH_EVENT_ENDED then
		if sender.tag == ButtonEventType.grade then
			on_btn_grade()
		elseif sender.tag == ButtonEventType.ready then
			on_btn_ready(2)
        elseif sender.tag == ButtonEventType.btn_return then
			on_btn_return()
        elseif sender.tag == ButtonEventType.btn_menu then
			on_btn_menu()
        elseif sender.tag == ButtonEventType.btn_config then
	        on_btn_config()
        elseif sender.tag == ButtonEventType.btn_chat then
			on_btn_chat()
        elseif sender.tag == ButtonEventType.btn_voice then
	        on_btn_voice(Touch.ended)
        elseif sender.tag == ButtonEventType.btn_voice_1 then
	        on_btn_voice_1(Touch.ended)
        elseif sender.tag == ButtonEventType.btn_continue then
	        on_btn_ready(2)
        elseif sender.tag == ButtonEventType.btn_dissolve then
	        on_btn_dissolve()
        elseif sender.tag == ButtonEventType.btn_copy then
	        on_btn_copy()
        elseif sender.tag == ButtonEventType.btn_invite then
	        on_btn_invite()
        elseif sender.tag == ButtonEventType.btn_grade then
	        on_btn_grade()
        elseif sender.tag == ButtonEventType.btn_changetable then
            on_btn_changetable()
        elseif sender.tag == ButtonEventType.btn_out then
	        on_btn_return()
        elseif sender.tag == ButtonEventType.btn_no_trust then
	        on_btn_no_trust()
        elseif sender.tag == ButtonEventType.btn_game_rule then
            on_btn_game_rule();
        elseif sender.tag == ButtonEventType.btn_menu_dissolve then
            on_btn_dissolve()
        elseif sender.tag == ButtonEventType.btn_help then
            on_btn_help()
        elseif sender.tag == ButtonEventType.btn_finish_layer then
            on_btn_finish_layer()
        end
	elseif eventType == _G.TOUCH_EVENT_CANCELED then
		if sender.tag == ButtonEventType.btn_voice then
	        on_btn_voice_1(Touch.canceled)
	    end
	end
end

-- 初始化button
function button_event:init(ButtonName, ButtonType)
	if ButtonName == ButtonEventName.ready then
        self:loadTextureNormal("btn_ready.png",1)
        self:loadTextureDisabled("btn_already.png",1)
    elseif ButtonName == ButtonEventName.grade then
        self:loadTextureNormal("left_count_bg.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_return then
        self:loadTextureNormal("btn_return.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_menu then
        self:loadTextureNormal("img_open.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_config then
	    self:loadTextureNormal("btn_config.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_chat then
        self:loadTextureNormal("btn_chat.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_voice then
	    self:loadTextureNormal("btn_voice.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_voice_1 then
	    self:loadTextureNormal("btn_voice_1.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_continue then
	    self:loadTextureNormal("btn_again.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_dissolve then
	    self:loadTextureNormal("btn_dissolve.png",1)
    elseif ButtonName == ButtonEventName.btn_copy then
	    self:loadTextureNormal("btn_copy.png",1)
    elseif ButtonName == ButtonEventName.btn_invite then
	    self:loadTextureNormal("btn_invite.png",1)
    elseif ButtonName == ButtonEventName.btn_grade then
	    self:loadTextureNormal("btn_grade.png",1)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_changetable then
	    self:loadTextureNormal("btn_changetable.png",1)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_out then
	    self:loadTextureNormal("btn_out.png",1)
    elseif ButtonName == ButtonEventName.btn_no_trust then
	    self:loadTextureNormal("btn_no_trust.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_game_rule then
	    self:loadTextureNormal("btn_rule.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_menu_dissolve then
	    self:loadTextureNormal("btn_menu_dissolve.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_help then
        self:loadTextureNormal("btn_rule.png",1)
        self:setVisible(true)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_ting_layer then
        self:loadTextureNormal("btn_ting.png",1)
        self:setTouchEnabled(true)
    elseif ButtonName == ButtonEventName.btn_finish_layer then
        self:loadTextureNormal("btn_sgrade.png",1)
        self:setTouchEnabled(true)
    end
end

-- 创建button
function button_event:create(ButtonName, ButtonType)
	local button = button_event.extend(UIButtonExSmall:create())
	button:setTouchEnabled(false)
	button:setVisible(false)
	button:init(ButtonName, ButtonType)
	button.tag = ButtonType
	button:addTouchEventListener(touchEvent)

	return button
end
--endregion
