--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--------------------------------------------------------------------------------
-- 结算界面
--------------------------------------------------------------------------------
finish_layer = class("finish_layer",function() return frame_finish_base:new() end)

function finish_layer:ctor()
    
end
--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
finish_layer.table_fan_bg={}
finish_layer.table_fan_label={}
finish_layer.img_hu_type={}

finish_layer.table_user_item={}

finish_layer.animation = nil;
finish_layer.animation1 = nil;

finish_layer.table_hand_cards = {}
finish_layer.table_heap_cards = {}
finish_layer.table_free_cards = {}

finish_layer.btn_changetable = nil
finish_layer.btn_continue = nil
finish_layer.end_clock = nil;

finish_layer.card_scale = 0.6
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function finish_layer:init(visibleSize)  
    --遮罩
--    self.img_bg = ImageView:create();
--    self.img_bg:loadTexture("bg_black.png",1);
--    self.img_bg:setAnchorPoint(ccp(0,0));
--    self.img_bg:setScale9Enabled(true);
--    self.img_bg:setSize(visibleSize);
--    self.img_bg:setTouchEnabled(true);
--    self:addChild(self.img_bg);

    local function touchEvent(sender, eventType)
        self:touch_event(sender, eventType)
    end
    self.__back:addTouchEventListener(touchEvent)
    --背景
    self.back_ground = UIHelper.create_img(self, ccp(0, 0 + 10), "resources/result_bg.png")
    self.back_ground:setTouchEnabled(true);

    --番数
    for i=1,6,1 do
        local img_fan = UIHelper.create_img(self.back_ground,ccp(260,32 - i*35),"fan"..i..".png",1);
        table.insert(self.table_fan_bg,img_fan);
        local label_fan = UIHelper.create_labelBM(img_fan, "resources/number_gold/number_fuzhoumajiang_fan.fnt",ccp(10,-3));
        table.insert(self.table_fan_label,label_fan);
    end

    --玩家信息
    for i=1,GAME_PLAYER,1 do
        local user_item = CUserInfoItem:create(visibleSize);
        user_item:setPosition(ccp(-95,67 - i*60));
        self.back_ground:addChild(user_item);
        user_item:setZOrder(200);
        table.insert(self.table_user_item, user_item);
    end
    
    --胡牌牌型
    self.img_hu_type = UIHelper.create_img(self.back_ground, ccp(250,50), "hutype10.png",1);
    self.img_hu_type:setZOrder(10000);
    self:set_hu_type(0);
    
    --手牌

    --按钮
    self.btn_changetable = button_event:create(ButtonEventName.btn_changetable,ButtonEventType.btn_changetable);
    self.btn_changetable:setPosition(ccp( - 150,  - 260));
    self:addChild(self.btn_changetable);
    self.btn_changetable:loadTextureNormal("btn_changetable2.png",1);
    self.btn_changetable:setVisible(true);

    self.btn_continue = button_event:create(ButtonEventName.btn_continue,ButtonEventType.btn_continue);
    self.btn_continue:setPosition(ccp(  150,  - 260));
    self:addChild(self.btn_continue);

    self.btn_again = button_event:create(ButtonEventName.btn_continue,ButtonEventType.btn_continue);
    self.btn_again:setPosition(ccp(0,  - 260));
    self:addChild(self.btn_again);
    self.btn_again:setVisible(false);

    self.btn_grade = button_event:create(ButtonEventName.btn_grade,ButtonEventType.btn_grade);
    self.btn_grade:setPosition(ccp(0,  - 260));
    self:addChild(self.btn_grade);
    self.btn_grade:setVisible(false);
    --返回按钮
    self.btn_back = UIButtonExSmall:create();
    self.btn_back:loadTextureNormal("btn_back.png",1);
    self.btn_back:setPosition(ccp(45 + game_layer.screenGap - visibleSize.width/2, visibleSize.height/2 - 45));
    self:addChild(self.btn_back);
    self.btn_back:addTouchEventListener(function(sender, eventType) if eventType == _G.TOUCH_EVENT_ENDED then  on_btn_return();end end);

    --计时器
    self.end_clock = ready_clock:create();
    self.end_clock:setPosition(ccp(0, - 260));
    self:addChild(self.end_clock);
    self.end_clock:setVisible(false);

    --
    self.label_consume = UIHelper.create_label(self,ccp(visibleSize.width/2 - 10 - game_layer.screenGap, 5 - visibleSize.height/2),26);
    self.label_consume:setAnchorPoint(ccp(1,0));
    self.label_consume:setText("服务费:0");

    --
    self.label_base = UIHelper.create_label(self,ccp(visibleSize.width/2 - 10 - game_layer.screenGap, 35 - visibleSize.height/2),26);
    self.label_base:setAnchorPoint(ccp(1,0));
    self.label_base:setText("底分:0");

    --
    self.labelHint = UIHelper.create_label(self,ccp(0, 5 - visibleSize.height/2),24);
    self.labelHint:setAnchorPoint(ccp(0.5,0));
    self.labelHint:setText("按住任意阴影位置可查看牌局信息");

    --动画
    self.animation = CCArmature:create("mj_fuzhoumajiang_jiesuan")
    if not self.animation then
        return;
    end
    self.animation:setPosition(ccp(0, 190 ))
    self.back_ground:addNode(self.animation);
    self.animation:getAnimation():playWithIndex(0,-1,-1,0);
    self.animation:setVisible(false);

    self.animation1 = CCArmature:create("mj_fuzhoumajiang_jiesuan")
    self.animation1:setPosition(ccp(0, 190))
    self.back_ground:addNode(self.animation1);
    self.animation1:getAnimation():playWithIndex(1,-1,-1,1);
    self.animation1:setVisible(false);

    self.task_win = self:get_task_win();
    self.task_win:setScale(0.85);
    self.task_win:setPosition(ccp(frame_tools:get_screen_gap() + 170*0.85 - visibleSize.width/2, 0));
end

function finish_layer:set_window_type(type)
    if type == nil then
        return;
    elseif type == 0 then
        self.btn_changetable:setVisible(true);
        self.btn_continue:setVisible(true);
        self.btn_again:setVisible(false);
        self.btn_grade:setVisible(false);
    elseif type == 1 then
        self.btn_changetable:setVisible(false);
        self.btn_continue:setVisible(false);
        self.btn_again:setVisible(true);
        self.btn_grade:setVisible(false);
    elseif type == 2 then
        self.btn_changetable:setVisible(false);
        self.btn_continue:setVisible(false);
        self.btn_again:setVisible(false);
        self.btn_grade:setVisible(true);
    end
end

function finish_layer:play_animation(type)
--    self:show_window(true);
    self:setVisible(true);
    if ROOM_MODE ~= ROOM_MODE_FRIEND then
        self:show_task_win();
    end

    if ROOM_MODE ~= ROOM_MODE_FRIEND then
        if game_layer.ready_time then
            self.end_clock:set_ready_clock(game_layer.ready_time);
        else
            self.end_clock:set_ready_clock(10,false);
        end
    end

    if not self.animation then
        return;
    end
    self.animation1:setVisible(false);
    if type == ResultKind.RESULT_KIND_WIN then
        self.animation1:setVisible(true);
        self.animation:getAnimation():playWithIndex(0,-1,-1,0);
    elseif type == ResultKind.RESULT_KIND_LOST then
        self.animation:getAnimation():playWithIndex(2,-1,-1,0);
    elseif type == ResultKind.RESULT_KIND_DRAW then
        self.animation:getAnimation():playWithIndex(4,-1,-1,0);
    end
    self.animation:setVisible(true);
end

function finish_layer:hide_layer()
--    self:show_window(false);
    self:setVisible(false);
    self:close_task_win();
    self.end_clock:set_ready_clock(-1);

    if not self.animation then
        return;
    end
    self.animation:setVisible(false);
end

function finish_layer:shut_clock()
    self.end_clock:set_ready_clock(-1);
end

function finish_layer:touch_event(sender, eventType)
    if eventType == _G.TOUCH_EVENT_ENDED or eventType == _G.TOUCH_EVENT_CANCELED then
        self:setVisible(true);
    elseif eventType == _G.TOUCH_EVENT_BEGAN then
        self:setVisible(false);
    end
end

function finish_layer:get_one_card(card)
    local local_card;
    if #self.table_free_cards>0 then
        local_card = self.table_free_cards[1];
        table.remove(self.table_free_cards,1);
    else
        local_card = cards_3d_layout:getNewHandCard(true);
        self.back_ground:addChild(local_card);
    end
    local_card:init(local_card:makeDummyHandCardLayoutInfo());
    local_card:setScale(self.card_scale);
    return local_card;
end

function finish_layer:clear_cards()
    for k,v in ipairs(self.table_hand_cards) do
        v:setVisible(false);
        table.insert(self.table_free_cards,v);
    end
    for k,v in ipairs(self.table_heap_cards) do
        v:setVisible(false);
        table.insert(self.table_free_cards,v);
    end
    self.table_hand_cards = {};
    self.table_heap_cards = {};
end

function finish_layer:set_show_cards(table_heaps, table_show_cards, table_king_be, bool_eye_card)
    local float_start_x = -320;
	local float_start_y = 85;
	local float_spacing_x = 5;
	local float_spacing_y = 15;

	local float_card_width = 0;
	local float_card_height = 0;

    self:clear_cards()
    local int_zor=100;
    for k,v in pairs(table_heaps) do
        for k1,v1 in pairs(v.cards) do
            local temp_card = self:get_one_card();
            temp_card:showCard(v1);
            temp_card:setVisible(true);
            int_zor=int_zor+1;
            temp_card:setZOrder(int_zor)
               
            float_card_width = temp_card:getSize().width * self.card_scale - 5
            float_card_height = temp_card:getSize().height * self.card_scale 

            if (k1 == 4) then
                temp_card:setPosition(ccp(float_start_x - 2*(float_card_width),float_start_y + float_spacing_y))
                table.insert(self.table_heap_cards,temp_card)
                break;
            else
                if v.type == HandleTypeS.HT_MJ_ANGANG then
                    temp_card:showBack();
                end
            end 

            temp_card:setPosition(ccp(float_start_x,float_start_y))
            table.insert(self.table_heap_cards,temp_card)

            float_start_x = float_start_x + float_card_width
        end
        float_start_x = float_start_x + float_spacing_x
    end

    local int_king_index = 1;
    for k,v in pairs(table_show_cards) do
        local temp_card = self:get_one_card();
        temp_card:showCard(v);
        temp_card:setVisible(true)
        int_zor=int_zor+1;
        temp_card:setZOrder(int_zor)   
        if (int_king_index<=#table_king_be and k == table_king_be[int_king_index] + 1) then
            temp_card:showCard(game_layer.byte_caishen_card)
            int_king_index=int_king_index+1;
            temp_card:showCorner(7);
--        elseif temp_card:get_card() == game_layer.byte_caishen_card then
--            temp_card:set_cai_shen(true)
        else
            if v == game_layer.byte_caishen_card then
                temp_card:showCorner(7);
            else
                temp_card:showCorner(0);
            end
        end    
           
        float_card_width = temp_card:getSize().width * self.card_scale - 5
        float_card_height = temp_card:getSize().height * self.card_scale - 5

        if bool_eye_card and k==#table_show_cards then
            float_start_x = float_start_x + float_spacing_x;
        end
        temp_card:setPosition(ccp(float_start_x,float_start_y))
        table.insert(self.table_hand_cards,temp_card)

        float_start_x= float_start_x + float_card_width
    end

end

function finish_layer:set_fan_count(table_fan_count)
    local all_count = table_fan_count[1];
    if all_count == nil then
        all_count = 0;
    end
    self.table_fan_label[6]:setText(all_count);

    local int_index = 1;

    for i=2,6,1 do
        local local_count = table_fan_count[i];
        if local_count == nil or local_count == 0 then
            self.table_fan_label[i - 1]:setVisible(false);
            self.table_fan_bg[i - 1]:setVisible(false);
        else
            self.table_fan_label[i - 1]:setText(local_count);
            self.table_fan_label[i - 1]:setVisible(true);

            self.table_fan_bg[i - 1]:setPosition(ccp(260,32 - int_index*35));
            self.table_fan_bg[i - 1]:setVisible(true);

            int_index = int_index + 1;
        end
    end
end

function finish_layer:set_hu_type(hu_type)
    if hu_type == 0 then
        self.img_hu_type:setVisible(false);
    else
        self.img_hu_type:loadTexture("hutype"..hu_type..".png",1);
        self.img_hu_type:setVisible(true);			    		    
    end
end

function finish_layer:set_zhuang(chair)
    for i=1,GAME_PLAYER,1 do
        if i == chair + 1 then
            self.table_user_item[i]:set_zhuang(true);
        else 
            self.table_user_item[i]:set_zhuang(false);
        end
    end
end

function finish_layer:set_name(table_name)
    for i=1,GAME_PLAYER,1 do
        local local_name = table_name[i];
        if local_name == nil then
            local_name="";
        end
         self.table_user_item[i]:set_name(frame_tools:gbk_to_utf8(local_name));
    end
end

function finish_layer:set_status(table_status)
    for i=1,GAME_PLAYER,1 do
        local local_status = table_status[i];
        if local_status == nil then
            local_status = 0;
        end
         self.table_user_item[i]:set_status(local_status);
    end
end

function finish_layer:set_gold_status(table_gold_status)
    for i=1,GAME_PLAYER,1 do
        local local_status = table_gold_status[i];
        if local_status == nil then
            local_status = 0;
        end
         self.table_user_item[i]:set_gold_status(local_status);
    end
end

function finish_layer:set_gold(table_gold)
    for i=1,GAME_PLAYER,1 do
        local local_gold = table_gold[i];
        if local_gold == nil then
            local_gold = 0;
        end
        self.table_user_item[i]:set_gold(local_gold);
    end
end

function finish_layer:init_user_item(table_gold,table_name,table_status,chair_zhaung,table_gold_status)
    self:set_gold(table_gold);
    self:set_name(table_name);
    self:set_status(table_status);
    self:set_zhuang(chair_zhaung);
    self:set_gold_status(table_gold_status);
    
    for i=1,GAME_PLAYER,1 do
        if i == frame_tools:get_self_chair_id() + 1 then
            self.table_user_item[i]:set_self(true);
        else 
            self.table_user_item[i]:set_self(false);
        end
    end
    
end

function finish_layer:set_consume(param, base)
    if ROOM_KIND == ROOM_KIND_SCORE then
        self.label_consume:setVisible(false);
    end
    
    self.label_consume:setText("服务费:0");
    self.label_base:setText("底分:0");
    if param ~= nil then
        self.label_consume:setText("服务费:"..param);
    end
    if base ~= nil then
        self.label_base:setText("底分:"..base);
    end
end

function finish_layer:clear()
    for i=1,GAME_PLAYER,1 do
        self.table_user_item[i]:clear();
    end

    self.clear_cards();
end

-----------------------------------------------------------------------------
CUserInfoItem=class("CUserInfoItem");

function CUserInfoItem:extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, CUserInfoItem)
    return target
end

function CUserInfoItem:create(visibleSize)
    local layer = CUserInfoItem:extend(ImageView:create())
    layer:setVisible(true)
    layer:setTouchEnabled(false)
    layer:loadTexture("useritem_other.png",1);
    layer:init(visibleSize)
    return layer
end
----------------------------------------------------------------------------
CUserInfoItem.label_name=nil;
CUserInfoItem.img_zhuang=nil;
CUserInfoItem.img_status=nil;
CUserInfoItem.label_gold=nil;
CUserInfoItem.btn_gold_status = nil;

CUserInfoItem.int_gold_status = 0;
CUserInfoItem.bool_self=false;
CUserInfoItem.bool_lose=false;
----------------------------------------------------------------------------
function CUserInfoItem:init(visibleSize)
    self.label_name = UIHelper.create_labelEx(self, ccp(-240, 0), 26, ccc3(132, 82, 42));
    self.img_zhuang = UIHelper.create_img(self,ccp(-250,20),"reselt_zhuang.png",1);
    self.img_status = UIHelper.create_img(self,ccp(20,0),"status1.png",1);
    self.label_gold = UIHelper.create_labelBM(self, "resources/number_gold/number_fuzhoumajiang_ying.fnt",ccp(155,0));
    
    self.btn_gold_status = UIButtonExSmall:create()
    self:addChild(self.btn_gold_status);
    self.btn_gold_status:setPosition(ccp(245,0));
    self.btn_gold_status:loadTextureNormal("228_top_win.png",1);
    self.btn_gold_status:addTouchEventListener(function(sender, touchType) self:on_btn_gold_status(sender, touchType) end);
    self.btn_gold_status:setTouchEnabled(true);

    self.img_hint_bg = UIHelper.create_img(self,ccp(245,45),"228_hing_bg_up.png",1);
--    self.img_hint_bg:setScale9Enabled(true);
    self.label_hint = UIHelper.create_label(self.img_hint_bg, ccp(0, 7), 20, ccc3(81,88,115));
    self.label_hint:setText("赢取每个输家金币不超过赢家携带的数量");
    self.img_hint_bg:setOpacity(0);

--    local width = self.label_hint:getSize().width;
--    self.img_hint_bg:setSize(CCSizeMake(width + 10, 50));
--    self.img_hint_bg:setVisible(true);

    self:clear();
end

function CUserInfoItem:on_btn_gold_status(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    audio_engine.playEffect(-1)

    if self.int_gold_status <= 1 then
        return;
    end
    self.img_hint_bg:stopAllActions();
    self.img_hint_bg:setOpacity(0);
    self.img_hint_bg:setVisible(true);

    local array = CCArray:create();
    array:addObject(CCFadeIn:create(0.5));
    array:addObject(CCDelayTime:create(4));
    array:addObject(CCFadeOut:create(0.5));

    self.img_hint_bg:runAction(CCSequence:create(array));
end

function CUserInfoItem:set_name(str_name)
    self.label_name:setTextEx(str_name,170, 2);
end

function CUserInfoItem:set_zhuang(bool_zhuang)
    if bool_zhuang then
        self.img_zhuang:setVisible(true);
    else
        self.img_zhuang:setVisible(false);
    end
end

function CUserInfoItem:set_status(status)
    if status == 0 then
        self.img_status:setVisible(false);
        return;
    end
    self.img_status:setVisible(true);
    self.img_status:loadTexture("status"..status..".png",1);
end

function CUserInfoItem:set_gold(gold)
    if gold >= 0 then
        self.label_gold:setFntFile("resources/number_gold/number_fuzhoumajiang_ying.fnt");
        if gold > 100000 then
            self.label_gold:setText("+"..(gold/10000).."万");
        else 
            self.label_gold:setText("+"..gold);
        end
    else
        self.label_gold:setFntFile("resources/number_gold/number_fuzhoumajiang_shu.fnt");
        if gold<-100000 then
            self.label_gold:setText((gold/10000).."万");
        else 
            self.label_gold:setText(gold);
        end
    end
    
end

function CUserInfoItem:set_self(bool_self)
    if bool_self == nil then
        return;
    end
    self.bool_self = bool_self;
    if bool_self then
        self:loadTexture("useritem_self.png",1);
    else
        self:loadTexture("useritem_other.png",1);
    end
end

function CUserInfoItem:set_gold_status(gold_status)
    self.int_gold_status = gold_status;
    if gold_status == 0 then
        self.btn_gold_status:setVisible(false);
        self.img_hint_bg:setVisible(false);
        return;
    end
    
    if gold_status == 1 then
        self.btn_gold_status:loadTextureNormal("228_broke.png",1);  
    else
        self.btn_gold_status:loadTextureNormal("228_top_win.png",1);
        
        if gold_status == 2 then
            self.label_hint:setText("赢取每个输家金币不超过赢家携带的数量");
        elseif gold_status == 3 then    
            self.label_hint:setText("单局每人最多输"..game_layer.max_win.."金币");
        end
--        local width = self.label_hint:getSize().width;
--        self.img_hint_bg:setSize(CCSizeMake(width + 10, 50));
--        self.img_hint_bg:setVisible(true);
    end
    self.btn_gold_status:setVisible(true);
end

function CUserInfoItem:clear()
    self:set_name("")
    self:set_zhuang(false);
    self:set_status(0);
    self:set_gold(0);
    self:set_gold_status(0);
    self:set_self(false);
end

--------------------------------------------------------------------------------
-- 准备计时
--------------------------------------------------------------------------------

ready_clock = class("ready_clock")

--------------------------------------------------------------------------------
-- 参数
--------------------------------------------------------------------------------

ready_clock.fTimer=0;
ready_clock.int_time=-1;
ready_clock.int_id=-1;

ready_clock.clock_num=nil
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function ready_clock.extend(target)
    local t = tolua.getpeer(target)
    if not t then
        t = {}
        tolua.setpeer(target, t)
    end
    setmetatable(t, ready_clock)
    return target
end

function ready_clock:init(the_size)
    self.clock_num = LabelBMFont:create()
    self.clock_num:setFntFile("resources/number_gold/number_shaoxingmajiang_daojishi.fnt")
    self.clock_num:setPosition(ccp(0, -5))
    self:addChild(self.clock_num)
    self.clock_num:setVisible(false)
end

function ready_clock:set_ready_clock(int_time,bool_exit)
    if int_time>0 then
        self:setVisible(true);
        self.clock_num:setVisible(true)
        self.int_time=int_time;
        self.clock_num:setText(string.format("%d", self.int_time))
        local function update(dt)
            if self.int_time<=0 then
                return;
            end
            self.fTimer=self.fTimer+dt;
            if self.fTimer >= 1 then
                self.fTimer = self.fTimer - 1
            else
                return 
            end

            self.int_time = self.int_time - 1
            if self.int_time > 0 then
                self.clock_num:setText(string.format("%02d", self.int_time))
                if self.int_time <= 5 then
                     audio_engine.playEffect(KindSound.time_soon)
                end
            elseif self.int_time <= 0 then
                audio_engine.stopEffect(KindSound.time_soon)
                self.clock_num:setText(string.format("%d", self.int_time))
                self:unscheduleUpdate()
                if bool_exit == true then
                    game_event.on_start_time_over()
                end
            end
        end
        self:scheduleUpdateWithPriorityLua(update, 0)
    else
        self.clock_num:setVisible(false)
        self:setVisible(false);
        self:unscheduleUpdate()
    end
end

function ready_clock:create(the_size)
    local color = ready_clock.extend(ImageView:create())
    color:loadTexture("finish_time.png",1);
    color:init(the_size)
    return color
end

--endregion
