--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game_event = game_event or {}

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function game_event.switchMessage(id, data)
	--print("message id = ", id)
	if data ~= nil then
        if id == MessageType.SUB_S_GAME_CONFIG then
			game_event.on_event_game_config(data)

        elseif id == MessageType.SUB_S_GAME_CHAT then
            game_event.on_event_game_chat(data);

		elseif id == MessageType.SUB_S_BUTTON_POWER then
			game_event.on_event_button_power(data)	
        
        elseif id == MessageType.SUB_S_GAME_START then
            game_event.on_event_game_start(data)
	    
        elseif id == MessageType.SUB_S_BANKER then
            game_event.on_event_game_banker(data)

        elseif id == MessageType.SUB_S_GAME_DICE then
			game_event.on_event_game_dice(data)

        elseif id == MessageType.SUB_S_HAND_CARDS then
			game_event.on_event_hand_cards(data)

        elseif id == MessageType.SUB_S_HAND_CARDS_COUNT then
	        game_event.on_event_hand_cards_count(data)

        elseif id == MessageType.SUB_S_CARD_COUNT then
            game_event.on_event_left_card_count(data)

        elseif id == MessageType.SUB_S_ZI_GANG_CARDS then
            game_event.on_event_zi_gang_cards(data)

        elseif id == MessageType.SUB_S_ZI_GANG_CARD then
            game_event.on_event_zi_gang_card(data)

        elseif id == MessageType.SUB_S_CAISHEN_CARD then
	        game_event.on_event_caishen_card(data)

        elseif id == MessageType.SUB_S_A_HAND_CARDS then
	        game_event.on_event_a_hand_cards(data)

        elseif id == MessageType.SUB_S_OUT_CARD then
			game_event.on_event_out_cards(data)	

        elseif id == MessageType.SUB_S_OPERATION then
            game_event.on_event_handle_type(data)

        elseif id == MessageType.SUB_S_GANG_RESULT then
	        game_event.on_event_gang_result(data)   
            
        elseif id == MessageType.SUB_S_PENG_RESULT then
	        game_event.on_event_peng_result(data)         
               
        elseif id == MessageType.SUB_S_CHI_RESULT then
	        game_event.on_event_chi_result(data) 

        elseif id == MessageType.SUB_S_HU_RESULT then
	        game_event.on_event_hu_result(data)

        elseif id == MessageType.SUB_S_GAME_CLOCK then
            game_event.on_event_game_clock(data)

        elseif id == MessageType.SUB_S_GAME_FINISH then
			game_event.on_event_game_finish(data)

        elseif id == MessageType.SUB_S_TING_HINT then
            game_event.on_event_ting_hint(data)

--        elseif id == MessageType.SUB_S_TING_RESULT then
--            game_event.on_event_ting_result(data)

        elseif id == MessageType.SUB_S_USER_TRUST then
            game_event.on_event_user_trust(data)
       
        elseif id == MessageType.SUB_S_LIAN_ZHUANG_COUNT then
            game_event.on_event_lian_zhuang_count(data)

        elseif id == MessageType.SUB_S_READY_TIME then
            game_event.on_event_ready_time(data)

        elseif id == MessageType.SUB_S_FRIENDPARAMRTER_INFO then
            game_event.on_event_friends_info(data);

        elseif id == MessageType.SUB_S_HEAP_CARD then
	        game_event.on_event_heap_cards(data);

        elseif id == MessageType.SUB_S_LEAVE_CARDS_HINT then
            game_event.on_event_hint_leave_cards(data);

        elseif id == MessageType.SUB_S_HEAP_OUT_CARD then
	        game_event.on_event_heap_out_cards(data)

        elseif id == MessageType.SUB_S_SEND_GIFT then
			game_event.on_event_send_gift(data)

        elseif id == MessageType.SUB_S_USER_SEAT then
            game_event.on_event_user_seat(data) 

        elseif id == MessageType.SUB_S_HINT_POWER then
            game_event.on_event_hint_power(data)

        elseif id == MessageType.SUB_S_WIN_STREAK then
            game_event.on_event_win_streak(data);

        elseif id == MessageType.SUB_S_WIN_STREAK_COUNT then    
            game_event.on_event_win_streak_count(data);

        elseif id == MessageType.SUB_S_WIN_STREAK_HINT then    
            game_event.on_event_win_streak_hint(data);

        end
    end
end

function game_event.on_event_game_chat(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    frame_tools:show_hinting(frame_tools:gbk_to_utf8(table_json.message));
end

function game_event.on_event_heap_out_cards(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    local int_view = UIHelper.switch_to_view_id(table_json.chair)

    cards_3d_layout:setOutCards(UIHelper.Switch_view_to_view(int_view),table_json.cards)
    if table_json.islast == 1 then
        local pos = cards_3d_layout:getLastVisibleCardInfo(UIHelper.Switch_view_to_view(int_view),LayoutCardsType.out)
        game_layer.card_layer:play_point(int_view,pos);
    end

    for k,v in pairs(table_json.cards) do
        game_layer.table_remain_card_count[v - 10] = game_layer.table_remain_card_count[v - 10]-1;
--        print("remain:"..v)
    end
    game_layer.card_layer:hide_point();
end

function game_event.on_event_friends_info(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    game_layer.friend_info = table_json;

    game_layer.table_id_bg:setVisible(true);
    game_layer.table_id:setText(tostring("房间号:" .. table_json.code))
    game_layer.left_count_bg:setVisible(true);
    if game_layer.friend_info.currcount < game_layer.friend_info.totalcount then
        game_layer.left_count:setText(tostring((game_layer.friend_info.currcount).. "/" .. game_layer.friend_info.totalcount))
    end 
    if table_json.currcount > 0 and game_layer.tips_bg:getTag() == 0 then
        game_layer.tips_bg:setVisible(true);
        game_layer.tips_bg:setTag(1)
    end

    game_layer.grade_list = {};
    for i=1,table_json.data_count,1 do
        local item = {};
        item.name = frame_tools:gbk_to_utf8(table_json.name[i]);
        item.grade = table_json.grade[i];
        table.insert(game_layer.grade_list,item);
    end
    
end

function game_event.on_event_hint_leave_cards(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end
    game_layer.hint_leave_count:setText(tostring(table_json.count));
    game_layer.hint_leave_count:setOpacity(255);

    game_layer.hint_leave_count_bg:setPosition(ccp(game_layer.visibleSize.width/2,game_layer.visibleSize.height*3/4));
    game_layer.hint_leave_count_bg:setOpacity(255);
    game_layer.hint_leave_count_bg:setVisible(true);
    
    game_layer.hint_leave_count_bg:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(1),CCFadeOut:create(1)));
    game_layer.hint_leave_count_bg:runAction(
    CCSequence:createWithTwoActions(
    CCDelayTime:create(1),
    CCMoveTo:create(1,ccp(game_layer.visibleSize.width/2,game_layer.visibleSize.height*3/4 + 70))
    ));
    game_layer.hint_leave_count:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(1),CCFadeOut:create(1)));
end

function game_event.on_event_ready_time(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end
    
    if table_json.time == nil then
        return;
    end

    if ROOM_MODE == ROOM_MODE_FRIEND then
        return;
    end

    for i=1,GAME_PLAYER,1 do
        if i-1 ~= frame_tools:get_self_chair_id() then
            game_layer.game_user:set_clock(UIHelper.switch_to_view_id(i-1),table_json.time[i],game_layer.ready_time); 
        end
    end
    
end

function game_event.on_event_lian_zhuang_count(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end
  
    game_layer.count_lian_zhuang = table_json.zhuang;
    if table_json.zhuang == 0 or table_json.zhuang == nil then
--        game_layer.lian_zhuang_bg:setVisible(false);
        game_layer.label_lian_zhuang:setVisible(false);
        return;
    end
--    game_layer.lian_zhuang_bg:setVisible(true);
--    game_layer.lian_zhuang_count:setText("x"..table_json.zhuang);
    if ROOM_MODE ~= ROOM_MODE_FRIEND then
        game_layer.label_lian_zhuang:setVisible(true);
        game_layer.label_lian_zhuang:setText("连庄x"..table_json.zhuang);
    else
        game_layer.friends_base_label:setText("底分:"..game_layer.base_gold .."  连庄x"..table_json.zhuang);
    end

    if table_json.ani then
        game_layer.card_layer:player_lianzhuang(game_layer.banker_viewid);
    end
end

function game_event.on_event_user_trust(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    local int_chair_id = table_json.chair;
    local bool_trust = table_json.trust;

    if int_chair_id == frame_tools:get_self_chair_id() then
        if bool_trust then
            game_layer.trust_layer:setVisible(true)
        else
            game_layer.trust_layer:setVisible(false)
        end
    end
end

function game_event.on_event_game_config(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    game_layer.base_gold = table_json.base_gold;
    game_layer.consume_gold = table_json.consume;
    game_layer.ready_time = table_json.ready;
    game_layer.lock_time = table_json.lock_time;
    game_layer.ting_da = table_json.ting_da;
    game_layer.ting_duo = table_json.ting_duo;
    game_layer.max_win = table_json.max_win;
    --连胜
    game_layer.ws_day = table_json.ws_day;
    game_layer.ws_start = table_json.ws_start;
    game_layer.ws_end = table_json.ws_end;
    game_layer.ws_max_award_count = table_json.ws_max;
    if game_layer.ws_day == nil then
        game_layer.ws_day = 0;
    end

    if ROOM_MODE ~= ROOM_MODE_FRIEND and frame_tools:get_game_status() ~= GameStatus.free then
        game_layer.table_id_bg:setPosition(ccp(game_layer.visibleSize.width/2,game_layer.visibleSize.height + 20));
        game_layer.table_id_bg:runAction(CCMoveTo:create(1,ccp(game_layer.visibleSize.width/2, game_layer.visibleSize.height - 17)));
        game_layer.table_id_bg:setVisible(true);

        local str_base_gold = "底分:"..table_json.base_gold
        game_layer.table_id:setText(str_base_gold);
        game_layer.table_id:setVisible(true);
    elseif ROOM_MODE == ROOM_MODE_FRIEND and frame_tools:get_game_status() ~= GameStatus.free then
        
        if game_layer.count_lian_zhuang and game_layer.count_lian_zhuang > 0 then
            game_layer.friends_base_label:setText("底分:"..table_json.base_gold .."  连庄x"..game_layer.count_lian_zhuang);
        else
            game_layer.friends_base_label:setText("底分:"..table_json.base_gold);
        end
        game_layer.friends_base_label:setVisible(true);
    end
end

function game_event.on_event_handle_type(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    game_layer.table_handle_type = table_json;

    local table_handle_list = {};
    local table_select_cards = {};
    table.insert(table_handle_list,{type = HandleType.pass,value = table_json.card});

    --吃
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_LEFTCHI)>0 then
        table.insert(table_handle_list,{type = HandleType.b_chi_left,value = table_json.card});
    end 
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_ZHONGCHI)>0 then
        table.insert(table_handle_list,{type = HandleType.b_chi_mid,value = table_json.card});
    end
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_RIGHTCHI)>0 then
        table.insert(table_handle_list,{type = HandleType.b_chi_right,value = table_json.card});
    end
    --碰
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_PENG)>0 then
        table.insert(table_handle_list,{type = HandleType.b_peng,value = table_json.card});
        table_select_cards = {};
        table.insert(table_select_cards, table_json.card);
    end 
    --杠
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_ANGANG)>0 then
        table.insert(table_handle_list,{type = HandleType.d_gang,value = table_json.card});
        table_select_cards = {};
        table.insert(table_select_cards, table_json.card);
    elseif bit._and(table_json.handle_type,HandleTypeS.HT_MJ_MINGGANG1)>0 then
        table.insert(table_handle_list,{type = HandleType.b_gang,value = table_json.card});
        table_select_cards = {};
        table.insert(table_select_cards, table_json.card);
    elseif bit._and(table_json.handle_type,HandleTypeS.HT_MJ_MINGGANG2)>0 then
        table.insert(table_handle_list,{type = HandleType.a_gang,value = table_json.card});
        table_select_cards = {};
        table.insert(table_select_cards, table_json.card);
    elseif bit._and(table_json.handle_type,HandleTypeS.HT_MJ_DUOGANG)>0 then
        table_select_cards = {};
        local table_gang = table_json.gang;
        for k,v in ipairs(table_gang) do
            table.insert(table_handle_list,{type=game_layer.switch_handle_type_to_client(v.type),value=v.card})
            table.insert(table_select_cards, v.card);
        end
    end
    --胡
    if bit._and(table_json.handle_type,HandleTypeS.HT_MJ_HU)>0 then
        table.insert(table_handle_list,{type = HandleType.hu,value = table_json.card});
    end

    cards_3d_layout:showHandleSelect(table_handle_list);
    cards_3d_layout:selectMoveHandCardsWithValue(table_select_cards);
end

function game_event.on_event_heap_cards(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    if table_json.heap == nil then
        return
    end

    for k,v in pairs(table_json.heap) do
        for k1,v1 in pairs(v.cards) do
            if v1 == 0 then
                break;
            end
            game_layer.table_remain_card_count[v1 - 10] = game_layer.table_remain_card_count[v1 - 10] - 1;
        end
    end

    local table_handle_total = {};
    local int_to_chair_id = UIHelper.switch_to_view_id(table_json.chair);
	for k,v in pairs(table_json.heap) do
		local int_from_view_id = UIHelper.switch_to_view_id(v.chair_from);

        local table_handle = {};
        table_handle._value= v.eye_card;

		local int_HandleType = game_layer.switch_handle_type_to_client(v.handle_type);

        table_handle._type = int_HandleType;
        table_handle._from = UIHelper.Switch_view_to_view(int_from_view_id);
        table.insert(table_handle_total , table_handle)
	end

    cards_3d_layout:setHeapCards(UIHelper.Switch_view_to_view(int_to_chair_id),table_handle_total)
end

function game_event.on_event_game_clock(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    UIHelper.show_clock(UIHelper.switch_to_view_id(table_json.chair), table_json.clock)
end

function game_event.on_event_chi_result(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
    
    if game_layer.card_layer.sprite_point~=nil then
        game_layer.card_layer.sprite_point:setVisible(false);
    end

    local int_view_to = UIHelper.switch_to_view_id(table_json.chair_to)
    local int_view_from = int_view_to
    if table_json.chair_from ~= -1 then
        int_view_from = UIHelper.switch_to_view_id(table_json.chair_from)
    end
    
    local table_cards=table_json.result_cards;
    if int_view_to == 1 then
        table_cards[1],table_cards[3]=table_cards[3],table_cards[1]
    end

    local int_HandleType = HandleType.b_chi_left;
    if table_json.handle_type == HandleTypeS.HT_MJ_RIGHTCHI then
        int_HandleType = HandleType.b_chi_right;
    elseif table_json.handle_type == HandleTypeS.HT_MJ_ZHONGCHI then
        int_HandleType = HandleType.b_chi_mid;
    end

    cards_3d_layout:handle(UIHelper.Switch_view_to_view(int_view_to),UIHelper.Switch_view_to_view(int_view_from),int_HandleType,table_json.eye_card);
    cards_3d_layout:playHandleAnimation(UIHelper.Switch_view_to_view(int_view_to),int_HandleType,table_json.eye_card);

    game_layer.byte_last_out_card = 0;
	game_layer.card_layer:clear_out_card(game_layer.int_last_out_card_view);

    audio_engine.playCardVoice(KindSound.chi,table_json.chair_to);

    for i=1,3 do
        game_layer.table_remain_card_count[table_json.result_cards[i] - 10]=game_layer.table_remain_card_count[table_json.result_cards[i] - 10] - 1;
--        print("remain:"..table_json.result_cards[i])
        if table_json.result_cards[i] ~= table_json.eye_card then
            game_layer.card_layer:remove_hand_card(table_json.result_cards[i]);
        end
    end

    if table_json.chair_to == frame_tools:get_self_chair_id() then
        game_layer.btn_ting_layer:setVisible(false);
    end

    game_layer.card_layer:hide_point();
end

function game_event.on_event_peng_result(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    if game_layer.card_layer.sprite_point~=nil then
        game_layer.card_layer.sprite_point:setVisible(false);
    end

    local table_head_card={}
    for i=1,3,1 do
        table.insert(table_head_card,table_json.eye_card)
    end
    local int_view_to = UIHelper.switch_to_view_id(table_json.chair_to)
    local int_view_from = int_view_to
    if table_json.chair_from ~= -1 then
        int_view_from = UIHelper.switch_to_view_id(table_json.chair_from)
    end

    cards_3d_layout:handle(UIHelper.Switch_view_to_view(int_view_to),UIHelper.Switch_view_to_view(int_view_from),HandleType.b_peng,table_json.eye_card);
    cards_3d_layout:playHandleAnimation(UIHelper.Switch_view_to_view(int_view_to),HandleType.b_peng,table_json.eye_card);

    game_layer.byte_last_out_card = 0;
	game_layer.card_layer:clear_out_card(game_layer.int_last_out_card_view);

    audio_engine.playCardVoice(KindSound.peng,table_json.chair_to);

    game_layer.table_remain_card_count[table_json.eye_card - 10]=game_layer.table_remain_card_count[table_json.eye_card - 10] - 3;
    game_layer.card_layer:remove_hand_card(table_json.eye_card);
    game_layer.card_layer:remove_hand_card(table_json.eye_card);
--    print("remain:"..table_json.eye_card)

    if table_json.chair_to == frame_tools:get_self_chair_id() then
        game_layer.btn_ting_layer:setVisible(false);
    end

    game_layer.card_layer:hide_point();
end

function game_event.on_event_gang_result(data)
        local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    if game_layer.card_layer.sprite_point~=nil then
        game_layer.card_layer.sprite_point:setVisible(false);
    end

    local table_head_card={}
    for i=1,4,1 do
        table.insert(table_head_card,table_json.eye_card)
    end
    local int_view_to = UIHelper.switch_to_view_id(table_json.chair_to)
    local int_view_from = UIHelper.switch_to_view_id(table_json.chair_from)

    local int_HandleType = HandleType.b_gang;
    if table_json.handle_type == HandleTypeS.HT_MJ_ANGANG then
        int_HandleType = HandleType.d_gang;
    elseif table_json.handle_type == HandleTypeS.HT_MJ_MINGGANG2 then
        int_HandleType = HandleType.a_gang;
    end

    cards_3d_layout:handle(UIHelper.Switch_view_to_view(int_view_to),UIHelper.Switch_view_to_view(int_view_from),int_HandleType,table_json.eye_card);
    cards_3d_layout:playHandleAnimation(UIHelper.Switch_view_to_view(int_view_to),int_HandleType,table_json.eye_card);
   
    game_layer.byte_last_out_card = 0;
	game_layer.card_layer:clear_out_card(game_layer.int_last_out_card_view);

    audio_engine.playCardVoice(KindSound.gang,table_json.chair_to);

    if table_json.handle_type ~= HandleTypeS.HT_MJ_MINGGANG2 then
        game_layer.table_remain_card_count[table_json.eye_card - 10] = game_layer.table_remain_card_count[table_json.eye_card - 10] - 4;
--        print("remain:"..table_json.eye_card)
        for i=1,4,1 do
            if i == 4 and table_json.handle_type ~= HandleTypeS.HT_MJ_ANGANG then
                break;
            end
            game_layer.card_layer:remove_hand_card(table_json.eye_card);      
        end
    else 
        game_layer.table_remain_card_count[table_json.eye_card - 10] = game_layer.table_remain_card_count[table_json.eye_card - 10] - 1;
        game_layer.card_layer:remove_hand_card(table_json.eye_card);
--        print("remain:"..table_json.eye_card)
    end

    if table_json.chair_to == frame_tools:get_self_chair_id() then
        game_layer.btn_ting_layer:setVisible(false);
    end

    if table_json.handle_type ~= HandleTypeS.HT_MJ_ANGANG then
        game_layer.card_layer:hide_point(); 
    end
end

function game_event.on_event_hu_result(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
    game_layer.other_turn();

    local int_view = UIHelper.switch_to_view_id(table_json.chair_to);
    local int_view_from = UIHelper.switch_to_view_id(table_json.chair_from);
    local userIndex = UIHelper.Switch_view_to_view(int_view);
    local userIndexFrom = UIHelper.Switch_view_to_view(int_view_from);
    local int_card_count = #table_json.cards[table_json.chair_to + 1];

    if table_json.hu_type == nil then
        table_json.hu_type = 0;
    end
    --抢金
    if bit._and(table_json.hu_type,HuType.HT_QIANG_JIN)>0 then
        if int_view == 1 then
            game_layer.sort_cards_by_size_reverse(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        else
            game_layer.sort_cards_by_size(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        end   
        cards_3d_layout:setHandCards(userIndex,table_json.cards[table_json.chair_to + 1])
        if userIndex == UserIndex.down then
            cards_3d_layout:laySelfHandCards(true)
        end

        game_layer.card_layer:player_qiangjin(int_view);
    else
        --非抢金
        local int_win_cards_count = int_card_count;
        local winCardTable = {};
        local byte_eye_card = table_json.eye_card
        if table_json.eye_card == 0 then
            byte_eye_card = table_json.cards[table_json.chair_to + 1][#table_json.cards[table_json.chair_to + 1]];
            int_win_cards_count = int_win_cards_count - 1;
        end
        if userIndex ~= UserIndex.down then
            for i=1,int_win_cards_count do
                table.insert(winCardTable, table_json.cards[table_json.chair_to + 1][i]); 
            end
            if int_view == 1 then
                game_layer.sort_cards_by_size_reverse(winCardTable, int_win_cards_count, game_layer.byte_caishen_card);
            else
                game_layer.sort_cards_by_size(winCardTable, int_win_cards_count, game_layer.byte_caishen_card);
            end   
            table.insert(winCardTable, byte_eye_card); 
        end

        local array = CCArray:create();
--        array:addObject(CCDelayTime:create(1.0));
        array:addObject(CCCallFunc:create(function()
            if userIndex == UserIndex.down then
--                cards_3d_layout:setSelfHandJump(-1,0.1,10,2, true, true)
            end
        end));
--        array:addObject(CCDelayTime:create(1.0));
        array:addObject(CCCallFunc:create(function()
            cards_3d_layout:setHandCardsCanOut(false)
            cards_3d_layout:setHandCardsCanTouch(false)
            if userIndex ~= UserIndex.down then
                cards_3d_layout:setHandCards(userIndex, winCardTable)
            else
                local cardCount = int_card_count;
                if int_view_from ~= -1 then
                    cards_3d_layout:catchCard(UserIndex.down, byte_eye_card)
                    cardCount = int_card_count + 1;
                end
                cards_3d_layout:laySelfHandCards(true);
--                cards_3d_layout:setLayIndex(cardCount)
            end
        end
        ));
        array:addObject(CCDelayTime:create(0.1));
        array:addObject(CCCallFunc:create(function()
            game_layer.card_layer:showAniShuShan(userIndex, userIndexFrom)   
        end));
        array:addObject(CCDelayTime:create(1.2));
        array:addObject(CCCallFunc:create(function()
            cards_3d_layout:removeOutCard(userIndexFrom)
            cards_3d_layout:playHandleAnimation(userIndex,HandleType.hu);
            game_layer.card_layer:showAniQuanShan(userIndex, 0.2) 
        end));
        game_layer.layer:runAction(CCSequence:create(array));
        
    end

    game_layer.int_hu_view = int_view;
    game_layer.card_layer:clear_out_cards(game_layer.int_last_out_card_view);
    game_layer.byte_last_out_card = 0

    game_layer.ting_hint_layer:setVisible(false);
    audio_engine.playCardVoice(KindSound.hu,table_json.chair_to);

    game_layer.btn_ting_layer:setVisible(false);

    if table_json.chair_from ~= -1 then
        game_layer.card_layer:hide_point(); 
    end

    game_layer.int_game_status = GameStatus.hu;
end

function game_event.on_event_hu_result_old(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    local int_view = UIHelper.switch_to_view_id(table_json.chair_to);
    local int_view_from = UIHelper.switch_to_view_id(table_json.chair_from);
    local int_card_count = #table_json.cards[table_json.chair_to + 1];

    if table_json.hu_type == nil then
        table_json.hu_type = 0;
    end
    if bit._and(table_json.hu_type,HuType.HT_QIANG_JIN)>0 then
        if int_view == 1 then
            game_layer.sort_cards_by_size_reverse(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        else
            game_layer.sort_cards_by_size(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        end   
    else
        local byte_eye_card = table_json.eye_card
        if table_json.eye_card == 0 then
            byte_eye_card = table_json.cards[table_json.chair_to + 1][#table_json.cards[table_json.chair_to + 1]];
            int_card_count = int_card_count-1;
        else
            table.insert(table_json.cards[table_json.chair_to + 1],byte_eye_card);
        end
        if int_view == 1 then
            game_layer.sort_cards_by_size_reverse(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        else
            game_layer.sort_cards_by_size(table_json.cards[table_json.chair_to + 1],int_card_count,game_layer.byte_caishen_card);
        end
    end
    cards_3d_layout:setHandCards(UIHelper.Switch_view_to_view(int_view),table_json.cards[table_json.chair_to + 1])
    
    if UIHelper.Switch_view_to_view(int_view) == UserIndex.down then
        cards_3d_layout:laySelfHandCards(true)
    end

    game_layer.int_hu_view = int_view;
    game_layer.card_layer:clear_out_cards(game_layer.int_last_out_card_view);
    game_layer.byte_last_out_card = 0

    if table_json.hu_type ~= nil then
        if bit._and(table_json.hu_type,HuType.HT_QIANG_JIN) > 0 then
            game_layer.card_layer:player_qiangjin(int_view);
        else
            game_layer.card_layer:showHandleAni(UIHelper.Switch_view_to_view(int_view),UIHelper.Switch_view_to_view(int_view_from),int_card_count + 1) 
            cards_3d_layout:playHandleAnimation(UIHelper.Switch_view_to_view(int_view),HandleType.hu);               
        end
    end
    game_layer.ting_hint_layer:setVisible(false);
    audio_engine.playCardVoice(KindSound.hu,table_json.chair_to);

    game_layer.btn_ting_layer:setVisible(false);

    if table_json.chair_from ~= -1 then
        game_layer.card_layer:hide_point(); 
    end

    game_layer.int_game_status = GameStatus.hu;
end

function game_event.on_event_game_finish(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
    game_layer.other_turn();
    cards_3d_layout:setHandCardsCanTouch(false)
    game_layer.ting_cards = {};

    frame_tools:set_game_status(GameStatus.free);

    game_layer.byte_last_out_card=0

    game_layer.card_layer:clear_out_cards();
    game_layer.card_layer:hide_point();
    UIHelper.show_clock(-1, game_layer.ready_time);

--    cards_3d_layout:setHandCardsCanTouch(false);

    for i=1,GAME_PLAYER,1 do
        local int_view = UIHelper.switch_to_view_id(i-1)
        
        local table_card = table_json.hand_cards[i]
        local card_count = #table_card
        if (game_layer.int_hu_view ~= int_view) then
            card_count = #table_card-1;
        end
        if int_view == 1 then
            game_layer.sort_cards_by_size_reverse(table_card,card_count,game_layer.byte_caishen_card);
        else
            game_layer.sort_cards_by_size(table_card,card_count,game_layer.byte_caishen_card);
        end
               
        cards_3d_layout:setHandCards(UIHelper.Switch_view_to_view(int_view),table_card)
        if UIHelper.Switch_view_to_view(int_view) == UserIndex.down then
            cards_3d_layout:laySelfHandCards(true)
        end
    end
    if table_json.winner == -1 then
        game_layer.play_liuju(true);
    else
        if ROOM_MODE == ROOM_MODE_FRIEND then
            if game_layer.friend_info.currcount == game_layer.friend_info.totalcount then
                game_layer.finish_layer:set_window_type(2); 
            else
                game_layer.finish_layer:set_window_type(1); 
            end
        end
        game_layer.finish_layer:init_user_item(table_json.gold, table_json.name, table_json.status, table_json.banker, table_json.gold_status);
        game_layer.finish_layer:set_hu_type(table_json.hu_statu);
        game_layer.finish_layer:set_fan_count(table_json.fan);
        game_layer.finish_layer:set_consume(game_layer.consume_gold, game_layer.base_gold);
        if bit._and(table_json.hu_type,HuType.HT_QIANG_JIN) > 0 then
            game_layer.finish_layer:set_show_cards(table_json.heap_cards[table_json.winner + 1],table_json.show_cards,table_json.king_cards,false);
        else
            game_layer.finish_layer:set_show_cards(table_json.heap_cards[table_json.winner + 1],table_json.show_cards,table_json.king_cards,true);
        end
        game_layer.finish_layer:play_animation(table_json.kind);
        
--        game_layer.btn_finish_layer:setVisible(true);
    end

    if table_json.kind == ResultKind.RESULT_KIND_WIN then
        audio_engine.playEffect(KindSound.win)
    elseif table_json.kind == ResultKind.RESULT_KIND_LOST then
        audio_engine.playEffect(KindSound.lose)
    elseif table_json.kind == ResultKind.RESULT_KIND_DRAW then
        audio_engine.playEffect(KindSound.draw)
    end
    game_layer.ting_hint_layer:setVisible(false);
    game_layer.left_card_bg:setVisible(false);

    game_layer.int_game_status = GameStatus.free;
--    game_layer.lian_zhuang_bg:setVisible(false);
    game_layer.label_lian_zhuang:setVisible(false);
end

function game_event.on_event_out_cards(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
    if frame_tools:get_game_status() == GameStatus.free then
        return;
    end
    game_layer.card_layer:clear_out_card(game_layer.int_last_out_card_view);
    game_layer.byte_last_out_card = 0

    local int_view = UIHelper.switch_to_view_id(table_json.chair)
    local userIndex = UIHelper.Switch_view_to_view(int_view);
    local bool_reout = table_json.reout or false;

    if (int_view == VIEW_INDEX_SELF) then
        for k,v in pairs(game_layer.ting_cards) do
            if v == table_json.card then
                game_layer.ting_hint_layer:set_hu_card(game_layer.ting_data[k].type,game_layer.ting_data[k].cards,game_layer.ting_data[k].count);
                game_layer.btn_ting_layer:setVisible(true);
            end
        end
        game_layer.ting_cards = {};
	end

    if int_view ~= VIEW_INDEX_SELF or game_layer.client_out_card ~= table_json.card then
        audio_engine.playEffect(KindSound.outcards)
        audio_engine.playCardVoice(table_json.card,table_json.chair);

        local param_1 = nil;
        local param_2 = nil;
        if int_view == VIEW_INDEX_SELF then
            param_2 = game_layer.card_layer:get_card_index(table_json.card);
            if param_2 > 17 then
                param_2 = 1;
            end
        end

        cards_3d_layout:outCard(userIndex,table_json.card,param_1,param_2);

        game_layer.card_layer:set_big_card(int_view,table_json.card);   
    end
     
    if int_view == VIEW_INDEX_SELF then
        game_layer.card_layer:remove_hand_card(table_json.card);

        game_layer.img_banker_out_hint:setVisible(false);
    end

    game_layer.ting_hint_layer:setVisible(false);
    game_layer.int_last_out_card_view = int_view;
	game_layer.byte_last_out_card = table_json.card;
    game_layer.client_out_card = 0;

--    game_layer.layer:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.5),CCCallFunc:create(function ()
--        game_layer.card_layer:showHandleAni(userIndex, userIndex) 
--    end) ) );
end

function game_event.on_event_a_hand_cards(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
--    game_layer.ting_cards = {};
    game_layer.set_head_able(true);
    
    if game_layer.byte_last_out_card ~= 0 and game_layer.int_last_out_card_view ~= -1 then
        game_layer.table_remain_card_count[game_layer.byte_last_out_card - 10] = game_layer.table_remain_card_count[game_layer.byte_last_out_card - 10] - 1;
--        print("remain:"..game_layer.byte_last_out_card)
        game_layer.card_layer:hide_big_card(game_layer.int_last_out_card_view);
        game_layer.byte_last_out_card = 0;
    end     
    
    cards_3d_layout:unselectAllHandCards();
    if table_json.card_chair == frame_tools:get_self_chair_id() then 
        audio_engine.playEffect(KindSound.catch_card)
        cards_3d_layout:catchCard(UserIndex.down,table_json.card)
        game_layer.card_layer:insert_hand_card(table_json.card,1);
        game_layer.btn_ting_layer:setVisible(false);

        cards_3d_layout:setDarkCardValue(table_json.card);
    else 
        local view_id = UIHelper.switch_to_view_id(table_json.card_chair)
        cards_3d_layout:catchCard(UIHelper.Switch_view_to_view(view_id),0)
    end

    game_layer.int_residue_cards=game_layer.int_residue_cards-1
    game_layer.left_card_bg:setVisible(true);
    game_layer.left_card_count:setText("剩"..game_layer.int_residue_cards.."张");

    game_layer.ting_cards = {};
end

function game_event.on_event_caishen_card(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
    if table_json.caishen == 0 then
        return;
    end
    game_layer.byte_caishen_card=table_json.caishen
    game_layer.caishen_bg:setVisible(true);

    game_layer.caishen_img:setScale(1);
    game_layer.caishen_img:showCard(table_json.caishen)
    game_layer.caishen_img:stopAllActions();
    game_layer.caishen_img:setVisible(false);
    local table_config = {};
    table_config[table_json.caishen]=7;

    cards_3d_layout:setCornerCardValue(table_config)

    if table_json.kaijin then
        game_layer.card_layer:player_kaijin(game_layer.banker_viewid);
        if table_json.caishen < 40 then
            local array=CCArray:create();
            array:addObject(CCDelayTime:create(0.3));
            array:addObject(CCCallFunc:create(function ()
                game_layer.caishen_img:setVisible(true);
            end))
            array:addObject(CCDelayTime:create(1));
            array:addObject(CCMoveTo:create(0.3,ccp(game_layer.visibleSize.width - 48 - game_layer.screenGap, game_layer.visibleSize.height - 155 - 3)));
            array:addObject(CCScaleTo:create(0.3,0.8));
            array:addObject(CCCallFunc:create(function ()
                game_layer.caishen_img:showCorner(7);
            end))
            game_layer.caishen_img:runAction(CCSequence:create(array))

            game_layer.int_game_status = GameStatus.out_card;
        else
            local array=CCArray:create();
            array:addObject(CCDelayTime:create(0.3));
            array:addObject(CCCallFunc:create(function ()
                game_layer.caishen_img:setVisible(true);
            end))
            array:addObject(CCDelayTime:create(1))
            array:addObject(CCCallFunc:create(function() game_layer.caishen_img:setVisible(false);end))
            game_layer.caishen_img:runAction(CCSequence:create(array))
        end
    else
        game_layer.caishen_img:setVisible(true);
        game_layer.caishen_img:showCorner(7);
        game_layer.caishen_img:setScale(0.8);
    end
    
    game_layer.table_remain_card_count[table_json.caishen - 10] = game_layer.table_remain_card_count[table_json.caishen - 10] - 1;
end

function game_event.on_event_zi_gang_card(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    local int_view = UIHelper.switch_to_view_id(table_json.chair);
    game_layer.card_layer:do_bu_hua(int_view,table_json.card);

    game_layer.game_user:set_hua_count(int_view,table_json.count);

    game_layer.card_layer:remove_hand_card(table_json.card);

    audio_engine.playCardVoice(KindSound.buhua,table_json.chair);
    game_layer.card_layer:clear_out_card(game_layer.int_last_out_card_view);
    game_layer.byte_last_out_card = 0
end

function game_event.on_event_zi_gang_cards(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    local int_view = UIHelper.switch_to_view_id(table_json.chair);
    game_layer.card_layer:set_bu_hua(int_view,table_json.cards,table_json.count,table_json.ref,table_json.kaijin);

    game_layer.game_user:set_hua_count(int_view,table_json.count);

    if not table_json.kaijin and table_json.ref then
        audio_engine.playCardVoice(KindSound.buhua,table_json.chair);
        game_layer.set_head_able(false);
    end
    
end

function game_event.on_event_left_card_count(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end
    game_layer.int_residue_cards = table_json.card_count;
    game_layer.left_card_bg:setVisible(true);
    game_layer.left_card_count:setText("剩"..table_json.card_count.."张");
end

function game_event.on_event_hand_cards(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end
--    game_layer.ting_cards = {};

    --清理手牌？
    if table_json.card_count==0 then

        return
    end
    --对比手牌，是否刷新
    local is_reset = false
    local client_count = game_layer.card_layer:get_cards_count()
    local client_card = game_layer.card_layer:get_hand_cards()
    repeat
        if client_count ~= cards_count then
            is_reset = true
            break;
        end

        if client_card == nil or #client_card == 0 then
            is_reset = true 
            break;
        end
       
        for k,v in pairs(hand_cards) do  
            if v and v ~= 0 and v ~= game_layer.struct_hand_cards[k] then
                is_reset = true
                break
            end
        end
    until(false)

    if is_reset then
        cards_3d_layout:unselectAllHandCards();
        local isReconnect = table_json.isReconnect or false;
        game_layer.card_layer:set_self_hand_card(table_json.cards, table_json.card_count, table_json.bool_ani, isReconnect)
    end

end

function game_event.on_event_button_power(data)
	local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
	end

--	print(table_json.visible, table_json.enable, "~~~~~~~~~~~~")

    local user_json = frame_tools:get_self_user_data()
    if user_json == nil then
        return
    end

    if user_json.user_status ~= 0x03 then
        game_layer.btn_invite:setVisible(bit._and(table_json.visible, ButtonPower.BUTTON_POWER_FRIEND) > 0)
        game_layer.btn_invite:setTouchEnabled(bit._and(table_json.enable, ButtonPower.BUTTON_POWER_FRIEND) > 0)

        game_layer.ptr_btn_start:setVisible(bit._and(table_json.visible, ButtonPower.BUTTON_START) > 0)
        game_layer.ptr_btn_start:setTouchEnabled(bit._and(table_json.enable, ButtonPower.BUTTON_START) > 0)
        game_layer.ptr_btn_start:setBright(bit._and(table_json.enable, ButtonPower.BUTTON_START) > 0);

        game_layer.ptr_btn_changetable:setVisible(bit._and(table_json.visible, ButtonPower.BUTTON_CHANGETABLE) > 0)
        game_layer.ptr_btn_changetable:setTouchEnabled(bit._and(table_json.enable, ButtonPower.BUTTON_CHANGETABLE) > 0)

        game_layer.btn_grade:setVisible(bit._and(table_json.visible, ButtonPower.BUTTON_GRADE) > 0)
        game_layer.btn_grade:setTouchEnabled(bit._and(table_json.enable, ButtonPower.BUTTON_GRADE) > 0)
       
        if ROOM_MODE ~= ROOM_MODE_FRIEND then
            --头像倒计时
            if bit._and(table_json.visible, ButtonPower.BUTTON_POWER_CLOCK) > 0 then
                local bool_exit = true;
                if bit._and(table_json.enable, ButtonPower.BUTTON_POWER_CLOCK) <= 0 then
                    bool_exit = false;
                end
                game_layer.game_user:set_clock(VIEW_INDEX_SELF,game_layer.ready_time,game_layer.ready_time,bool_exit);
                UIHelper.show_clock(-1, game_layer.ready_time);
            end
            --锁桌踢人倒计时
            if bit._and(table_json.visible, ButtonPower.BUTTON_POWER_LOCK) > 0 then
                game_layer.ready_lock:set_ready_clock(game_layer.lock_time,true);
            end
        end
        
    end

    if bit._and(table_json.visible, ButtonPower.BUTTON_HANDLE_WAIT) > 0 then
        game_layer.hint_wait_other_handle:setVisible(true);
    end

    if bit._and(table_json.visible, ButtonPower.BUTTON_AUTO_START) > 0 then
        on_btn_ready(2)
    end

    if(bit._and(table_json.visible, ButtonPower.BUTTON_OUTCARD) > 0) then
        game_layer.bool_zi_gang=false;
        game_layer.bool_wait_handle=false;
        cards_3d_layout:setHandCardsCanOut(true)
        game_layer.btn_ting_layer:setVisible(false);
    elseif bit._and(table_json.visible, ButtonPower.BUTTON_NO_OUTCARD) > 0 or table_json.visible == 0 then
        game_layer.other_turn();
    end
    if(bit._and(table_json.visible, ButtonPower.BUTTON_POWER_FRIEND) > 0 and ROOM_MODE==ROOM_MODE_FRIEND)then
        if game_layer.friend_info ~= nil and game_layer.friend_info.currcount == 0 then
            game_layer.game_hint_bg:setVisible(true);
        end
    end
end

function game_event.on_event_game_start(data)
    game_layer.ptr_btn_start:setVisible(false)
    game_layer.ptr_btn_changetable:setVisible(false)
end

function game_event.on_event_game_banker(data)

    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end
    game_layer.tips_bg:setVisible(false)
    frame_tools:set_game_status(GameStatus.playing);

    game_layer.show_new_player_hint(1);

    game_layer.game_user:clear_user_data()
    if game_layer.friend_info~=nil then
        if game_layer.friend_info.currcount < game_layer.friend_info.totalcount then
            game_layer.left_count:setText(tostring((game_layer.friend_info.currcount + 1).. "/" .. game_layer.friend_info.totalcount))
        end  
    end
    
    game_layer.banker_viewid = UIHelper.switch_to_view_id(table_json.banker_id)
    if table_json.bool_action == false then
        UIHelper.convert_east_banker(game_layer.banker_viewid)
    end
    game_layer.game_user.player_identity[UIHelper.switch_to_view_id(table_json.banker_id)]:setVisible(true)

    game_layer.game_hint_bg:setVisible(false);

    for i=1,VIEW_INDEX_COUNT,1 do
        game_layer.game_user:set_status(i,UserStatus.null);
    end

    game_layer.game_user:move_head();
end

function game_event.on_event_game_dice(data)

    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    game_layer.dice_tbl = {}
    for k,v in pairs(table_json.dice_num) do
        table.insert(game_layer.dice_tbl, v)
    end

    UIHelper.play_start_action(UIHelper.switch_to_view_id(table_json.player))
    game_layer.set_head_able(false);
end

function game_event.on_event_hand_cards_count(data)
    local c = require "cjson"
	local table_json = c.decode(data)
	if table_json == nil then
		return
    end

    if table_json.chair == frame_tools:get_self_chair_id() then
        return
    end

    local int_view = UIHelper.switch_to_view_id(table_json.chair)

    if game_layer.int_hand_card_count[int_view] ~= 0 then
        return    
    end

    if (table_json.card_count ~= game_layer.int_hand_card_count[int_view])then
		game_layer.int_hand_card_count[int_view] = table_json.card_count;
	end
    
    game_layer.card_layer:set_other_hand_card(int_view,table_json.card_count,0,false,table_json.bool_ani)
end

function game_event.on_start_time_over()
    if ROOM_MODE==ROOM_MODE_FRIEND then
        return
    end
    frame_tools:get_relief_gold();
    frame_tools:close_game()
    frame_tools:show_sysmessage_box("长时间未开始，已自动离开房间", "提示", 0)
end

function game_event.on_event_ting_hint(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return
    end

    game_layer.ting_cards = table_json.cards;
    game_layer.ting_data = table_json.data;

    local table_ting_da = {}
    local table_ting_duo = {}
    local table_tine_other = {};

    local int_max_ting_type = 0;
    local int_max_ting_count = 0;

    --为了小游戏，避免改协议,贼麻烦
    --听 大
    for k,v in pairs(table_json.data) do
        for k1,v1 in pairs(v.type) do
            if v1 > game_layer.ting_da then
                if v1 > int_max_ting_type then
                    int_max_ting_type = v1;

                    table_ting_da = {};
                end
                if v1 >= int_max_ting_type then
                    table.insert(table_ting_da, table_json.cards[k]);
                end
            end
        end    
    end
    --听 多
    for k,v in pairs(table_json.data) do
        local isFind = false;
        for daK,daV in pairs(table_ting_da) do
            if table_json.cards[k] == daV then
                isFind = true;
            end
        end
        if not isFind then
            if table_json.cards[k] ~= int_max_ting_type_card then
                if v.count > game_layer.ting_duo then
                    if v.count > int_max_ting_count then
                        int_max_ting_count = v.count;

                        table_ting_duo = {};
                    end
                    if v.count >= int_max_ting_count then
                        table.insert(table_ting_duo, table_json.cards[k]);
                    end
                end
            end
        end
    end
    --
    for k,v in pairs(table_json.data) do
        local isFind = false;
        for daK,daV in pairs(table_ting_da) do
            if table_json.cards[k] == daV then
                isFind = true;
            end
        end
        if not isFind then
            for duoK,duoV in pairs(table_ting_duo) do
                if table_json.cards[k] == duoV then
                    isFind = true;
                end
            end
        end
        if not isFind then
            table.insert(table_tine_other,table_json.cards[k]);
        end
    end

--    for k,v in pairs(table_json.data) do
--        local isFind = false;
--        for k1,v1 in pairs(v.type) do
--            if v1 > game_layer.ting_da then
--                table.insert(table_ting_da,table_json.cards[k]);
--                isFind = true;
--            end
--        end    
--        if not isFind then
--            if v.count > game_layer.ting_duo then
--                table.insert(table_ting_duo,table_json.cards[k]);
--                isFind = true;
--            end
--        end
--        if not isFind then
--            table.insert(table_tine_other,table_json.cards[k]);
--        end
--    end
    
    cards_3d_layout:setHandCardsTingDaByValue(table_ting_da);
    cards_3d_layout:setHandCardsTingDuoByValue(table_ting_duo);
    cards_3d_layout:setHandCardsTingByValue(table_tine_other);
end

function game_event.on_event_send_gift(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return 
    end

    local from_chair_id = table_json.from_chair_id
    local to_chair_id = table_json.to_chair_id
    local from_user_id = table_json.from_user_id
    local to_user_id = table_json.to_user_id
    local gift_id = table_json.gift_id
    local int_num = table_json.int_num

    local visibleSize = CCDirector:sharedDirector():getWinSize()
    local player_pos = { [1] = ccp(game_layer.game_user.player_background[1]:getPositionX(), game_layer.game_user.player_background[1]:getPositionY() + 10), 
                         [2] = ccp(game_layer.game_user.player_background[2]:getPositionX(), game_layer.game_user.player_background[2]:getPositionY() + 10), 
                         [3] = ccp(game_layer.game_user.player_background[3]:getPositionX(), game_layer.game_user.player_background[3]:getPositionY() + 10), 
                         [4] = ccp(game_layer.game_user.player_background[4]:getPositionX(), game_layer.game_user.player_background[4]:getPositionY() + 10)}
    local from_pos = player_pos[UIHelper.switch_to_view_id(from_chair_id)]
    local to_pos = player_pos[UIHelper.switch_to_view_id(to_chair_id)]

    if game_layer.game_user.have_move then
        game_layer.gift_play:play_gift_times(from_pos, to_pos, gift_id, int_num, 0.75)
    else
        game_layer.gift_play:play_gift_times(from_pos, to_pos, gift_id, int_num)
    end
end

function game_event.on_event_user_seat(data)
    local c = require "cjson"
    local seat_json = c.decode(data)
    if seat_json == nil then
        return 
    end
    game_layer.isCanChangeSeat = seat_json.canChange;
    game_layer.table_user_seat = seat_json.seat;
    game_layer.isGetSeat = true;

    if game_layer.isCanChangeSeat ~= 0 then
        game_layer.game_user:resetChangeSeat();
    end
    
    game_layer.selfSeat = game_layer.table_user_seat[SELFCHAIRID + 1];

    table_3d_layout:setSelfDirection(game_layer.selfSeat + 1);

    for i=1,GAME_PLAYER do 
        if i ~= VIEW_INDEX_SELF then
            game_layer.game_user:show_user(i, false);
            game_layer.game_user:set_status(i, UserStatus.null)
--            if bit._and(ROOM_KIND,ROOM_KIND_SCORE)>0 then
--                game_layer.game_user:set_score(i, 0)
--            else
--                game_layer.game_user:set_gold(i, -1)
--            end
        end
    end
    
    for k,v in pairs(game_layer.table_wait_init) do
        local chairid = v;
        local table_json = frame_tools:get_user_data(chairid)
        
        local viewid = UIHelper.switch_to_view_id(chairid);

        game_layer.game_user:show_user(viewid, true)
        game_layer.game_user:set_sex(viewid, table_json.user_id, table_json.face_id, table_json.sex)
        game_layer.game_user:set_name(viewid,table_json.nickname);
        game_layer.game_user:set_identity(viewid,-1);
        game_layer.game_user:turn_outline_status(viewid, table_json.user_status ~= PlayerStatus.us_offline);
        
--            if bit._and(ROOM_KIND,ROOM_KIND_SCORE)>0 then
--                game_layer.game_user:set_score(viewid, table_json.socre)
--            else
--                game_layer.game_user:set_gold(viewid, table_json.gold)
--            end

        if table_json ~= nil and table_json.user_status == 0x03 then -- 准备状态
            if viewid ~= VIEW_INDEX_SELF then
                game_layer.game_user:set_status(viewid, UserStatus.ready)
            end
        else 
            if ROOM_MODE ~= ROOM_MODE_FRIEND then
                if viewid ~= VIEW_INDEX_SELF then
                    if game_layer.ready_time > 0 then
                        game_layer.game_user:set_clock(viewid,game_layer.ready_time,game_layer.ready_time);
                    end 
                end
            end
        end

        game_layer.set_play_effect = game_layer.set_play_effect or false
        if game_layer.set_play_effect == true then
            audio_engine.enter_effect()
        end
        
    end

end

function game_event.on_event_hint_power(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return 
    end

    if bit._and(table_json.type, HintPower.HINT_FENZHANG) > 0 then
        game_layer.play_aniUpOut(game_layer.img_fen_zhang_hint, ccp(game_layer.visibleSize.width/2,game_layer.visibleSize.height*3/4) );
    elseif bit._and(table_json.type, HintPower.HINT_BANKER_OUT) > 0 then
        game_layer.img_banker_out_hint:setVisible(true);
    end
end

function game_event.on_event_win_streak(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return 
    end

    if game_layer.ws_day == 0 then
        return;
    end

    game_layer.btn_win_streak:setTouchEnabled(false);
    game_layer.ws_award_count = table_json.award_count;

    local array = CCArray:create();
    array:addObject(CCDelayTime:create(2));
    array:addObject(CCCallFunc:create(function() game_layer.btn_win_streak:setTouchEnabled(true); end) );
    if game_layer.ws_award_count >= game_layer.ws_max_award_count then
        game_layer.layer_winning_streak:show_tips_string(table_json.id.."连胜达成,今日"..table_json.award_count.."次挑战奖励已领完");
    else
        game_layer.layer_winning_streak:show_tips(4, table_json.id);
    end
  
    game_layer.btn_win_streak:runAction(CCSequence:create(array));
    
--    game_layer.layer_winning_streak:show_tips(4, table_json.id);

    --动画
    game_layer.layer_winning_streak:play_gold_ani();
    game_layer.layer_winning_streak:play_text(table_json.gold, table_json.ticket);
end

function game_event.on_event_win_streak_count(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return 
    end

    if game_layer.ws_day == 0 then
        return;
    end
    game_layer.ws_award_count = table_json.award_count;

    game_layer.layer_winning_streak:set_win_count(table_json.count);
    game_layer.layer_winning_streak:set_aim_count(table_json.aim);
    game_layer.layer_winning_streak:set_award_count(table_json.gold, table_json.ticket);

    if game_layer.btn_win_streak:isVisible() == false then
        game_layer.show_win_streak(true);
        game_layer.layer_winning_streak:set_time(game_layer.ws_start, game_layer.ws_end);
    end
end

function game_event.on_event_win_streak_hint(data)
    local c = require "cjson"
    local table_json = c.decode(data)
    if table_json == nil then
        return 
    end

    if game_layer.ws_day == 0 then
        return;
    end

    game_layer.layer_winning_streak:show_tips(table_json.type);
end

--endregion
