--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

game_layer = game_layer or {};

--------------------------------------------------------------------------------
-- 属性
--------------------------------------------------------------------------------
game_layer.scale_height = nil;
game_layer.layer = nil;
game_layer.visibleSize = nil;

game_layer.game_user=nil;

game_layer.byte_caishen_card=0;
game_layer.client_out_card=0

game_layer.table_user_name={}
game_layer.table_user_sex={}
game_layer.table_user_userid={}
game_layer.table_user_faceid={}

game_layer.int_hand_card_count = {0,0,0,0}
game_layer.int_hu_view = -1
game_layer.int_last_out_card_view =-1
game_layer.byte_last_out_card = 0
game_layer.int_residue_cards = 144                  --剩余牌数

game_layer.int_touch_height = 200;

game_layer.int_last_out_card_view = 0;
game_layer.byte_last_out_card = 0;
game_layer.client_out_card = 0;

game_layer.base_gold = 0;
game_layer.consume_gold = 0;
game_layer.ready_time = 0;

game_layer.friend_info = nil;
game_layer.grade_list = nil;

game_layer.ting_cards = {};
game_layer.table_remain_card_count={};

game_layer.touch_enable = true;

game_layer.int_game_status = 0;
game_layer.table_user_seat = {};
game_layer.selfSeat = -1;
game_layer.isGetSeat = false;
game_layer.isCanChangeSeat = false;
game_layer.table_wait_init = {};
--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------
function game_layer.init(layer, visibleSize)
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("resources/table.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("resources/finish.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("resources/flash.plist");
    CCSpriteFrameCache:sharedSpriteFrameCache():addSpriteFramesWithFile("resources/G_noble.plist");

    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/dh_zbz.ExportJson")    
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/dh_shaizi.ExportJson")
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/dh_jn_minglou.ExportJson")
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/dh_mj_hupai.ExportJson")
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/mj_fuzhoumajiang_jiesuan.ExportJson")
    CCArmatureDataManager:sharedArmatureDataManager():addArmatureFileInfo("resources/armature/fuzhoumajiang_animation.ExportJson") 

game_layer.table_s_handle={
HandleTypeS.HT_MJ_NULL,
HandleTypeS.HT_MJ_NULL,
HandleTypeS.HT_MJ_LEFTCHI,
HandleTypeS.HT_MJ_ZHONGCHI,
HandleTypeS.HT_MJ_RIGHTCHI,
HandleTypeS.HT_MJ_PENG,
HandleTypeS.HT_MJ_MINGGANG1,
HandleTypeS.HT_MJ_NULL,
HandleTypeS.HT_MJ_NULL,
HandleTypeS.HT_MJ_ANGANG,
HandleTypeS.HT_MJ_MINGGANG2,
HandleTypeS.HT_MJ_HU,
}
    
    game_layer.layer = layer;
    game_layer.visibleSize = visibleSize;
    game_layer.layer:setContentSize(visibleSize);
    frame_tools:set_game_status(GameStatus.free);

    game_layer.scale_height = visibleSize.height / 750;
    -- 手牌相对于屏幕尺寸的缩放
    game_layer.HAND_CARD_SCALE = visibleSize.width / 1334.0 * 1.05;

    for i=1,58 do
        game_layer.table_remain_card_count[i]=4;
    end

    game_layer.screenGap = 0;
    if visibleSize.width/visibleSize.height > 17/9 then
        game_layer.screenGap = 60;
    end

    -- 初始化背景
    game_layer.init_back_ground(visibleSize);
    -- 牌
    game_layer.init_card_layer(visibleSize)
    -- 按钮
    game_layer.init_table_btn(visibleSize);
    -- 初始化头像
    game_layer.init_game_user_layer(visibleSize);
    -- 
    game_layer.init_game_time(visibleSize);
    -- 初始化礼物发送
    game_layer.init_gift_play_layer(visibleSize)
    -- 初始化不知道什么东西
    game_layer.init_chat_info(visibleSize);
    -- 初始化聊天界面
    game_layer.init_chat_layer(visibleSize);
    -- 菜单
    game_layer.init_right_bar_layer(visibleSize);
    -- 初始化结束界面
    game_layer.init_finish_layer(visibleSize)
    --
    game_layer.init_loot_img(visibleSize);
    --
    game_layer.init_new_player_hint(visibleSize);
    -- 确认退出
    game_layer.init_back_layer(visibleSize);

    function call_back()
        audio_engine.playBackground("back")
    end
    game_layer.layer:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(0.1),CCCallFunc:create(call_back)))

    game_layer.ready_lock = ready_clock:create();
    game_layer.layer:addChild(game_layer.ready_lock);
    game_layer.ready_lock:setPosition(ccp(-1000,-1000));

--[[    test_armature = CCArmature:create("dh_mj_hupai")
    test_armature:setPosition(ccp(visibleSize.width / 2, visibleSize.height / 2))
    game_layer.layer:addNode(test_armature);
    test_armature:getAnimation():play("dh_mj_hupai",-1,-1,-1,-1);
    test_armature:getAnimation():stop();
    test_armature:getAnimation():play("dh_mj_hupai",-1,-1,1,-1); 

    sprite = CCSprite:create()
    sprite:setPosition(ccp(visibleSize.width/2, visibleSize.height/2))
    game_layer.layer:addNode(sprite)

    local aniShuLei = CCAnimation:create();
    for i=1,12 do
        local sprite = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("FX_SD_"..i..".png");
        aniShuLei:addSpriteFrame(sprite);
    end
    aniShuLei:setDelayPerUnit(0.1);
    aniShuLei:setRestoreOriginalFrame(true);
    local animaShuLei = CCAnimate:create(aniShuLei)
    sprite:runAction(animaShuLei);  ]]

--    game_layer.new_player_hint:show_hint(1);
end

function game_layer.init_back_ground(visibleSize)
    game_layer._3d_table_layer = UIHelper.create_img(game_layer.layer, ccp(visibleSize.width/2, visibleSize.height/2), nil)
    table_3d_layout:init(game_layer._3d_table_layer,visibleSize)

    table_3d_layout:showDirectionClock(true);

    -- logo
    game_layer.logo = UIHelper.create_img(game_layer.layer, ccp(visibleSize.width/2, visibleSize.height /2 + 110), "logo_table.png",1)

    -- 房间号
    game_layer.table_id_bg = UIHelper.create_img(game_layer.layer, ccp(visibleSize.width/2, visibleSize.height - 17), "room_id_bg.png",1)
    game_layer.table_id_bg:setScale(UI_SCALE);
    game_layer.table_id_bg:setVisible(false);
    game_layer.table_id = UIHelper.create_label(game_layer.table_id_bg, ccp(0, 0), 30, ccc3(173, 244, 253))

    --连庄
    game_layer.label_lian_zhuang = UIHelper.create_label(game_layer.layer,ccp(visibleSize.width/2, visibleSize.height/2 - 33),24,ccc3(11, 58, 62));
    game_layer.label_lian_zhuang:setVisible(false);
    --好友房底分
    game_layer.friends_base_label=UIHelper.create_label(game_layer.layer,ccp(visibleSize.width/2,visibleSize.height/2 - 33),24,ccc3(11, 58, 62));
    game_layer.friends_base_label:setVisible(false);

    game_layer.game_hint_bg =  UIHelper.create_img(game_layer.layer, ccp(visibleSize.width/2, 60), "hint_bg.png",1)
    game_layer.game_hint = UIHelper.create_label(game_layer.game_hint_bg, ccp(0, -1), 24, ccc3(51, 169, 173))
    game_layer.game_hint:setText("温馨提示：游戏开始前解散房间不扣房卡")
    game_layer.game_hint_bg:setVisible(false);
end

function game_layer.init_right_bar_layer(visibleSize)
    game_layer.menu_bar = menu_bar:create(visibleSize)
    game_layer.layer:addChild(game_layer.menu_bar)

    game_layer.menu_bar:setPosition(ccp(game_layer.screenGap - visibleSize.width/2 + 45 ,visibleSize.height/2 - 45));
end

function game_layer.init_new_player_hint(visibleSize)
    game_layer.new_player_hint = new_player_hint:create(visibleSize);
    game_layer.layer:addChild(game_layer.new_player_hint)

end

function game_layer.init_back_layer( visibleSize )
    game_layer.dissolve_layer = dissolve_layer:create(visibleSize)
    game_layer.layer:addChild(game_layer.dissolve_layer)

    game_layer.help_layer = help_layer:create(visibleSize)
    game_layer.layer:addChild(game_layer.help_layer)

    game_layer.back_layer = back_layer:create(visibleSize)
    game_layer.layer:addChild(game_layer.back_layer)
end

function game_layer.init_gift_play_layer( visibleSize )
    game_layer.gift_play = gift_play:create(visibleSize)
    game_layer.layer:addChild(game_layer.gift_play)
end

function game_layer.init_finish_layer( visibleSize )
    game_layer.finish_layer = finish_layer:create(visibleSize)
    game_layer.layer:addChild(game_layer.finish_layer)

    game_layer.liuju_armature = CCArmature:create("mj_fuzhoumajiang_jiesuan")
    if not game_layer.liuju_armature then
        return;
    end
    game_layer.liuju_armature:setPosition(ccp(visibleSize.width/2, visibleSize.height/2 + 100));
    game_layer.layer:addNode(game_layer.liuju_armature);
    game_layer.liuju_armature:setVisible(false);
end

function game_layer.play_liuju(args)
    if not game_layer.liuju_armature then
        return;
    end

    if args then
        game_layer.liuju_armature:setVisible(true);
        game_layer.liuju_armature:getAnimation():playWithIndex(3,-1,-1,0);
    else
        game_layer.liuju_armature:setVisible(false);
    end
end

function game_layer.show_loot_img()
    local c = require "cjson"
    local room_json = frame_tools:get_room_data()
    if room_json.room_mode == ROOM_MODE_FRIEND then
        return;
    end
    local version = frame_tools:bpversion();
    if version < 113 then
        return;
    end

    local mask1 = 0
    local mask2 = 0
    if get_module_mask then
        mask1 = get_module_mask();
    end
    if get_module_mask2 then
        mask2 = get_module_mask2();
    end
    
    local is_show_hint = false;
    local is_show_point = false;
    local firstTime = os.date("%Y%m%d") .. "08"
    local secondTime = os.date("%Y%m%d") .. "18"
    local curTime = os.date("%Y%m%d%H")

    local lastTime = frame_tools:get_config_value("fzmj_lastTime","-1")
    if curTime >= secondTime and  lastTime < secondTime then
--        is_show_hint = true;
    end
    if curTime >= firstTime and  lastTime < firstTime then
        is_show_hint = true;
        is_show_point =true;
    end
    if bit._and(mask1, MASK_MODULE_EXCHANGE) > 0 then
--        if  bit._and(mask2, MASK_MODULE2_EXCHANGE_LOOT) > 0 then
              if is_show_hint then
--                  game_layer.img_loot_hint:setVisible(true);
--                  game_layer.play_aniUpOut(game_layer.img_loot_hint,ccp(game_layer.img_loot_hint:getPositionX(), game_layer.img_loot_hint:getPositionY() ) );
              end
--        end
        if is_show_hint then
            game_layer.img_loot_point:setVisible(true);
        end
        game_layer.img_loot:setVisible(true);
    else
        game_layer.img_loot:setVisible(false);
    end

    if game_layer.btn_game_task:isVisible() == false then
        game_layer.img_loot:setPosition(ccp(game_layer.top_btn_x, game_layer.top_btn_y) );
    end

    frame_tools:set_config_value("fzmj_lastTime", curTime);

--    frame_tools:set_config_value("fzmj_lastTime", 0);
end

function game_layer.init_loot_img(visibleSize)
    game_layer.top_btn_x = 115 + game_layer.screenGap;
    game_layer.top_btn_y = visibleSize.height - 45
    -- 任务
    game_layer.btn_game_task = UIButtonExSmall:create();
    game_layer.layer:addChild(game_layer.btn_game_task);
    game_layer.btn_game_task:loadTextureNormal("228_task.png",1);
    game_layer.btn_game_task:setPosition(ccp(game_layer.top_btn_x, game_layer.top_btn_y));
    game_layer.btn_game_task:addTouchEventListener(function(sender, touchType) game_layer.on_btn_task(sender, touchType) end);
    game_layer.btn_game_task:setTouchEnabled(true);

    local c = require "cjson"
    local room_json = frame_tools:get_room_data()
    if room_json.room_mode == ROOM_MODE_FRIEND then
        game_layer.btn_game_task:setVisible(false);
    else 
        if game_layer.get_version() >= 112 and get_module_mask and bit._and(get_module_mask(),0x00010000)>0 then
            game_layer.btn_game_task:setVisible(true);
        else
            game_layer.btn_game_task:setVisible(false);
        end
    end

    game_layer.img_task_point =  UIHelper.create_img(game_layer.btn_game_task, ccp(25, 25), "228_red_point.png",1);
    game_layer.img_task_point:setVisible(false);

    --兑换
    game_layer.img_loot = UIButtonExSmall:create();
    game_layer.layer:addChild(game_layer.img_loot);
    game_layer.img_loot:setPosition(ccp(game_layer.top_btn_x + 70, game_layer.top_btn_y));
    game_layer.img_loot:loadTextureNormal("228_loot.png",1);
    game_layer.img_loot:addTouchEventListener(function(sender, touchType) game_layer.OnBtnLoot(sender, touchType) end);
    game_layer.img_loot:setTouchEnabled(true);
    game_layer.img_loot:setVisible(false);

--    game_layer.img_loot_hint =  UIHelper.create_img(game_layer.img_loot, ccp(80, -50), "loot_hint.png",1);
--    game_layer.img_loot_hint:setVisible(false);
    game_layer.img_loot_point =  UIHelper.create_img(game_layer.img_loot, ccp(25, 25), "228_red_point.png",1);
    game_layer.img_loot_point:setVisible(false);
    --
    game_layer.show_loot_img(game_layer.visibleSize);

    --连胜
    game_layer.btn_win_streak = UIButtonExSmall:create();
    game_layer.layer:addChild(game_layer.btn_win_streak);
    game_layer.btn_win_streak:loadTextureNormal("228_ls_btn.png",1);
    game_layer.btn_win_streak:setPosition(ccp(game_layer.top_btn_x + 70*2, game_layer.top_btn_y + 5));
    game_layer.btn_win_streak:addTouchEventListener(function(sender, touchType) game_layer.on_btn_win_streak(sender, touchType) end);
    game_layer.btn_win_streak:setTouchEnabled(true);
    game_layer.btn_win_streak:setVisible(false);

    game_layer.layer_winning_streak = winning_streak:create();
    game_layer.layer:addChild(game_layer.layer_winning_streak);
--    game_layer.layer_winning_streak:set_btn_position(ccp(game_layer.top_btn_x + 70*2, game_layer.top_btn_y + 5));
    game_layer.layer_winning_streak:setVisible(false);

    game_layer.layer_winning_streak:set_self_head_position(game_layer.game_user.player_pos[VIEW_INDEX_SELF]);

    game_layer.table_week_index = { 0x0040,0x0001,0x0002,0x0004,0x0008,0x0010,0x0020 };
end

function game_layer.show_win_streak(isShow)
    if isShow == false then
        game_layer.btn_win_streak:setVisible(false);
        game_layer.layer_winning_streak:setVisible(false);
        return;
    end

    local btn_x = game_layer.top_btn_x;
    local btn_y = game_layer.top_btn_y + 5;

    if game_layer.btn_game_task:isVisible() == true then
        btn_x = btn_x + 70;
    end
    if game_layer.img_loot:isVisible() == true then
        btn_x = btn_x + 70;
    end
    
    game_layer.btn_win_streak:setPosition(ccp(btn_x + 5, btn_y));
    game_layer.layer_winning_streak:set_btn_position(ccp(btn_x + 5, btn_y));

    game_layer.btn_win_streak:setVisible(true);
    game_layer.layer_winning_streak:setVisible(true);

--    game_layer.layer_winning_streak:show_tips(1);
end

function game_layer.OnBtnLoot(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    audio_engine.playEffect(-1)

--    game_layer.img_loot_hint:stopAllActions();
--    game_layer.img_loot_hint:setVisible(false);
    game_layer.img_loot_point:setVisible(false);

    local mask2 = 0
    if get_module_mask2 then
        mask2 = get_module_mask2();
    end
    
    if  bit._and(mask2, MASK_MODULE2_EXCHANGE_LOOT) > 0 then
        frame_tools:on_do_task("open:14");
    else
        frame_tools:on_do_task("open:6");
    end
end

function game_layer.init_table_btn(visibleSize)
    --托管界面
    game_layer.trust_layer=Layout:create();
    game_layer.layer:addChild(game_layer.trust_layer);
    game_layer.trust_layer:setSize(visibleSize)
    game_layer.trust_layer:setTouchEnabled(false)
    game_layer.trust_layer:setVisible(false);

    local float_new_height = (CardInfo.CARD_RESOURCE_HEIGHT) * game_layer.HAND_CARD_SCALE + 20;
    game_layer.trust_bg=UIHelper.create_img(game_layer.trust_layer, ccp(visibleSize.width/2, float_new_height/2), "trust_bg.png",1)
    game_layer.trust_bg:setScaleX(visibleSize.width/game_layer.trust_bg:getContentSize().width)
    game_layer.trust_bg:setScaleY(float_new_height/game_layer.trust_bg:getContentSize().height)
    game_layer.trust_bg:setTouchEnabled(true)
    --托管按钮
    game_layer.btn_no_trust=button_event:create(ButtonEventName.btn_no_trust,ButtonEventType.btn_no_trust);
    game_layer.btn_no_trust:setPosition(ccp(game_layer.visibleSize.width/2,float_new_height/2))
    game_layer.trust_layer:addChild(game_layer.btn_no_trust)
    game_layer.btn_no_trust:setScale(UI_SCALE * 0.7); 
    --提示
    game_layer.trust_hint = UIHelper.create_img(game_layer.trust_layer, ccp(visibleSize.width/2, float_new_height/2 - 35), "trust_hint.png",1)
    game_layer.trust_hint:setScale(UI_SCALE * 0.7); 
    --等待其他操作提示
    game_layer.img_wait_tips=UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2, 60),"wait_for_other.png",1);
    game_layer.img_wait_tips:setVisible(false);
    --分张
    game_layer.img_fen_zhang_hint = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2, 60),"228_hint_fen_zhang.png",1);
    game_layer.img_fen_zhang_hint:setVisible(false);
    --庄家出牌提示
    game_layer.img_banker_out_hint = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2, float_new_height - 4),"228_hint_banker_out.png",1);
    game_layer.img_banker_out_hint:setVisible(false);

    --准备按钮
    game_layer.ptr_btn_start = button_event:create(ButtonEventName.ready,ButtonEventType.ready);
    game_layer.ptr_btn_start:setPosition(ccp(visibleSize.width / 2 + 150, 250))
    game_layer.layer:addChild(game_layer.ptr_btn_start)
    game_layer.ptr_btn_start:setScale(UI_SCALE);    
    --换桌按钮
    game_layer.ptr_btn_changetable = button_event:create(ButtonEventName.btn_changetable,ButtonEventType.btn_changetable);
    game_layer.ptr_btn_changetable:setPosition(ccp(visibleSize.width / 2 - 150, 250))
    game_layer.layer:addChild(game_layer.ptr_btn_changetable)
    game_layer.ptr_btn_changetable:setScale(UI_SCALE);
    --邀请按钮
    game_layer.btn_invite = button_event:create(ButtonEventName.btn_invite, ButtonEventType.btn_invite)
    game_layer.btn_invite:setPosition(ccp(visibleSize.width/2 - 150, 250))
    game_layer.layer:addChild(game_layer.btn_invite)
    game_layer.btn_invite:setScale(UI_SCALE);
    --战绩
    game_layer.btn_grade = button_event:create(ButtonEventName.btn_grade, ButtonEventType.btn_grade)
    game_layer.btn_grade:setPosition(ccp(visibleSize.width / 2, 250))
    game_layer.layer:addChild(game_layer.btn_grade)
    game_layer.btn_grade:setScale(UI_SCALE);
    --聊天
    game_layer.btn_chat = button_event:create(ButtonEventName.btn_chat, ButtonEventType.btn_chat)
    game_layer.btn_chat:setPosition(ccp(visibleSize.width - 40 - game_layer.screenGap, 135))
    game_layer.layer:addChild(game_layer.btn_chat)
    --听牌结果按钮
    game_layer.btn_ting_layer = button_event:create(ButtonEventName.btn_ting_layer, ButtonEventType.btn_ting_layer)
    game_layer.btn_ting_layer:setPosition(ccp(visibleSize.width - 120 - game_layer.screenGap, 136))
    game_layer.layer:addChild(game_layer.btn_ting_layer)
    game_layer.btn_ting_layer:setScale(0.88);
--    game_layer.btn_ting_layer:setVisible(true);
    --结算界面按钮
    game_layer.btn_finish_layer = button_event:create(ButtonEventName.btn_finish_layer, ButtonEventType.btn_finish_layer)
    game_layer.btn_finish_layer:setPosition(ccp(visibleSize.width - 120 - game_layer.screenGap, 136))
    game_layer.layer:addChild(game_layer.btn_finish_layer)
    game_layer.btn_finish_layer:setScale(0.88);
--    game_layer.btn_finish_layer:setVisible(true);
end

function game_layer.init_game_time(visibleSize)
    -- 分张提醒
    game_layer.hint_leave_count_bg = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2,visibleSize.height*3/4),"hint_for_count.png",1)
    game_layer.hint_leave_count_bg:setVisible(false);
    game_layer.hint_leave_count_bg:setScale(game_layer.HAND_CARD_SCALE);

    game_layer.hint_leave_count = UIHelper.create_labelBM(game_layer.hint_leave_count_bg,"resources/number_gold/number_fuzhoumajiang_tishi.fnt",ccp(27,-6));
    game_layer.hint_leave_count:setText("8");
    -- 等待提醒
    local local_height = (CardInfo.CARD_RESOURCE_HEIGHT + 20) * game_layer.HAND_CARD_SCALE;
    game_layer.hint_wait_other_handle = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2,local_height),"wait_for_other.png",1);
    game_layer.hint_wait_other_handle:setVisible(false);
    game_layer.hint_wait_other_handle:setScale(game_layer.HAND_CARD_SCALE);
    -- 剩余局数
    game_layer.left_count_bg = button_event:create(ButtonEventName.grade, ButtonEventType.grade)
    game_layer.left_count_bg:setPosition(ccp(75 + game_layer.screenGap, visibleSize.height - 122))
    game_layer.layer:addChild(game_layer.left_count_bg)
    game_layer.left_count_bg:setVisible(false);
    game_layer.left_count_bg:setScale(UI_SCALE);

    game_layer.left_count = UIHelper.create_labelBM(game_layer.left_count_bg, "resources/number_gold/num_syjs.fnt", ccp(5, -2))
    game_layer.count = UIHelper.create_img(game_layer.left_count_bg, ccp(5, 0), "", 0, ccp(-1.1, 0.5))
    game_layer.count:loadTexture("count.png",1)
    game_layer.left_count:setText(tostring("1/4"))

    game_layer.tips_bg=UIHelper.create_img(game_layer.layer, ccp(90 + game_layer.screenGap, visibleSize.height - 165), "tips_bg.png",1)
    game_layer.tips_bg:setScale(UI_SCALE);
    game_layer.tips=UIHelper.create_label(game_layer.tips_bg,ccp(0,-5),28,ccc3(117,64,50))
    game_layer.tips:setText("点击查看战绩")
    game_layer.tips_bg:setVisible(false);
    game_layer.tips_bg:setTag(0);

    --剩余牌数
    game_layer.left_card_bg = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width - 65 - game_layer.screenGap,visibleSize.height - 85),"left_card_bg.png",1)
    game_layer.left_card_bg:setVisible(false);
    game_layer.left_card_bg:setScale(UI_SCALE)

    game_layer.left_card_count=UIHelper.create_labelBM(game_layer.left_card_bg,"resources/number_gold/num_syzs.fnt",ccp(0,0),ccp(0.5,0.5));
    game_layer.left_card_count:setText("剩123张")
    --连庄
--    game_layer.lian_zhuang_bg = UIHelper.create_img(game_layer.layer,ccp(65 + game_layer.screenGap,visibleSize.height - 155),"lianzhuang.png",1)
--    game_layer.lian_zhuang_bg:setVisible(false);
--    game_layer.lian_zhuang_bg:setScale(UI_SCALE)

--    game_layer.lian_zhuang_count=UIHelper.create_labelBM(game_layer.lian_zhuang_bg,"resources/number_gold/number_fuzhoumajiang_lianzhuang.fnt",ccp(25,-2),ccp(0.5,0.5));
--    game_layer.lian_zhuang_count:setText("x1")
    -- 时间 wifi 电量
    game_layer.time_bg = UIHelper.create_img(game_layer.layer, ccp(visibleSize.width - 48 - game_layer.screenGap, visibleSize.height - 35), "time_bg.png",1)
    game_layer.time_bg:setScale(UI_SCALE);
    local wifi_or_not = frame_tools:get_wifi_status() == 0 and "signal.png" or "wifi.png"
    local wifi = UIHelper.create_img(game_layer.time_bg, ccp(-20, 13), wifi_or_not, 1)
    local battary_bg = UIHelper.create_img(game_layer.time_bg, ccp(18, 13), "battary.png",1)
    local battary = UIHelper.create_img(battary_bg, ccp(-17, 0), "battary_1.png",1, ccp(0, 0.5))
    local clock = UIHelper.create_label(game_layer.time_bg, ccp(0, -10), 22)
    local temp_time = 1
    local temp_second = 0
    local function step(dt)
        local c = require "cjson"
        local local_time = frame_tools:get_current_time()
        if local_time == nil then
            return 
        end
        local hour = string.format("%02d", local_time.hour)
        local minute = string.format("%02d", local_time.minute)
        clock:setText( hour .. ":" .. minute)
        temp_time = temp_time + dt
        temp_second = temp_second + dt
        game_layer.current_second = temp_second
        if temp_time > 1 then
            temp_time = 0
            UIHelper.setBattary(battary)
            UIHelper.setWifi(wifi)
        end
    end
    game_layer.layer:scheduleUpdateWithPriorityLua(step, 0);

    
    -- 财神牌
    game_layer.caishen_layer = UIHelper.create_img(game_layer.layer,ccp(0, 0));

    game_layer.caishen_bg = UIHelper.create_img(game_layer.caishen_layer, ccp(visibleSize.width - 48 - game_layer.screenGap, visibleSize.height - 158), "caishen_bg.png",1)
    game_layer.caishen_bg:setScale9Enabled(true);
    game_layer.caishen_bg:setSize(CCSize(72,94));
    game_layer.caishen_bg:setVisible(false)

    game_layer.caishen_img = cards_3d_layout:getNewHandCard(true)
    game_layer.caishen_img:setScale(0.8)
    game_layer.caishen_img:setPosition(ccp(visibleSize.width - 48 - game_layer.screenGap, visibleSize.height - 157 - 3));
    game_layer.caishen_layer:addChild(game_layer.caishen_img);
    game_layer.caishen_img:showCard(11);
    game_layer.caishen_img:setVisible(false);

    -- 听牌提示
    game_layer.ting_hint_layer = ting_hint_layer:create(visibleSize);
    game_layer.layer:addChild(game_layer.ting_hint_layer)

--    game_layer.ting_hint_layer:set_hu_card({1},{{15,16}},2);
--    game_layer.ting_hint_layer:setVisible(true);
    -- 骰子
    game_layer.tou_zi = {}

    for i=1,2 do
        local tou_zi = CCArmature:create("dh_shaizi")
        if tou_zi == nil then
            break;
        end
        tou_zi:setPosition(ccp(visibleSize.width/2, visibleSize.height/2 + 30))
        tou_zi:setVisible(false)
        tou_zi:getAnimation():playWithIndex(i*4)
        game_layer.layer:addNode(tou_zi)
        table.insert(game_layer.tou_zi,tou_zi);
    end 

end

function game_layer.on_btn_task(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    audio_engine.playEffect(-1)
    
    frame_tools:on_do_task("open:5")
    
end

function game_layer.on_btn_win_streak(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    audio_engine.playEffect(-1)

    if game_layer.ws_day == nil or game_layer.ws_day == 0 then
        return;
    end

    local day_index = tonumber( os.date("%w") ) + 1;
    local hour_index = tonumber( os.date("%H") );

    local hint_text = nil;
    local is_start = true;

    if bit._and(game_layer.ws_day, game_layer.table_week_index[day_index]) <= 0 then
        is_start = false
    else
        if hour_index < game_layer.ws_start or hour_index >= game_layer.ws_end then
            is_start = false
        end
    end

    local table_week_index = { 0x0001,0x0002,0x0004,0x0008,0x0010,0x0020,0x0040 };
    local day_text = {"一","二","三","四","五","六","日"};
    if is_start == false then
        for i=1,7 do
            if bit._and(game_layer.ws_day, table_week_index[i]) > 0 then
                if hint_text == nil then
                    hint_text = "周" .. day_text[i];
                else
                    hint_text = hint_text .. "/" .. day_text[i];
                end
            end
        end

        hint_text = hint_text .." ".. game_layer.ws_start ..":00 开启挑战"

        game_layer.layer_winning_streak:show_tips_string(hint_text)

        return;
    end

    if game_layer.ws_award_count >= game_layer.ws_max_award_count then
        game_layer.layer_winning_streak:show_tips(3, game_layer.ws_max_award_count);
        return;
    end
   
    game_layer.layer_winning_streak:show_windows()
end

function game_layer.init_chat_info(param)
    game_layer.string_chat = {
                    [1] = "打一个来碰下呗！", 
                    [2] = "时间就是金钱我的朋友~", 
                    [3] = "你的牌打的太好了", 
                    [4] = "快点出牌啊，脑子转快点嘛！", 
                    [5] = "今天这麻将有问题吧，打什么摸什么", 
                    [6] = "好歹让我吃一个吧！", 
                    [7] = "哎呦，好运来了挡也挡不住~", 
                    [8] = "呵，烂牌起手我也要胡它个十七八百！", 
                    [9] = "风水轮流转~", 
                    [10] = "小胡也是胡，苍蝇蚊子都是肉！", 
                   }
    local cjson = require "cjson"
    init_game_chat(cjson.encode(game_layer.string_chat))
end

function game_layer.init_chat_layer(param)
    local player_pos = {ccp(game_layer.game_user.player_background[1]:getPositionX(), game_layer.game_user.player_background[1]:getPositionY() + 35), 
                        ccp(game_layer.game_user.player_background[2]:getPositionX() + 150 , game_layer.game_user.player_background[2]:getPositionY()),
                        ccp(game_layer.game_user.player_background[3]:getPositionX(), game_layer.game_user.player_background[3]:getPositionY()),
                        ccp(game_layer.game_user.player_background[4]:getPositionX(), game_layer.game_user.player_background[4]:getPositionY())}
    local chat_pos = {  [1] = ccp(game_layer.game_user.player_background[1]:getPositionX() - 45, game_layer.game_user.player_background[1]:getPositionY() - 20), 
                        [2] = ccp(game_layer.game_user.player_background[2]:getPositionX() - 45, game_layer.game_user.player_background[2]:getPositionY() - 60), 
                        [3] = ccp(game_layer.game_user.player_background[3]:getPositionX() + 45, game_layer.game_user.player_background[3]:getPositionY() + 20), 
                        [4] = ccp(game_layer.game_user.player_background[4]:getPositionX() + 45, game_layer.game_user.player_background[4]:getPositionY() + 70)}
    local emotion_pos = {[1] = ccp(game_layer.game_user.player_background[1]:getPositionX(), game_layer.game_user.player_background[1]:getPositionY() + 10), 
                         [2] = ccp(game_layer.game_user.player_background[2]:getPositionX(), game_layer.game_user.player_background[2]:getPositionY() + 10), 
                         [3] = ccp(game_layer.game_user.player_background[3]:getPositionX(), game_layer.game_user.player_background[3]:getPositionY() + 10), 
                         [4] = ccp(game_layer.game_user.player_background[4]:getPositionX(), game_layer.game_user.player_background[4]:getPositionY() + 10)}
    local direction = {[1] = ChatDirection.right_top, 
                        [2] = ChatDirection.right_top, 
                        [3] = ChatDirection.left_down, 
                        [4] = ChatDirection.left_down}
    if param == 1 then
        chat_pos = {  [1] = ccp(game_layer.game_user.player_background[1]:getPositionX() - 40, game_layer.game_user.player_background[1]:getPositionY() - 60), 
                        [2] = ccp(game_layer.game_user.player_background[2]:getPositionX() - 45, game_layer.game_user.player_background[2]:getPositionY() - 60), 
                        [3] = ccp(game_layer.game_user.player_background[3]:getPositionX() + 45, game_layer.game_user.player_background[3]:getPositionY() + 70), 
                        [4] = ccp(game_layer.game_user.player_background[4]:getPositionX() + 45, game_layer.game_user.player_background[4]:getPositionY() + 70)}
        direction = {[1] = ChatDirection.right_top, 
                        [2] = ChatDirection.right_top, 
                        [3] = ChatDirection.left_down, 
                        [4] = ChatDirection.left_down}
    end
    local cjson = require "cjson"
    local value = {}
    for i=1, GAME_PLAYER do
        local tbl = {}
        tbl.text_x = chat_pos[i].x
        tbl.text_y = chat_pos[i].y
        tbl.em_x = emotion_pos[i].x
        tbl.em_y = emotion_pos[i].y
        tbl.direction = direction[i]
        table.insert(value, tbl)
    end
    if init_chat_play then
        init_chat_play(cjson.encode(value))
    end
end

function game_layer.init_card_layer(visibleSize)
    game_layer.touch_layer = UIHelper.create_img(game_layer.layer,ccp(visibleSize.width/2, visibleSize.height/2));
    game_layer.touch_layer:setScale9Enabled(true);
    game_layer.touch_layer:setSize(visibleSize);
    game_layer.touch_layer:setTouchEnabled(true);
    
    game_layer._3d_card_layer=UIHelper.create_img(game_layer.layer, ccp(0, 0), nil);
    cards_3d_layout:init(game_layer._3d_card_layer,visibleSize,table_3d_layout,4,MAX_HANDCARD_COUNT);
    LayoutConfig.show_heap_arrow = true;
    LayoutConfig.tile_hua_card = true;
    LayoutConfig.show_card_value_on_dark_gang = false;

    game_layer.card_layer = card_layer:create(visibleSize)
    game_layer.layer:addChild(game_layer.card_layer)

    cards_3d_layout:setHandleClickedFunc(function(args)
        game_layer.onclick_handle_btn(args)
    end)

    cards_3d_layout:setClickCardFunc(function(args)
        game_layer.onclick_card_once(args)
    end)

    local function touchEvent(sender, eventType)
        game_layer.touch_event(sender, eventType)
    end
    game_layer.touch_layer:addTouchEventListener(touchEvent)
end

function game_layer.init_game_user_layer( visibleSize )
    game_layer.game_user = game_user:create(visibleSize)
    game_layer.game_user:setPosition(ccp(0, 0))
    game_layer.layer:addChild(game_layer.game_user)
end

function game_layer.switch_view_to_feng(int_view_id)
    if (int_view_id <= game_layer.banker_viewid) then
        return game_layer.banker_viewid - int_view_id + 1
    elseif (int_view_id > game_layer.banker_viewid) then
        return game_layer.banker_viewid - int_view_id + 1 + 4
    end
end

function game_layer.get_card_size(byte_card,byte_caishen_card)
    local card_size = byte_card;
    if byte_card == byte_caishen_card then
        card_size = 0;
    elseif  byte_card == 47 then
        card_size = byte_caishen_card;
    end

    return card_size;
end

function game_layer.sort_cards_by_size(byte_cards,int_count,byte_caishen_card)
    if int_count == 0 then
		return {}
    end
	
    for i = int_count,1,-1 do
        for j=1,i-1,1 do
            if byte_cards[j]~=byte_caishen_card then
                if game_layer.get_card_size(byte_cards[j],byte_caishen_card) > game_layer.get_card_size(byte_cards[j + 1],byte_caishen_card) then
                    byte_cards[j],byte_cards[j+1] = byte_cards[j+1],byte_cards[j]
                end            
            end
        end
    end

    return byte_cards;
end

function game_layer.sort_cards_by_size_reverse(byte_cards,int_count,byte_caishen_card)
    if int_count == 0 then
		return
    end
	
    for i=int_count,1,-1 do
        for j=1,i-1,1 do
            if byte_cards[j + 1]~=byte_caishen_card then
                if byte_cards[j] < byte_cards[j + 1] or byte_cards[j]==byte_caishen_card then
                    byte_cards[j],byte_cards[j+1] = byte_cards[j+1],byte_cards[j]
                end 
            end           
        end
    end
end

function game_layer.sort_zi_gang_by_size(byte_cards,int_count,byte_ming_pai)
    if int_count == 0 then
		return
    end
	
    for i=int_count,1,-1 do
        for j=1,i-1,1 do
            if byte_cards[j]~=byte_ming_pai then
                if byte_cards[j] > byte_cards[j + 1] or byte_cards[j + 1]==byte_ming_pai then
                    byte_cards[j],byte_cards[j+1] = byte_cards[j+1],byte_cards[j]
                end            
            end
        end
    end
end

function game_layer.switch_handle_type_to_client(s_type)
    if bit._and(s_type,HandleTypeS.HT_MJ_HU)>0 then
        return HandleType.hu;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_ANGANG)>0 then
        return HandleType.d_gang;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_MINGGANG1)>0 then
        return HandleType.b_gang;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_MINGGANG2)>0 then
        return HandleType.a_gang;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_PENG)>0 then
        return HandleType.b_peng;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_RIGHTCHI)>0 then
        return HandleType.b_chi_right;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_ZHONGCHI)>0 then
        return HandleType.b_chi_mid;
    elseif bit._and(s_type,HandleTypeS.HT_MJ_LEFTCHI)>0 then
        return HandleType.b_chi_left;
    end 
    return 0;
end

function game_layer.switch_handle_type_to_server(c_type)
    return game_layer.table_s_handle[c_type];
end

function game_layer.onclick_handle_btn(args)
    local table_data={};
    table_data["card"]=args.card_value;
    table_data["handle_type"]=game_layer.switch_handle_type_to_server(args.handle_type);
    table_data["from"]=game_layer.table_handle_type["from"];
    table_data["to"]=game_layer.table_handle_type["to"];

    if bit._and(game_layer.table_handle_type.handle_type, HandleTypeS.HT_MJ_DUOGANG)>0 then
        if args.handle_type == HandleType.a_gang or args.handle_type == HandleType.d_gang then
            table_data["handle_type"] = HandleTypeS.HT_MJ_DUOGANG;
        end
    end

    frame_tools:send_data(MessageType.SUB_C_OPERATION,table_data);

--    game_layer.other_turn();
    cards_3d_layout:unselectAllHandCards();
end

function game_layer.onclick_card_once(args)
    game_layer.hint_wait_other_handle:setVisible(false);
    audio_engine.hit_card_effect();
    for k,v in pairs(game_layer.ting_cards) do
        if v == args then
            game_layer.ting_hint_layer:set_hu_card(game_layer.ting_data[k].type,game_layer.ting_data[k].cards,game_layer.ting_data[k].count);
            game_layer.ting_hint_layer:setVisible(true);
			return;
        end
    end
    game_layer.ting_hint_layer:setVisible(false);
end

function game_layer.touch_event(sender, eventType)
    if eventType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    local touch_point = sender:getTouchEndPos();
    if touch_point.y > 200 and  game_layer.int_game_status == GameStatus.out_card then
        cards_3d_layout:unselectAllHandCards();
        game_layer.ting_hint_layer:setVisible(false);
    end
    if game_layer.menu_bar.is_open == true then
        game_layer.menu_bar:show_right_bar();
    end
    game_layer.layer_winning_streak:show_windows(false);
end

function game_layer.other_turn(args)
    cards_3d_layout:setHandCardsCanOut(false)
    cards_3d_layout:unselectAllHandCards();
    cards_3d_layout:setHandCardsTingByValue();
    cards_3d_layout:setHandCardsTingDuoByValue();
    cards_3d_layout:setHandCardsTingDaByValue();
    cards_3d_layout:hideHandleSelect();

    game_layer.hint_wait_other_handle:setVisible(false);
    game_layer.ting_hint_layer:setVisible(false);
end

function game_layer.get_remain_card_count(byte_card)
    local card_count = game_layer.table_remain_card_count[byte_card - 10]

    local table_hand_cards = game_layer.card_layer:get_hand_cards();
    for k,v in pairs(table_hand_cards) do
        if v == byte_card then
            card_count = card_count-1;
        end
    end
    
    return card_count
end

function game_layer.set_head_able(args)
    if args == nil then
        args = true;
    end
    
    game_layer.touch_enable = args;
end

-----------------------------------------------------------------------------------------------------

function game_layer.on_game_user_status(userid, chairid, look, offline)
    local c = require "cjson"
    local table_json = frame_tools:get_user_data(chairid)
    if table_json == nil then
        return
    end
        
    if table_json.user_status == 0x03 then -- 准备状态
        if chairid ~= frame_tools:get_self_chair_id() then
            game_layer.game_user:set_clock(UIHelper.switch_to_view_id(chairid),-1,-1);
            game_layer.game_user:set_status(UIHelper.switch_to_view_id(chairid), UserStatus.ready)
            game_layer.set_play_effect = game_layer.set_play_effect or false
            if game_layer.set_play_effect == true then
                audio_engine.ready_effect()
            end
        end
    end

    if ROOM_MODE == ROOM_MODE_FRIEND then
        game_layer.game_user:turn_outline_status(UIHelper.switch_to_view_id(chairid), table_json.user_status ~= PlayerStatus.us_offline)
    end
end


function game_layer.on_game_user_enter(userid, chairid, look)
    local c = require "cjson"
    local table_json = frame_tools:get_user_data(chairid)
    local room_json = frame_tools:get_room_data()

    ROOM_KIND=room_json.room_kind
    TABLE_ID = table_json.table_id
    ROOM_MODE=room_json.room_mode
    
    SELFCHAIRID = frame_tools:get_self_chair_id();

    if chairid ~= SELFCHAIRID then
        table.insert(game_layer.table_wait_init, chairid);
    else
       
    end

    game_layer.table_user_name[chairid + 1]=table_json.nickname 

    if chairid == SELFCHAIRID or game_layer.isGetSeat then
        local viewid = UIHelper.switch_to_view_id(chairid)
        if chairid == SELFCHAIRID then
            viewid = VIEW_INDEX_SELF;
        end
        if (viewid == -1) then 
            if write_online_logs then
                write_online_logs("on_game_user_enter，viewid = -1,selfseat:"..game_layer.selfSeat);
            end
            return;
        end

        game_layer.game_user:show_user(viewid, true)
        game_layer.game_user:set_sex(viewid, table_json.user_id, table_json.face_id, table_json.sex)
        game_layer.game_user:set_name(viewid,table_json.nickname);
        game_layer.game_user:set_identity(viewid,-1);
        game_layer.game_user:set_vip(viewid,table_json.member);
        if ROOM_MODE == ROOM_MODE_FRIEND then
            game_layer.game_user:turn_outline_status(viewid, table_json.user_status ~= PlayerStatus.us_offline);
        end
--        if bit._and(ROOM_KIND,ROOM_KIND_SCORE)>0 then
--            game_layer.game_user:set_score(viewid, table_json.socre)
--        else
--            game_layer.game_user:set_gold(viewid, table_json.gold)
--        end

        if table_json ~= nil and table_json.user_status == 0x03 then -- 准备状态
            if viewid ~= VIEW_INDEX_SELF then
                game_layer.game_user:set_status(viewid, UserStatus.ready)
            end
        else 
            if ROOM_MODE ~= ROOM_MODE_FRIEND then
                if viewid ~= VIEW_INDEX_SELF then
                    if game_layer.ready_time > 0 then
                        game_layer.game_user:set_clock(viewid,game_layer.ready_time,game_layer.ready_time);
                    end 
                end
            end
        end

        if viewid == VIEW_INDEX_SELF then
            game_layer.set_play_effect = false
            local function callback()
                game_layer.set_play_effect = true
            end
            game_layer.layer:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(1), CCCallFunc:create(callback)))
            audio_engine.enter_effect()
        else
            game_layer.set_play_effect = game_layer.set_play_effect or false
            if game_layer.set_play_effect == true then
                audio_engine.enter_effect()
            end
        end

    end
end

function game_layer.on_game_user_left(userid, chairid, look)
    for k,v in pairs(game_layer.table_wait_init) do
        if chairid == v then
           table.remove(game_layer.table_wait_init,k); 
           break;
        end
    end

    local viewid = UIHelper.switch_to_view_id(chairid)
    if (viewid == -1) then 
        return;
    end

    game_layer.game_user:show_user(viewid, false, true)
    game_layer.game_user:set_status(viewid, UserStatus.null)
    audio_engine.left_effect()

--    if bit._and(ROOM_KIND,ROOM_KIND_SCORE)>0 then
--        game_layer.game_user:set_score(viewid, 0)
--    else
--        game_layer.game_user:set_gold(viewid, -1)
--    end

end

function game_layer.on_task_finish()
    game_layer.img_task_point:setVisible(true);
end

function game_layer.get_version()
    local v = frame_tools:bpversion();
    return v
end

function game_layer.show_new_player_hint(index)
    local version_data = frame_tools:get_config_value("228_version", 0);
    if Game_Version == tonumber(version_data) then
        return;
    end

    game_layer.new_player_hint:show_hint(1);

    frame_tools:set_config_value("228_version",Game_Version);
end

function game_layer.play_aniUpOut(sprite, pos, time)
    if sprite == nil then
        return;
    end
    if pos == nil then
        local local_height = (CardInfo.CARD_RESOURCE_HEIGHT + 65) * game_layer.HAND_CARD_SCALE;
        pos = ccp(game_layer.visibleSize.width/2,local_height);
    end
    if time == nil then
        time = 2
    end
    sprite:setPosition(pos);
    sprite:setOpacity(255);
    sprite:setVisible(true);
    
    sprite:stopAllActions();
    sprite:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(time),CCFadeOut:create(1)));
--    sprite:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(2),CCMoveTo:create(1,ccp(pos.x, pos.y + 70))     ));
end

function game_layer.play_aniUpInAndOunt(sprite, pos)
    if sprite == nil then
        return;
    end
    if pos == nil then
        local local_height = (CardInfo.CARD_RESOURCE_HEIGHT + 65) * game_layer.HAND_CARD_SCALE;
        pos = ccp(game_layer.visibleSize.width/2,local_height);
    end
    sprite:setPosition(pos);
    sprite:setOpacity(0);
    sprite:setVisible(true);
    
    sprite:stopAllActions();

    local array = CCArray:create()
    array:addObject(CCFadeIn:create(1))
    array:addObject(CCDelayTime:create(5))
    array:addObject(CCFadeOut:create(1))
    sprite:runAction(CCSequence:create(array));
--    sprite:runAction(CCSequence:createWithTwoActions(CCDelayTime:create(2),CCMoveTo:create(1,ccp(pos.x, pos.y + 70))     ));
end

function game_layer.play_aniUpDown(sprite, pos, time)
    if sprite == nil then
        return;
    end
    if pos == nil then
        local local_height = (CardInfo.CARD_RESOURCE_HEIGHT + 65) * game_layer.HAND_CARD_SCALE;
        pos = ccp(game_layer.visibleSize.width/2,local_height);
    end
    sprite:setPosition(pos);
    sprite:setVisible(true);
    
    sprite:stopAllActions();

    local array = CCArray:create()
    array:addObject(CCEaseSineInOut:create(CCMoveTo:create(3,ccp(pos.x, pos.y + 10 ) ) ) )
    array:addObject(CCEaseSineInOut:create(CCMoveTo:create(3, pos ) ) )
    sprite:runAction(CCRepeatForever:create(CCSequence:create(array) ) );
end

--endregion
