--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

winning_streak = class("winning_streak")

function winning_streak.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, winning_streak)
	return target
end

function winning_streak:create(visibleSize)
	local layer = winning_streak.extend(Layout:create())
    if layer ~= nil then
    	layer:init(visibleSize)
    end
	return layer
end

function winning_streak:init(visibleSize)
    --数据
    self.number_win_count = 0;
    self.number_aim_count = 0;
    self.show_type = 0
    --
    self.bg = UIHelper.create_img(self,ccp(0,0));
    --
    self.label_lian_sheng = UIHelper.create_labelBM(self.bg, "resources/number_gold/majiang-lstz.fnt",ccp(0,-31));
    self.label_lian_sheng:setVisible(true);
    self.label_lian_sheng:setText("连胜0/8");
    --连胜气泡
    self.tip_lian_sheng_bg = UIHelper.create_img(self.bg, ccp(-50,-65), "228_ls_tips.png",1);
    self.tip_lian_sheng_bg:setAnchorPoint(ccp(0, 0.5));
    self.tip_lian_sheng_bg:setVisible(false);
    self.tip_lian_sheng_bg:setCapInsets(CCRectMake( 150, 15, 15, 15 ))
    self.tip_lian_sheng_bg:setScale9Enabled(true);

    self.label_tip_lian_sheng = UIHelper.create_label(self.tip_lian_sheng_bg, ccp(0,-5), 18, ccc3(81,88,115) );
    self.label_tip_lian_sheng:setVisible(true);
    self.label_tip_lian_sheng:setText("周一，二，三，四，五，六，日 9：00 开启，敬请期待");

    local wight = self.label_tip_lian_sheng:getSize().width;
    self.tip_lian_sheng_bg:setSize(CCSizeMake(wight + 20,48) );
    self.label_tip_lian_sheng:setPosition(ccp(wight/2 + 10 ,-5));
    --按钮界面
    self.window_lian_sheng = UIHelper.create_img(self.bg, ccp(70,-115), "228_ls_windows.png",1);
    self.window_lian_sheng:setVisible(false);
    
    self.label_lian_sheng_count = UIHelper.create_labelBM(self.window_lian_sheng, "resources/number_gold/majiang-lstz.fnt", ccp(-40,40));
    self.label_lian_sheng_count:setVisible(true);
    self.label_lian_sheng_count:setText("");
    self.label_lian_sheng_count:setScale(1.1);

    self.label_lian_sheng_time = UIHelper.create_label(self.window_lian_sheng, ccp(110, 40), 18, ccc3(81,88,115) );
    self.label_lian_sheng_time:setVisible(true);
    self.label_lian_sheng_time:setText("12时59分");
    self.label_lian_sheng_time:setAnchorPoint(ccp(1,0.5));

    self.award_bg = {};
    self.award_label = {};

    self.img_class = 2;
    for i=1,self.img_class do
        local bg = UIHelper.create_img(self.window_lian_sheng, ccp(0,-20), "228_ls_gift_bg.png",1);
        local jiang = UIHelper.create_img(bg, ccp(-30,25), "228_ls_jiang.png",1);
        local award = UIHelper.create_img(bg, ccp(0,0), "228_ls_gift_gold.png",1);
        if i == 2 then
            award:loadTexture("228_ls_gift_quan.png",1);
        end
        local label = UIHelper.create_label(bg, ccp(0, -45), 18, ccc3(81,88,115) );
        label:setText("金币x30000");

        table.insert(self.award_bg, bg);
        table.insert(self.award_label, label); 
    end
    
    self.img_add = {};
    for i=1,self.img_class - 1 do
        local add = UIHelper.create_img(self.window_lian_sheng, ccp(0,-10), "228_ls_add.png",1);
        table.insert(self.img_add,add);
    end
    
    self.btn_pos = ccp(0,0);
    self.head_pos = ccp(0,0);
    self.label_head_gift = {};
    for i=1,self.img_class do
        local label = UIHelper.create_labelBM(self, "resources/number_gold/majiang-lstz.fnt", self.head_pos );
        label:setAnchorPoint(ccp(0, 0.5));
        label:setVisible(false);
        label:setText("金币+3000");
        table.insert(self.label_head_gift, label);
    end

    self.gold_count = 10;
    self.gold = {};
    for i=1,self.gold_count do
        local gold = ImageView:create()
        gold:loadTexture("228_ls_gold_2.png",1)
        frame_tools:addChild_to_top_layout(gold);
        gold:setVisible(false);
        gold:setScale(0.2);
        table.insert(self.gold, gold);
    end

    self.start_time = 0;
    self.end_time = 0;
    local time_second = 0;
    local function update(dt)
        time_second = time_second + dt;
        if time_second < 1 then
            return;
        end
        time_second = time_second - 1;

        local nYear = os.date("%Y");
        local nMonth = os.date("%m");
        local nDay = os.date("%d");

        local ttStart = os.time( {day= tonumber(nDay), month= tonumber(nMonth), year= tonumber(nYear), hour=self.start_time, minute=0, second=0} );
        local ttEnd = os.time( {day= tonumber(nDay), month= tonumber(nMonth), year= tonumber(nYear), hour=self.end_time, minute=0, second=0} );
        local tt = os.time();

        if (tt < ttStart) or (tt > ttEnd) then
            return
        end

        local still_time = ttEnd - tt;
        
        local hour = (still_time - still_time%3600) / 3600;
        local other = (still_time - hour * 3600);
        local minute = (other - other % 60) / 60;

        self.label_lian_sheng_time:setText(hour.."时"..minute.."分");
    end
    self:scheduleUpdateWithPriorityLua(update, 0)
    --test
--    self.award_bg[1]:setPosition(ccp(-55,-10));    
--    self.award_bg[2]:setPosition(ccp(55,-10));  

--    self:set_win_count(5);
--    self:set_aim_count(10);
--    self:set_award_count(1000,100);
--
--    self.show_type = 2;
--    self:show_tips(1);

end

function winning_streak:set_time(start_time, end_time)
    self.start_time = start_time;
    self.end_time = end_time;
end

function winning_streak:set_btn_position(btn_pos)
    self.btn_pos = btn_pos;
    self.bg:setPosition(btn_pos);
   
--    self:play_gold_ani();
--    self:play_text(1000,20);
end

function winning_streak:set_self_head_position(head_pos)
    self.head_pos = head_pos;

--    self:play_gold_ani();
--    self:play_text(1000,20);
end

function winning_streak:play_text(gold, ticket)
    local index = {};
    local height = { {55}, {75,55} }

    local head_wight = 36;
    for i=1,self.img_class do
        self.label_head_gift[i]:setPosition(ccp(self.head_pos.x - head_wight, self.head_pos.y - 20*(i - 1) ) );
    end

    if gold > 0 then
        table.insert(index,1);
        self.label_head_gift[1]:setText("金币+"..gold);
    end
    if ticket > 0 then
        table.insert(index,2);
        self.label_head_gift[2]:setText("奖券+"..ticket);
    end

    if #index == 0 then
        return;
    end

    local move_in_time = 0.5;
    local move_out_time = 0.5;
    local nowHeight = height[#index];
    for i=1,#nowHeight do
        self.label_head_gift[index[i]]:setOpacity(0);
        self.label_head_gift[index[i]]:setVisible(true);
        local arrray_2 = CCArray:create();
        arrray_2:addObject(CCMoveTo:create(move_out_time, ccp(self.head_pos.x - head_wight, self.head_pos.y + nowHeight[i]*1.5) ) )
        arrray_2:addObject(CCFadeOut:create(move_out_time));

        local arrray_3 = CCArray:create();
        arrray_3:addObject(CCMoveTo:create(move_in_time, ccp(self.head_pos.x - head_wight, self.head_pos.y + nowHeight[i]) ) )
        arrray_3:addObject(CCFadeIn:create(move_out_time));

        local array = CCArray:create();
        array:addObject(CCDelayTime:create(2));
        array:addObject(CCSpawn:create(arrray_3) );
        array:addObject(CCDelayTime:create(4) );
        array:addObject(CCSpawn:create(arrray_2) );
        array:addObject(CCCallFunc:create(function() self.label_head_gift[index[i]]:setVisible(false) end) );

        self.label_head_gift[index[i]]:runAction(CCSequence:create(array) );
--        self.label_head_gift[index[i]]:runAction(CCFadeIn:create(move_in_time));
    end
end

function winning_streak:play_gold_ani()
    local jump_height = 60;
    local jump_time = 1;
    local jump_count = 10;
    math.randomseed(os.time() );
    local weight = 50;
    local weight_2 = 20;

    local btn_pos =  self.btn_pos;
    local head_pos = self.head_pos;

    for i=1,self.gold_count do
        self.gold[i]:setPosition(ccp( math.random(btn_pos.x - weight, btn_pos.x + weight), math.random(btn_pos.y - 20, btn_pos.y + 20) ) );
        self.gold[i]:setVisible(true)
        local height = math.random(10, jump_height);
        local time = math.random(1,jump_count);
        local count = math.random(5, jump_count);

        local array = CCArray:create();
        array:addObject(CCDelayTime:create(1 + 0.1*i) );
        array:addObject(CCMoveTo:create(0.5, ccp(head_pos.x, head_pos.y) ) );
        array:addObject(CCCallFunc:create(function() self.gold[i]:setVisible(false) end) )
--        array:addObject(CCCallFunc:create(function()  end ) );
        self.gold[i]:runAction(CCJumpTo:create( math.random(), ccp( math.random(btn_pos.x - weight_2, btn_pos.x + weight_2), math.random(btn_pos.y - 20, btn_pos.y + 20) ) , height, count) );
        self.gold[i]:runAction(CCSequence:create(array) );
    end
end

function winning_streak:show_tips_string(tips)
    if self.show_type == 2 then
        self.window_lian_sheng:stopAllActions();
        self.window_lian_sheng:runAction(CCFadeOut:create(0.5));
    end
    self.label_tip_lian_sheng:setText(tips);

    local wight = self.label_tip_lian_sheng:getSize().width;
    if wight < 222 then
        wight = 222
    end
    self.tip_lian_sheng_bg:setSize(CCSizeMake(wight + 20, 48) );
    self.label_tip_lian_sheng:setPosition(ccp(wight/2 + 10 ,-5));

    self.tip_lian_sheng_bg:stopAllActions();
    self.tip_lian_sheng_bg:setOpacity(0);
    self.tip_lian_sheng_bg:setVisible(true);

    self.show_type = 1

    local array = CCArray:create();
    array:addObject(CCFadeIn:create(0.5));
    array:addObject(CCDelayTime:create(5));
    array:addObject(CCCallFunc:create(function() self.show_type = 0; end) )
    array:addObject(CCFadeOut:create(0.5));
    array:addObject(CCCallFunc:create(function() self.tip_lian_sheng_bg:setVisible(false); end) )

    self.tip_lian_sheng_bg:runAction(CCSequence:create(array));    
end

function winning_streak:show_tips(tips_type, win_count)
    if self.show_type == 2 then
        self.window_lian_sheng:stopAllActions();
        self.window_lian_sheng:runAction(CCFadeOut:create(0.5));
    end

    if tips_type == 1 then
        self.label_tip_lian_sheng:setText("连胜挑战已开启");
    elseif tips_type == 2 then
        self.label_tip_lian_sheng:setText("再胜一局 豪礼加码");
    elseif tips_type == 3 then
        self.label_tip_lian_sheng:setText("今日"..win_count.."次挑战奖励已领完");
    elseif tips_type == 4 then
        self.label_tip_lian_sheng:setText(win_count.."连胜达成");
    elseif tips_type == 5 then
        self.label_tip_lian_sheng:setText("连胜中断 再接再厉");
    end

    local wight = self.label_tip_lian_sheng:getSize().width;
    if wight < 222 then
        wight = 222
    end
    self.tip_lian_sheng_bg:setSize(CCSizeMake(wight + 20, 48) );
    self.label_tip_lian_sheng:setPosition(ccp(wight/2 + 10 ,-5));

    self.tip_lian_sheng_bg:stopAllActions();
    self.tip_lian_sheng_bg:setOpacity(0);
    self.tip_lian_sheng_bg:setVisible(true);

    self.show_type = 1

    local array = CCArray:create();
    array:addObject(CCFadeIn:create(0.5));
    array:addObject(CCDelayTime:create(5));
    array:addObject(CCCallFunc:create(function() self.show_type = 0; end) )
    array:addObject(CCFadeOut:create(0.5));
    array:addObject(CCCallFunc:create(function() self.tip_lian_sheng_bg:setVisible(false); end) )

    self.tip_lian_sheng_bg:runAction(CCSequence:create(array));    
end

function winning_streak:show_windows(isShow)
    if isShow == false then
        self.window_lian_sheng:stopAllActions();
        self.window_lian_sheng:setVisible(false);
        return;
    end
    if self.show_type == 1 then
        self.tip_lian_sheng_bg:stopAllActions();
        self.tip_lian_sheng_bg:runAction(CCFadeOut:create(0.5));
    end
    self.window_lian_sheng:stopAllActions();
    self.window_lian_sheng:setOpacity(0);
    self.window_lian_sheng:setVisible(true);

    self.show_type = 2

    local array = CCArray:create();
    array:addObject(CCFadeIn:create(0.1));
    array:addObject(CCDelayTime:create(5));
    array:addObject(CCCallFunc:create(function() self.show_type = 0; end) )
    array:addObject(CCFadeOut:create(0.1));
    array:addObject(CCCallFunc:create(function() self.window_lian_sheng:setVisible(false); end) )

    self.window_lian_sheng:runAction(CCSequence:create(array)); 
end

function winning_streak:set_win_count(win_count)
    self.number_win_count = win_count

    self.label_lian_sheng:setText("连胜"..self.number_win_count.."/"..self.number_aim_count);
    self.label_lian_sheng_count:setText("挑战"..self.number_aim_count.."连胜("..self.number_win_count.."/"..self.number_aim_count..")");
end

function winning_streak:set_aim_count(aim_count)
    self.number_aim_count = aim_count

    if aim_count > 0 then
        self.label_lian_sheng:setText("连胜"..self.number_win_count.."/"..self.number_aim_count);
        self.label_lian_sheng_count:setText("挑战"..self.number_aim_count.."连胜("..self.number_win_count.."/"..self.number_aim_count..")");
    else
        self.label_lian_sheng:setText("连胜");
        self.label_lian_sheng_count:setText("连胜");
    end
end
--
function winning_streak:set_award_count(award_gold, award_ticket)
    local index = {};
    local position = { {ccp(0, -10)},{ccp(-55,-10),ccp(55,-10)} }

    --金币
    if award_gold == nil or award_gold == 0 then
        self.award_bg[1]:setVisible(false);
    else
        self.award_label[1]:setText("金币x"..award_gold);
        self.award_bg[1]:setVisible(true);
        table.insert(index, 1);
    end
    --奖券
    if award_ticket == nil or award_ticket == 0 then
        self.award_bg[2]:setVisible(false);
    else
        self.award_label[2]:setText("奖券x"..award_ticket);
        self.award_bg[2]:setVisible(true);
        table.insert(index, 2);
    end

    if #index == 0 then
        return;
    end

    --奖励图片位置
    local position_item = position[#index];
    for i=1,#position_item,1 do
        self.award_bg[index[i]]:setPosition(position_item[i]);
    end

    --加号
    for i=1,#self.img_add do
        if i < #index then
            self.img_add[i]:setVisible(true);
        else
            self.img_add[i]:setVisible(false);
        end
    end

end

--endregion
