--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_config_win = class("frame_config_win", function() return frame_window:new() end );

function frame_config_win:ctor()

end

function frame_config_win:init()
    self:setVisible(false);

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_config_win/frame_config_win1.png");

    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_config_win_close.png","frame_config_win_close.png","frame_config_win_close.png",1);
    self._btn_close:setPosition(ccp(225, 145));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)

    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_config_title_bg.png",1);
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_config_title.png",1);

    --音效
    self._label_yinxiao = Label:create();
    self:addChild(self._label_yinxiao);
    self._label_yinxiao:setFontSize(30);
    self._label_yinxiao:setColor(ccc3(123,56,38 ) );
    self._label_yinxiao:setText("音效");

    self._switch_btn_yinxiao = Button:create();
    self:addChild(self._switch_btn_yinxiao);
    self._switch_btn_yinxiao:loadTextures("frame_config_btn_open.png","","frame_config_btn_open.png",1);
--    self._switch_btn_yinxiao:loadTextureNormal("frame_config_btn_open.png",1);
    self._switch_btn_yinxiao:addTouchEventListener(function(sender, touchType) self:on_switch_btn_yinxiao(sender, touchType) end);
    self._effects_volume = frame_tools:get_effects_volume();
    if self._effects_volume == 0 then
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_close.png","","frame_config_btn_close.png",1);
    end

    --音乐
    self._label_yinyue = Label:create();
    self:addChild(self._label_yinyue);
    self._label_yinyue:setFontSize(30);
    self._label_yinyue:setColor(ccc3(123,56,38 ) );
    self._label_yinyue:setText("音乐");

    self._switch_btn_yinyue = Button:create();
    self:addChild(self._switch_btn_yinyue);
    self._switch_btn_yinyue:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
    self._switch_btn_yinyue:addTouchEventListener(function(sender, touchType) self:on_switch_btn_yinyue(sender, touchType) end);
    self._music_volume = frame_tools:get_music_volume()
    if self._music_volume == 0 then
        self._switch_btn_yinyue:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
    end

    self._title_bg:setPosition(ccp(0,150));
    self._label_yinxiao:setPosition(ccp(-80,30));
    self._switch_btn_yinxiao:setPosition(ccp(80,30));
    self._label_yinyue:setPosition(ccp(-80,-70));
    self._switch_btn_yinyue:setPosition(ccp(80,-70));
end

function frame_config_win:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_config_win:on_switch_btn_yinxiao(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self._effects_volume ==  0 then
        frame_tools:set_effects_volume(1);
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
        self._effects_volume = 1
    else
        frame_tools:set_effects_volume(0);
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
        self._effects_volume = 0
    end
    
end

function frame_config_win:on_switch_btn_yinyue(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");
     
    if self._music_volume ==  0 then
        frame_tools:set_music_volume(1);
        self._switch_btn_yinyue:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
        self._music_volume = 1
    else
        frame_tools:set_music_volume(0);
        self._switch_btn_yinyue:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
        self._music_volume = 0
    end
end












---------------------------------------------------------------------------------------------------------------
--
---------------------------------------------------------------------------------------------------------------

frame_config_win_2 = class("frame_config_win_2", function() return frame_window:new() end );

function frame_config_win_2:ctor()

end

function frame_config_win_2:init(table_config, callback_bg)
    self:setVisible(false);

    self.callback_bg = callback_bg;

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_config_win/frame_config_win2.png");
    self._bg:setTouchEnabled(true)
    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_config_win_close.png","frame_config_win_close.png","frame_config_win_close.png",1);
    self._btn_close:setPosition(ccp(255, 205));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)

    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_config_title_bg.png",1);
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_config_title.png",1);

    --音效
    self._label_yinxiao = Label:create();
    self:addChild(self._label_yinxiao);
    self._label_yinxiao:setFontSize(30);
    self._label_yinxiao:setColor(ccc3(123,56,38 ) );
    self._label_yinxiao:setText("音效");

    self._switch_btn_yinxiao = Button:create();
    self:addChild(self._switch_btn_yinxiao);
    self._switch_btn_yinxiao:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
--    self._switch_btn_yinxiao:loadTextureNormal("frame_config_btn_open.png",1);
    self._switch_btn_yinxiao:addTouchEventListener(function(sender, touchType) self:on_switch_btn_yinxiao(sender, touchType) end);
    self._effects_volume = frame_tools:get_effects_volume();
    if self._effects_volume == 0 then
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
    end

    --音乐
    self._label_yinyue = Label:create();
    self:addChild(self._label_yinyue);
    self._label_yinyue:setFontSize(30);
    self._label_yinyue:setColor(ccc3(123,56,38 ) );
    self._label_yinyue:setText("音乐");

    self._switch_btn_yinyue = Button:create();
    self:addChild(self._switch_btn_yinyue);
    self._switch_btn_yinyue:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
    self._switch_btn_yinyue:addTouchEventListener(function(sender, touchType) self:on_switch_btn_yinyue(sender, touchType) end);
    self._music_volume = frame_tools:get_music_volume()
    if self._music_volume == 0 then
        self._switch_btn_yinyue:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
    end

    --背景
    local bg_btn_pos = { {},{ ccp(180, 50),ccp(180, -80) },{ ccp(180, 60),ccp(180, -30),ccp(180,-120) } }
    self._bg_btn_pos = bg_btn_pos[table_config.bg_count];
    self._bg_count = table_config.bg_count;
    self._bg_select_btn = {};
    for i=1,self._bg_count do
        local btn = frame_config_bg_btn:new();
        btn:init(table_config.bg_config[i]);
        btn:setPosition(self._bg_btn_pos[i]);
        btn:addTouchEventListener(function(sender, touchType) self:on_btn_switch_bg(sender, touchType, i) end);
        self:addChild(btn);
        table.insert(self._bg_select_btn, btn);
    end

    self._bg_select_img = ImageView:create();
    self:addChild(self._bg_select_img);
    self._bg_select_img:loadTexture("frame_config_bg.png",1);
    self._bg_select_img:setPosition(ccp(self._bg_btn_pos[1].x - 80, self._bg_btn_pos[1].y));

    self._title_bg:setPosition(ccp(0,210));
    self._label_yinxiao:setPosition(ccp(-200,30));
    self._switch_btn_yinxiao:setPosition(ccp(-80,30));
    self._label_yinyue:setPosition(ccp(-200,-60));
    self._switch_btn_yinyue:setPosition(ccp(-80,-60));
end

function frame_config_win_2:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_config_win_2:on_switch_btn_yinxiao(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self._effects_volume ==  0 then
        frame_tools:set_effects_volume(1);
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
        self._effects_volume = 1
    else
        frame_tools:set_effects_volume(0);
        self._switch_btn_yinxiao:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
        self._effects_volume = 0
    end
    
end

function frame_config_win_2:on_switch_btn_yinyue(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");
     
    if self._music_volume ==  0 then
        frame_tools:set_music_volume(1);
        self._switch_btn_yinyue:loadTextures("frame_config_btn_open.png","frame_config_btn_open.png","frame_config_btn_open.png",1);
        self._music_volume = 1
    else
        frame_tools:set_music_volume(0);
        self._switch_btn_yinyue:loadTextures("frame_config_btn_close.png","frame_config_btn_close.png","frame_config_btn_close.png",1);
        self._music_volume = 0
    end
end

function frame_config_win_2:on_btn_switch_bg(sender, touchType, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    for i=1,self._bg_count do
        self._bg_select_btn[i]:on_select_type(1);
    end

    self._bg_select_btn[index]:on_select_type(2);

    self._bg_select_img:stopAllActions();
    self._bg_select_img:runAction(CCMoveTo:create(0.1, ccp(self._bg_btn_pos[index].x - 80, self._bg_btn_pos[index].y) ) )

    if self.callback_bg then
        self.callback_bg(index);
    end
end

function frame_config_win_2:set_switch_bg(index)
    for i=1,self._bg_count do
        self._bg_select_btn[i]:on_select_type(1);
    end

    self._bg_select_btn[index]:on_select_type(2);
    self._bg_select_img:setPosition(ccp(self._bg_btn_pos[index].x - 80, self._bg_btn_pos[index].y) );
end


---------------------------------------------------------------------------------------------------------------

frame_config_bg_btn = class("frame_config_bg_btn", function() return Button:create() end );

function frame_config_bg_btn:ctor()

end

function frame_config_bg_btn:init(table_data)
    self._switch_type = 1;
   
    self:loadTextures("frame/image/lucency.png","frame/image/lucency.png","frame/image/lucency.png");
    self:setScale9Enabled(true);
    self:setSize(CCSizeMake(222,88));
    self:setTouchEnabled(true);

    self._bg_pvw = ImageView:create();
    self:addChild(self._bg_pvw);
    self._bg_pvw:loadTexture(table_data.pvw);
    self._bg_pvw:setPosition(ccp(-80, 0));

    self._btn_point = ImageView:create();
    self:addChild(self._btn_point);
    self._btn_point:loadTexture("frame_config_seect_1.png",1);
    self._btn_point:setPosition(ccp(50, 0));
end

function frame_config_bg_btn:get_select_type()
    return self._switch_type;
end

function frame_config_bg_btn:on_select_type(select_type)
    if select_type == 1 then
        self._btn_point:loadTexture("frame_config_seect_1.png",1);
        self._switch_type = 1;
    elseif select_type == 2 then
        self._btn_point:loadTexture("frame_config_seect_2.png",1);
        self._switch_type = 2;
    end
end

--endregion
