--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_exit_win = class("frame_exit_win",function() return frame_window:new() end)

function frame_exit_win:ctor()
    self.m_color_1 = ccc3(123,56,38);

    self.m_color_gold = ccc3(255,144,0);
    self.m_color_score = ccc3(211,66,8);

    self.m_color_task = ccc3(121,57,21);
    self.m_color_award = ccc3(244,107,24);

    self.m_callback = nil;
end

function frame_exit_win:init()
    self:setVisible(false);
--    self:set_show_type(true);

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_exit_win/frame_exit_bg.png");
    self._bg:setTouchEnabled(true)
    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_hint_btn_close.png","frame_hint_btn_close.png","frame_hint_btn_close.png",1);
    self._btn_close:setPosition(ccp(290, 195));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_hint_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 205));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_exit_title.png",1);
    
    --魅力
    self._img_charm = ImageView:create();
    self._bg:addChild(self._img_charm);
    self._img_charm:loadTexture("frame_exit_charm.png",1);
    self._img_charm:setPosition(ccp(-220, 115));
    --
    self._img_charm_change = ImageView:create();
    self._img_charm:addChild(self._img_charm_change);
    self._img_charm_change:setPosition(ccp(50,0));
    self._img_charm_change:loadTexture("frame_exit_no.png",1);
    --
    self._label_charm = Label:create();
    self._img_charm:addChild(self._label_charm);
    self._label_charm:setFontSize(24);
    self._label_charm:setColor(self.m_color_1);
    self._label_charm:setText("魅力值");
    self._label_charm:setAnchorPoint(ccp(1,0.5));
    self._label_charm:setPosition(ccp(20,-45));
    --
    self._label_charm_count = Label:create();
    self._img_charm:addChild(self._label_charm_count);
    self._label_charm_count:setFontSize(24);
    self._label_charm_count:setColor(self.m_color_1);
    self._label_charm_count:setText("+0");
    self._label_charm_count:setAnchorPoint(ccp(0,0.5));
    self._label_charm_count:setPosition(ccp(30,-45));

    --金币
    self._img_gold = ImageView:create();
    self._bg:addChild(self._img_gold);
    self._img_gold:loadTexture("frame_exit_gold.png",1);
    self._img_gold:setPosition(ccp(-10, 115));
    --
    self._img_gold_change = ImageView:create();
    self._img_gold:addChild(self._img_gold_change);
    self._img_gold_change:setPosition(ccp(50,0));
    self._img_gold_change:loadTexture("frame_exit_no.png",1);
    --
    self._label_gold = Label:create();
    self._img_gold:addChild(self._label_gold);
    self._label_gold:setFontSize(24);
    self._label_gold:setColor(self.m_color_1);
    self._label_gold:setText("金币");
    self._label_gold:setAnchorPoint(ccp(1,0.5));
    self._label_gold:setPosition(ccp(0,-45));
    --
    self._label_gold_count = Label:create();
    self._img_gold:addChild(self._label_gold_count);
    self._label_gold_count:setFontSize(24);
    self._label_gold_count:setColor(self.m_color_gold);
    self._label_gold_count:setText("+0");
    self._label_gold_count:setAnchorPoint(ccp(0,0.5));
    self._label_gold_count:setPosition(ccp(10,-45));

    --积分
    self._img_score = ImageView:create();
    self._bg:addChild(self._img_score);
    self._img_score:loadTexture("frame_exit_score.png",1);
    self._img_score:setPosition(ccp(190, 115));
    --
    self._img_score_change = ImageView:create();
    self._img_score:addChild(self._img_score_change);
    self._img_score_change:setPosition(ccp(50,0));
    self._img_score_change:loadTexture("frame_exit_no.png",1);
    --
    self._label_score = Label:create();
    self._img_score:addChild(self._label_score);
    self._label_score:setFontSize(24);
    self._label_score:setColor(self.m_color_1);
    self._label_score:setText("积分");
    self._label_score:setAnchorPoint(ccp(1,0.5));
    self._label_score:setPosition(ccp(0,-45));
    --
    self._label_score_count = Label:create();
    self._img_score:addChild(self._label_score_count);
    self._label_score_count:setFontSize(24);
    self._label_score_count:setColor(self.m_color_score);
    self._label_score_count:setText("+0");
    self._label_score_count:setAnchorPoint(ccp(0,0.5));
    self._label_score_count:setPosition(ccp(10,-45));

    --任务
    self._node_task = ImageView:create();
    self._bg:addChild(self._node_task);
    self._node_task:setPosition(ccp(0,-30));
    self._node_task:setVisible(false);

    self._img_task_award = ImageView:create();
    self._node_task:addChild(self._img_task_award);
    self._img_task_award:loadTexture("../5000/task_icon_1.png");
    self._img_task_award:setPosition(ccp(-200,0));

    self._label_task = Label:create();
    self._node_task:addChild(self._label_task);
    self._label_task:setFontSize(26);
    self._label_task:setColor(self.m_color_task);
    self._label_task:setText("保皇对局胜利5局（还差2局）");
    self._label_task:setAnchorPoint(ccp(0,0.5));
    self._label_task:setPosition(ccp(-120,20));

    self._label_award_text = Label:create();
    self._node_task:addChild(self._label_award_text);
    self._label_award_text:setFontSize(26);
    self._label_award_text:setColor(self.m_color_task);
    self._label_award_text:setText("奖励:");
    self._label_award_text:setAnchorPoint(ccp(0,0.5));
    self._label_award_text:setPosition(ccp(-120,-20));

    self._label_award = Label:create();
    self._node_task:addChild(self._label_award);
    self._label_award:setFontSize(26);
    self._label_award:setColor(self.m_color_award );
    self._label_award:setText("5000金币,5奖券");
    self._label_award:setAnchorPoint(ccp(0,0.5));
    self._label_award:setPosition(ccp(-50,-20));

    --引导
    self:init_guide_list();

    --提示
    self._node_hint = ImageView:create();
    self._bg:addChild(self._node_hint);
    self._node_hint:setPosition(ccp(0,-30));
    self._node_hint:setVisible(false);

    self._img_hint = ImageView:create();
    self._node_hint:addChild(self._img_hint);
    self._img_hint:setPosition(ccp(0,0));
    self._img_hint:loadTexture("frame_exit_hint.png",1);

    --btn
    self._btn_exit = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_exit);
    self._btn_exit:setPosition(ccp(-150,-150));
    self._btn_exit:loadTextureNormal("frame_exit_btn_out.png",1);
    self._btn_exit:addTouchEventListener(function(sender, touchType) self:on_btn_exit(sender, touchType) end);

    self._btn_continue = frame_tools:get_a_btn();
    self._bg:addChild(self._btn_continue);
    self._btn_continue:setPosition(ccp(150,-150));
    self._btn_continue:loadTextureNormal("frame_exit_go_on.png",1);
    self._btn_continue:addTouchEventListener(function(sender, touchType) self:on_btn_continue(sender, touchType) end);


    frame_tools:add_event_listen("update_game_status", function(data) 
        if self == nil or self.update_game_status then return; end
        self:update_game_status(data) 
        end
    );
    frame_tools:add_event_listen("update_self_change", function(data) 
        if self == nil or self.update_self_change then return; end
        self:update_self_change(data) 
        end
    );

--    self:set_change(111,12345678,-223);
    
end

function frame_exit_win:set_exit_callback(exit_callback)
    self.m_callback = exit_callback;
end

function frame_exit_win:init_guide_list()
    --引导
    self._node_guide = ImageView:create();
    self._bg:addChild(self._node_guide);
    self._node_guide:setPosition(ccp(0,-30));
    self._node_guide:setVisible(false);
    
    self._guide_list = {};

    if Frame_Exit_Guide == nil then return;end
    if frame_tools:is_func("on_do_task") == false then return;end

    local load_list = {}
    for k,v in pairs(Frame_Exit_Guide) do
        if frame_tools:find_game_list(v) == true then
            table.insert(load_list, v);
        end
    end

    local count = #load_list;
    if count == 0 then return;end

    self._guide_pos = { 
    { ccp(0,0) },
    { ccp(-100,0), ccp(100,0) },
    { ccp(-150,0), ccp(0,0), ccp(150,0)},  
    { ccp(-200,0), ccp(-100,0), ccp(0,0), ccp(100,0), ccp(200,0)},  
    } 

    if count > 3 then count = 3;end
    local pos = self._guide_pos[count];
    for k,v in pairs(load_list) do
        local guide_item = frame_exit_guide_item:new();
        guide_item:init(function(gameid) self:on_btn_guide(gameid) end);
        self._node_guide:addChild(guide_item);
        guide_item:set_name(v.name);
        guide_item:set_btn_img(v.img);
        guide_item:set_game_id(v.gameid);
        guide_item:setPosition(pos[k]);

        table.insert(self._guide_list, guide_item);

        if k == count then break; end
    end
    
end

--
function frame_exit_win:update_game_status(data)
    if data == nil then return; end

    if data.new == FRAME_USER_STATUS.US_PLAY then
        self:set_type(3);
    else    
        self:set_type(2);
    end
end
--
function frame_exit_win:update_self_change(data)
    if data == nil then return; end
    self:set_change_data(data);
end

function frame_exit_win:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_exit_win:on_btn_continue(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_exit_win:on_btn_exit(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.m_callback then
        self.m_callback();
    end

    close_game();
end

function frame_exit_win:on_btn_guide(game_id)
    print("on_btn_guide")

    if game_id == 0 then return; end

    frame_tools:on_do_task("enter:"..game_id);

    self:show_window(false);
end

function frame_exit_win:update_task(game_id)
    if game_id == nil then return; end

    self.m_gameid = game_id
--    frame_tools:request_game_task(self.m_gameid, function(data) self:load_task(data) end);
end

function frame_exit_win:load_task(data)
    if type(data) ~= "table" then return;end

    local task_item = nil;
    local min_gap = 999;
    for k,v in pairs(data) do
        if v._int_status == 1 then
            local gap = v._complete_count - v._cur_count;
            if gap < min_gap then
                min_gap = gap;
                task_item = v;
            end
        end
    end

    if task_item ~= nil then
        self:set_task_data(task_item);
        self:set_type(1);
    else
        self:set_type(3);
    end
--    self:show_window(true);
end

function frame_exit_win:set_type(type)
    if type == 2 and #self._guide_list == 0 then
        self._node_guide:setVisible(false);
        self._node_hint:setVisible(true);
        self._node_task:setVisible(false);    
        return;
    end

    if type == 1 then -- 任务
        self._node_hint:setVisible(false);
        self._node_guide:setVisible(false);
        self._node_task:setVisible(true);
    elseif type == 2 then --引导
        self._node_guide:setVisible(true);
        self._node_hint:setVisible(false);
        self._node_task:setVisible(false);
    else    --文字
        self._node_guide:setVisible(false);
        self._node_hint:setVisible(true);
        self._node_task:setVisible(false);    
    end
end

function frame_exit_win:set_task_data(data)
    self.m_task_id          = data._int_id or 0
    self.m_int_status       = data._int_status or 0;
    self.m_str_task         = data._task_name or ""
    self.m_curr_count       = data._cur_count or 0;
    self.m_task_count       = data._task_count or 0;
    self.m_complate_count   = data._complete_count or 0;
    self.m_logo             = data._task_logo_url or "";
    self.m_str_reward       = data._reward_name or "";

    self:update_task_data();
end

function frame_exit_win:update_task_data()
    self._label_award:setText(self.m_str_reward);
    self._img_task_award:loadTexture("../5000/"..self.m_logo);

    if self.m_int_status == 2 then --已完成
        self._label_task:setText(self.m_str_task.."(已完成)");
    elseif self.m_int_status == 4 then --已领取
        self._label_task:setText(self.m_str_task.."(已完成)");
    else    --未完成
        self._label_task:setText(self.m_str_task.."("..tostring(self.m_curr_count).."/"..tostring(self.m_complate_count)..")");
    end
end

function frame_exit_win:set_change_data(data)
    if data == nil then return; end
    self:set_change(data.charm, data.gold, data.score);
end

function frame_exit_win:set_change(charm, gold, score)
    if charm == nil then charm = 0 end;
    if gold == nil then gold = 0 end;
    if score == nil then score = 0 end;

    local gap = 21;

    if charm >= 0 then
        self._label_charm_count:setText("+"..charm);
        if charm == 0 then
            self._img_charm_change:loadTexture("frame_exit_no.png",1);
        else
            self._img_charm_change:loadTexture("frame_exit_up.png",1);
        end
    else
        self._label_charm_count:setText(charm);
        self._img_charm_change:loadTexture("frame_exit_down.png",1);
    end
    
    if true then
        local label_width_1 = self._label_charm:getSize().width;
        local label_width_2 = self._label_charm_count:getSize().width;
        local width = label_width_1 + label_width_2;

        self._label_charm:setPosition(ccp( label_width_1 - width/2 + gap - 6, -45) );
        self._label_charm_count:setPosition(ccp( width/2 - label_width_2 + gap - 6, -45) );
    end
    
    if gold >= 0 then
        self._label_gold_count:setText("+"..gold);
        if gold == 0 then
            self._img_gold_change:loadTexture("frame_exit_no.png",1);
        else
            self._img_gold_change:loadTexture("frame_exit_up.png",1);
        end
    else
        self._label_gold_count:setText(gold);
        self._img_gold_change:loadTexture("frame_exit_down.png",1);
    end

    if true then
        local label_width_1 = self._label_gold:getSize().width;
        local label_width_2 = self._label_gold_count:getSize().width;
        local width = label_width_1 + label_width_2;

        self._label_gold:setPosition(ccp( label_width_1 - width/2 + gap, -45) );
        self._label_gold_count:setPosition(ccp( width/2 - label_width_2 + gap, -45) );
    end

    if score >= 0 then
        self._label_score_count:setText("+"..score);
        if score == 0 then
            self._img_score_change:loadTexture("frame_exit_no.png",1);
        else
            self._img_score_change:loadTexture("frame_exit_up.png",1);
        end
    else
        self._label_score_count:setText(score);
        self._img_score_change:loadTexture("frame_exit_down.png",1);
    end

    if true then
        local label_width_1 = self._label_score:getSize().width;
        local label_width_2 = self._label_score_count:getSize().width;
        local width = label_width_1 + label_width_2;

        self._label_score:setPosition(ccp( label_width_1 - width/2 + gap, -45) );
        self._label_score_count:setPosition(ccp( width/2 - label_width_2 + gap, -45) );
    end

end


-----------------------------------------------------------------------------------------
--
frame_exit_guide_item = class("frame_exit_guide_item", function() return ImageView:create() end)

function frame_exit_guide_item:ctor()
    self.m_game_id = 0;
    self.m_name = "";
    self.m_callback = nil;

    self.m_color_1 = ccc3(123,56,38);
end

function frame_exit_guide_item:init(callback)
    self.m_callback = callback;

    self._btn = frame_tools:get_a_btn() 
    self:addChild(self._btn);
    self._btn:setPosition(ccp(0,15));
    self._btn:addTouchEventListener(function(sender, touchType) self:on_btn_click(sender, touchType) end);
    
    self._label_name = Label:create();
    self:addChild(self._label_name);
    self._label_name:setPosition(ccp(0,-50));
    self._label_name:setFontSize(22);
    self._label_name:setColor(self.m_color_1);
    self._label_name:setText("疯狂猎鱼");
end

function frame_exit_guide_item:set_btn_img(str_img)
    self._btn:loadTextures(str_img, str_img, str_img);

    local width = self._btn:getSize().width;
    self._btn:setScale(80/width);

end

function frame_exit_guide_item:on_btn_click(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    if self.m_callback then 
        self.m_callback(self.m_game_id);
    end
end

function frame_exit_guide_item:set_name(name)
    self.m_name = name or "";

    self._label_name:setText(name);

    print("frame_exit_guide_item:set_name",name)
end

function frame_exit_guide_item:set_game_id(id)
    self.m_game_id = id or 0;
end

function frame_exit_guide_item:get_game_id()
    return self.m_game_id;
end

--endregion
