--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

frame_report_win_single = class("frame_report_win_single", function() return frame_window:new() end);

function frame_report_win_single:ctor()
    self.m_userid = 0;
end

function frame_report_win_single:init()
    self:setVisible(false);

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_report_win/frame_report_win_single.png");
    self._bg:setTouchEnabled(true)
    --关闭
    self._btn_close = Button:create();
    self._bg:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_hint_btn_close.png","frame_hint_btn_close.png","frame_hint_btn_close.png",1);
    self._btn_close:setPosition(ccp(265, 170));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_hint_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 180));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_report_title.png",1);

    --
    self._label_bg = ImageView:create();
    self._bg:addChild(self._label_bg);
    self._label_bg:setPosition(ccp(0,100) );

    self._label_1 = Label:create();
    self._label_bg:addChild(self._label_1);
    self._label_1:setAnchorPoint(ccp(1, 0.5));
    self._label_1:setFontSize(26);
    self._label_1:setColor(ccc3(123,56,38));
    self._label_1:setText("您正在举报");

    self._label_2 = Label:create();
    self._label_bg:addChild(self._label_2);
    self._label_2:setAnchorPoint(ccp(1, 0.5));
    self._label_2:setFontSize(26);
    self._label_2:setColor(ccc3(228,75,39));
    self._label_2:setText("[");

    self._label_name = UILabelEx3:new();
    self._label_bg:addChild(self._label_name);
    self._label_name:setAnchorPoint(ccp(0, 0.5));
    self._label_name:setFontSize(26);
    self._label_name:setColor(ccc3(228,75,39));
    self._label_name:setText("dfajfadkjfka");

    self._label_3 = Label:create();
    self._label_bg:addChild(self._label_3);
    self._label_3:setAnchorPoint(ccp(0, 0.5));
    self._label_3:setFontSize(26);
    self._label_3:setColor(ccc3(228,75,39));
    self._label_3:setText("]");

    self._label_4 = Label:create();
    self._label_bg:addChild(self._label_4);
    self._label_4:setAnchorPoint(ccp(0, 0.5));
    self._label_4:setFontSize(26);
    self._label_4:setColor(ccc3(123,56,38));
    self._label_4:setText(",请选择举报内容");

    --select_item
    self.m_isSelect = {};

    self._select_item = frame_report_single_item:new();
    self._bg:addChild(self._select_item);
    self._select_item:setPosition(ccp(0,35));
    self._select_item:init("头像违规", function(sender, touchType, isSelect) self:on_btn_select_box(sender, touchType, isSelect, 1) end);
    table.insert(self.m_isSelect, 0);

    self._select_item_2 = frame_report_single_item:new();
    self._bg:addChild(self._select_item_2);
    self._select_item_2:setPosition(ccp(0,-35));
    self._select_item_2:init("昵称违规", function(sender, touchType, isSelect) self:on_btn_select_box(sender, touchType, isSelect, 2) end);
    table.insert(self.m_isSelect, 0);

    self._btn_report = frame_tools:get_a_btn()
    self._bg:addChild(self._btn_report);
    self._btn_report:setPosition(ccp(0,-120));
    self._btn_report:loadTextures("frame_report_btn.png","","frame_report_btn_unable.png", 1);
    self._btn_report:addTouchEventListener(function(sender, touchType) self:on_btn_report(sender, touchType) end);

    self._btn_report:setTouchEnabled(false);
    self._btn_report:setBright(false);
end

function frame_report_win_single:set_name(str_name)
    self._label_name:setTextEx(str_name,150);

    local width1 = self._label_1:getSize().width;
    local width2 = self._label_2:getSize().width;
    local width_name = self._label_name:getSize().width;
    local width3 = self._label_3:getSize().width;
    local width4 = self._label_4:getSize().width;

    local width = width1 + width2 + width_name + width3 + width4;

    self._label_1:setPosition(ccp(width1 - width/2, 0) );
    self._label_2:setPosition(ccp(width1 - width/2 + width2, 0) );
    self._label_name:setPosition(ccp(width1 - width/2 + width2, 0) );
    self._label_3:setPosition(ccp(width/2 - width4 - width3, 0) );
    self._label_4:setPosition(ccp(width/2 - width4, 0) );
end

function frame_report_win_single:set_userid(user_id)
    self.m_userid = user_id;
end

function frame_report_win_single:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_report_win_single:on_btn_report(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    print("on_btn_report");

    if self.m_isSelect[1] == 1 then
        local send_data = {};
        send_data.kind = 4;
        send_data.count = 1;
        send_data.userid = {}
        table.insert(send_data.userid, self.m_userid);

        frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_REPORT, send_data);
    end

    if self.m_isSelect[2] == 1 then
        local send_data = {};
        send_data.kind = 1;
        send_data.count = 1;
        send_data.userid = {}
        table.insert(send_data.userid, self.m_userid);

        frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_REPORT, send_data);
    end
    
    self:show_window(false);
end

function frame_report_win_single:on_btn_select_box(sender, touchType, isSelect, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
--    frame_tools:playEffect("frame/sound/click.mp3");

    self.m_isSelect[index] = isSelect;

    local isEnableBtn = false;
    for k,v in pairs(self.m_isSelect) do
        if v == 1 then
            isEnableBtn = true;
        end
    end
    
    self._btn_report:setBright(isEnableBtn);
    self._btn_report:setTouchEnabled(isEnableBtn);
end

function frame_report_win_single:clear()
    self.m_isSelect = {};
    
    self._select_item:clear();
    self._select_item_2:clear();

    self._btn_report:setBright(false);
    self._btn_report:setTouchEnabled(false);
end

--------------------------------------------------------------------------------------------------------------------------------------
--
frame_report_single_item = class("frame_report_single_item", function() return ImageView:create() end)
function frame_report_single_item:ctor()

end

function frame_report_single_item:init(str_label, callback)
    self.m_select = 0;
    self.callback = callback;

    self:loadTexture("frame_report_item_bg1.png", 1);
    self:setTouchEnabled(true);
    self:addTouchEventListener(function(sender, touchType) self:on_btn_select_box(sender, touchType) end);

    self._label = Label:create();
    self:addChild(self._label);
    self._label:setPosition(ccp(-80,0));
    self._label:setText(str_label);
    self._label:setFontSize(30);
    self._label:setColor(ccc3(123,56,38));

    self._select_box = frame_tools:get_a_btn();
    self:addChild(self._select_box);
    self._select_box:setPosition(ccp(120,0));
    self._select_box:loadTextures("frame_report_select_box.png","frame_report_select_box.png","frame_report_select_box.png",1);
    self._select_box:addTouchEventListener(function(sender, touchType) self:on_btn_select_box(sender, touchType) end);
    self._select_box:setTouchEnabled(false);

    self._select = ImageView:create();
    self._select_box:addChild(self._select);
    self._select:setPosition(ccp(0,0));
    self._select:loadTexture("frame_report_select.png", 1);
    self._select:setVisible(false);

end

function frame_report_single_item:on_btn_select_box(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    print("on_btn_select_box");

    if self.m_select == 0 then
        self.m_select = 1;
        self._select:setVisible(true);
    else    
        self.m_select = 0;
        self._select:setVisible(false);
    end

    if self.callback then
        self.callback(sender, touchType, self.m_select);
    end
end

function frame_report_single_item:clear()
    self.m_select = 0;
    self._select:setVisible(false);
end


-------------------------------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------------------------------
frame_report_win = class("frame_report_win", function() return frame_window:new() end);

function frame_report_win:ctor()
    self._user_item = {};
    self.m_isSelect = {};
end

function frame_report_win:init()
    self:setVisible(false);

    --背景
    self._bg = ImageView:create();
    self:addChild(self._bg);
    self._bg:loadTexture("frame/image/frame_report_win/frame_report_win.png");
    self._bg:setTouchEnabled(true)
    --关闭
    self._btn_close = Button:create();
    self:addChild(self._btn_close);
    self._btn_close:loadTextures("frame_hint_btn_close.png","frame_hint_btn_close.png","frame_hint_btn_close.png",1);
    self._btn_close:setPosition(ccp(290, 230));
    self._btn_close:addTouchEventListener(function(sender, touchType) self:on_btn_close(sender, touchType) end)
    --标题
    self._title_bg = ImageView:create();
    self._bg:addChild(self._title_bg);
    self._title_bg:loadTexture("frame_hint_title_bg.png",1);
    self._title_bg:setPosition(ccp(0, 240));
    --标题
    self._title = ImageView:create();
    self._title_bg:addChild(self._title);
    self._title:loadTexture("frame_report_title.png",1);

    self._label_1 = Label:create();
    self._bg:addChild(self._label_1);
    self._label_1:setPosition(ccp(0, 170));
    self._label_1:setFontSize(26);
    self._label_1:setColor(ccc3(123,56,38));
    self._label_1:setText("您正在进行举报合伙作弊，请选择至少两名玩家");

    --用户item
    self._scroll_width = 600 
    self._user_item_scroll = ScrollView:create();
    self._bg:addChild(self._user_item_scroll);
    self._user_item_scroll:setAnchorPoint(ccp(0.5,0.5));
    self._user_item_scroll:setSize(CCSizeMake(self._scroll_width,305));
    self._user_item_scroll:setDirection( _G.SCROLLVIEW_DIR_VERTICAL);

    --举报按钮
    self._btn_report = frame_tools:get_a_btn()
    self._bg:addChild(self._btn_report);
    self._btn_report:setPosition(ccp(0,-200));
    self._btn_report:loadTextures("frame_report_btn.png","","frame_report_btn_unable.png", 1);
    self._btn_report:addTouchEventListener(function(sender, touchType) self:on_btn_report(sender, touchType) end);

    self._btn_report:setTouchEnabled(false);
    self._btn_report:setBright(false);
end

function frame_report_win:set_user_item(user_data)
    if type(user_data) ~= "table" then return;end

    self._user_item = {};
    self.m_isSelect = {};
    self.m_userid = {};

    local width = self._scroll_width / 2;
--    local pos = { ccp(width,333),ccp(width,258),ccp(width,183),ccp(width,108),ccp(width,33) }
    local count = #user_data;
    local height_count = 4;
    if count > 4 then
        height_count = count;
    end
    for i=1,count do
        local item = frame_report_item:new();
        item:init(function(sender, touchType, isSelect) self:on_btn_select_box(sender, touchType, isSelect, i) end);
        self._user_item_scroll:addChild(item);
        item:setPosition( ccp(width, 33 + (height_count - i) * 75 ) );
        table.insert(self._user_item,item);
        table.insert(self.m_isSelect,0);
        table.insert(self.m_userid, user_data[i].user_id)

        item:set_head(user_data[i].user_id, user_data[i].face_id, user_data[i].sex)
        item:set_name(user_data[i].nickname);
        item:set_gold(frame_logic:get_user_win_lose(user_data[i].user_id));
    end
    local height = count * 75 - 10;
    if height < 300 then
        height = 300;
    end 
    self._user_item_scroll:setInnerContainerSize(CCSizeMake(self._scroll_width, height));
end

function frame_report_win:on_btn_close(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    self:show_window(false);
end

function frame_report_win:on_btn_report(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    print("on_btn_report");

    local send_data = {};
    send_data.kind = 3;
    send_data.count = 1;
    send_data.userid = {};

    for k,v in pairs(self.m_isSelect) do
        if v == 1 then
            table.insert(send_data.userid, self.m_userid[k]);
        end
    end
    
    frame_tools:send_data(FRAME_MESSAGE.SUB_GAME_REPORT, send_data);

    self:show_window(false);
end

function frame_report_win:on_btn_select_box(sender, touchType, isSelect, index)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
--    frame_tools:playEffect("frame/sound/click.mp3");

    self.m_isSelect[index] = isSelect;

    local isEnableBtn = false;
    local isSelectCount = 0;
    for k,v in pairs(self.m_isSelect) do
        if v == 1 then
            isSelectCount = isSelectCount + 1;
        end
    end
    
    if isSelectCount > 1 then
        isEnableBtn = true;
    end

    print("index",index);

    self._btn_report:setBright(isEnableBtn);
    self._btn_report:setTouchEnabled(isEnableBtn);
end

--------------------------------------------------------------------------------------------------------------------------------------
--
frame_report_item = class("frame_report_item", function() return ImageView:create() end)
function frame_report_item:ctor()
    self.m_color_win = ccc3(255,144,0);
    self.m_color_lose = ccc3(211,66,8);
end

function frame_report_item:init(callback)
    self.m_select = 0;
    self.callback = callback;
    
    self._bg = ImageView:create()
    self:addChild(self._bg);
    self._bg:loadTexture("frame_report_item_bg2.png", 1);
    self._bg:setPosition(ccp(30,0));

    self._select_box = frame_tools:get_a_btn();
    self:addChild(self._select_box);
    self._select_box:setPosition(ccp(-275,0));
    self._select_box:loadTextures("frame_report_select_box.png","frame_report_select_box.png","frame_report_select_box.png",1);
    self._select_box:addTouchEventListener(function(sender, touchType) self:on_btn_select_box(sender, touchType) end);

    self._select = ImageView:create();
    self._select_box:addChild(self._select);
    self._select:setPosition(ccp(0,0));
    self._select:loadTexture("frame_report_select.png", 1);
    self._select:setVisible(false);

    --头像
    self._head_bg = ImageView:create();
    self._bg:addChild(self._head_bg);
    self._head_bg:setPosition(ccp(-230,0));
    self._head_bg:loadTexture("frame_userinfo_head_bg.png", 1);
    self._head_bg:setScale(55/120);

    self._head = UICustomImage:create();
    self._head_bg:addChild(self._head);
    self._head:setPosition(ccp(0,2));

    --名字
    self._name = UILabelEx3:new();
    self._bg:addChild(self._name);
    self._name:setAnchorPoint(ccp(0, 0.5));
    self._name:setPosition(ccp(-190, 0));
    self._name:setFontSize(26);
    self._name:setTextEx("测试测试测试测试",160);
    self._name:setColor(ccc3(123,56,38));

    --输赢
    self._label_1 = Label:create();
    self._bg:addChild(self._label_1);
    self._label_1:setPosition(ccp(80, 0));
    self._label_1:setText("本局输赢:");
    self._label_1:setFontSize(26);
    self._label_1:setColor(ccc3(123,56,38));

    --金币
    self._gold = Label:create();
    self._label_1:addChild(self._gold);
    self._gold:setAnchorPoint(ccp(0, 0.5));
    self._gold:setPosition(ccp(60, 0));
    self._gold:setFontSize(26);
    self._gold:setColor(self.m_color_lose);
    self._gold:setText("-123456789");

end

function frame_report_item:set_head(userid, face_id, sex)
    self._head:set_head(105, 105, userid, face_id, sex)
end

function frame_report_item:set_name(str_name)
    self._name:setTextEx(str_name, 160);
end

function frame_report_item:set_gold(gold)
    if gold < 0 then
        self._gold:setColor(self.m_color_lose);
        self._gold:setText(tostring(gold));
    else 
        self._gold:setColor(self.m_color_win);
        self._gold:setText("+"..tostring(gold));
    end
end

function frame_report_item:on_btn_select_box(sender, touchType)
    if touchType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end
    frame_tools:playEffect("frame/sound/click.mp3");

    print("on_btn_select_box");

    if self.m_select == 0 then
        self.m_select = 1;
        self._select:setVisible(true);
    else    
        self.m_select = 0;
        self._select:setVisible(false);
    end

    if self.callback then
        self.callback(sender, touchType, self.m_select);
    end
end


--endregion
