CCardPoint3D=class("CCardPoint3D",function() return CCSprite:create() end)
local the_path="card_point/card_point_"
function CCardPoint3D:ctor()
    self._show_ani=nil
    self:init()
end

function CCardPoint3D:init()
    self:setAnchorPoint(ccp(0.5,0))
    self:stopAllActions()
    self:setVisible(false)
end

function CCardPoint3D:showPoint()
   local animation=CCAnimation:create()
   local animation_num=6
   for i=1,animation_num,1 do
       --local sprit_frame = CCSpriteFrame:create((the_path..i..".png"),CCRectMake(0, 0,50,50))
       local sprit_frame = CCSpriteFrameCache:sharedSpriteFrameCache():spriteFrameByName("card_point_"..i..".png")
       animation:addSpriteFrame(sprit_frame)
   end
   animation:setDelayPerUnit(0.6/animation_num)
   animation:setRestoreOriginalFrame(false)
   local animate=CCAnimate:create(animation)
   self:stopAllActions()
   self:runAction(CCRepeatForever:create(animate))
   self:setVisible(true)
end

function CCardPoint3D:hidePoint()
    self:setVisible(false)
    self:stopAllActions()
end

function CCardPoint3D:destroy()
    self:stopAllActions()
    self:setVisible(false)
end

return CCardPoint3D
