--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

UI_SCALE = 0.8--640/750

GameStatus ={
free            = 0,
playing         = 1,
out_card        = 2,
hu              = 3,
finish          = 4,
}

ButtonEventType = {
grade		    = 1, 
ready           = 2,
btn_return      = 3,
btn_chi         = 4,
btn_peng        = 5,
btn_hu          = 6,
btn_gang        = 7,
btn_cancel      = 8,
btn_menu		= 9,
btn_config		= 10,
btn_chat 		= 11,
btn_voice		= 12, 
btn_continue 	= 13,
btn_dissolve	= 14,
btn_copy		= 15,
btn_invite		= 16, 
btn_grade 		= 17,
btn_changetable = 18,
btn_out      	= 19,
btn_no_trust    = 20,
btn_game_rule   = 21,
btn_menu_dissolve = 22,
btn_voice_1		= 23,
btn_help        = 24,
btn_ting_layer  = 25,
btn_finish_layer= 26,
btn_task        = 27,
}

ButtonEventName = {
grade		    = 1, 
ready           = 2,
btn_return      = 3,
btn_menu	    = 9,
btn_config		= 10,
btn_chat 		= 11,
btn_voice		= 12,
btn_continue 	= 13,
btn_dissolve	= 14,
btn_copy		= 15,
btn_invite		= 16, 
btn_grade 		= 17,
btn_changetable = 18,
btn_out      	= 19,
btn_no_trust    = 20,
btn_game_rule   = 21,
btn_menu_dissolve = 22,
btn_voice_1		= 23,
btn_help        = 24,
btn_ting_layer  = 25,
btn_finish_layer= 26,
btn_task        = 27,
}

ButtonPower = {
BUTTON_OUTCARD          =0x00000001,
BUTTON_START            =0x00000002,
BUTTON_CHANGETABLE      =0x00000004,
BUTTON_NO_OUTCARD       =0x00000008,
BUTTON_GRADE            =0x00000010,
BUTTON_AUTO_START       =0x00000020,
BUTTON_POWER_AGAIN      =0x00000040,
BUTTON_POWER_CLOCK	    =0x00000080,
BUTTON_HANDLE_WAIT		=0x00000100,
BUTTON_POWER_LOCK	    =0x00000200,
BUTTON_POWER_FRIEND     =0x00002000,
}

MessageType = {
SUB_S_GAME_START            =101,
SUB_S_OUT_CARD              =102,
SUB_S_HAND_CARDS            =103,
SUB_S_OPERATION             =104,
SUB_S_OPERATION_RESULT      =105,
SUB_S_GAME_DICE             =106,
SUB_S_GAME_CONFIG           =107,
SUB_S_GAME_CHAT             =108,
SUB_S_START_OUT_CARD        =109,
SUB_S_USER_STATUS           =110,
SUB_S_USER_RANK             =111,
SUB_S_GAME_CLOCK            =112,
SUB_S_GAME_FINISH           =113,
SUB_S_USER_TRUST            =114,
SUB_S_SEND_GIFT             =115,
SUB_S_GAME_INFO             =116,
SUB_S_A_HAND_CARDS          =117,
SUB_S_GANG_RESULT           =118,
SUB_S_PENG_RESULT           =119,
SUB_S_HU_RESULT             =120,
SUB_S_CHI_RESULT            =121,
SUB_S_BUTTON_POWER          =122,
SUB_S_HEAP_CARD             =123,
SUB_S_HAND_CARDS_COUNT      =124,
SUB_S_HEAP_OUT_CARD         =125,
SUB_S_TING_HINT             =126,
SUB_S_TING_RESULT           =127,
SUB_S_BANKER                =128,
SUB_S_CARD_COUNT            =130,
SUB_S_GOLD_TEXT             =131,
SUB_S_READY_TIME            =132,
SUB_S_OVER_USER_CHANGETABLE =135,
SUB_S_CAISHEN_CARD          =136,
SUB_S_ZI_GANG_CARDS         =137,
SUB_S_ZI_GANG_HANDLE        =138,
SUB_S_LIAN_ZHUANG_COUNT     =139,
SUB_S_CHANGE_CARD           =140,
SUB_S_FRIENDPARAMRTER_INFO	=141,
SUB_S_BI_HU					=142,				
SUB_S_ZI_GANG_CARD			=143,				
SUB_S_LEAVE_CARDS_HINT      =144,	
SUB_S_USER_SEAT             =145,
SUB_S_HINT_POWER	        =146,		
SUB_S_WIN_STREAK			=147,				--连胜
SUB_S_WIN_STREAK_COUNT		=148,				--连胜数	
SUB_S_WIN_STREAK_HINT		=149,				--连胜提示	

SUB_C_OUTCARD               =1001,
SUB_C_OPERATION             =1002,
SUB_C_TRUST                 =1003,
SUB_C_NO_TRUST              =1004,
SUB_C_SEND_GIFT             =1005,
SUB_C_TING_ANSWER           =1006,
SUB_C_XUAN_ZI_GANG          =1007,
SUB_C_OVER_USER_OUT         =1008,
SUB_C_OVER_USER_CHANGETABLE =1009,
SUB_C_CHANGE_SEAT           =1010,
SUB_C_CHAT_ID               =1011,
}

HintPower = { 
HINT_WAIT_HANDLE			=0x00000001,
HINT_WAIT_QIANGGANG			=0x00000002,
HINT_CHENGBAO2				=0x00000004,
HINT_CHENGBAO3				=0x00000008,
HINT_PENGGANG				=0x00000010,
HINT_FENZHANG				=0x00000020,
HINT_BANKER_OUT             =0x00000040,
}

--玩家状态
PlayerStatus={
us_null=0x00,
us_free=0x01,
us_sit=0x02,
us_ready=0x03,
us_lookon=0x04,
us_play=0x05,
us_offline=0x06
}

RoomLimit = {
score_min   = 0x00000001, 
score_max   = 0x00000002, 
gold_min    = 0x00000004, 
gold_max    = 0x00000008,
charm_min   = 0x00000010, 
charm_max   = 0x00000020
}

KindSound = {
start = 0, 
dice = 1, 
catch_card = 4,  
draw = 5,
outcards = 7,
win = 8, 
lose = 9, 
time_soon = 11,
chi = 10,  
peng = 20,
gang = 30, 
hu = 40,
angang=50,
qidui=51,
qingyise=52,
qingqidui=53,
qingyoujin=54,
youjin=55,
shuangyoujin=56,
fengding=57,
buhua=60,
shudian=70,
huandian=71,
}

HandleTypeS={
HT_MJ_NULL		=	0x0000,		-- 未知
HT_MJ_CANCEL	=	0x0001,		-- 取消
HT_MJ_RIGHTCHI	=	0x0002,		-- 右吃（12吃3）
HT_MJ_ZHONGCHI	=	0x0004,		-- 中吃（13吃2）
HT_MJ_LEFTCHI	=	0x0008,		-- 左吃（23吃1）
HT_MJ_PENG		=	0x0010,		-- 碰
HT_MJ_MINGGANG1	=	0x0020,		-- 明杠（手上有三个，其他玩家出了第四个的时候杠）
HT_MJ_MINGGANG2	=	0x0040,		-- 明杠（组合里有碰，手上有第四个的时候杠）
HT_MJ_ANGANG	=	0x0080,		-- 暗杠（手上有四个的时候杠）
HT_MJ_HU		=	0x0100,		-- 胡
HT_MJ_DUOGANG	=	0x0200,		-- 多杠
HT_MJ_HU_MINGGANG2	= 0x0400,    -- 被抢杠
}

ResultKind={
RESULT_KIND_WIN	 = 0,			--胜
RESULT_KIND_LOST = 1,			--输
RESULT_KIND_DRAW = 2,			--和
RESULT_KIND_FLEE = 3,			--逃
RESULT_KIND_NULL = 4,			--无
}

HuType={
HT_HU_NULL				=			0x00000000, -- 未知
HT_PAI_HU				=			0x00000001, -- 排胡
HT_PING_1				=			0x00000002, -- 平胡1(一花)
HT_PING_2				=			0x00000004, -- 平胡2（无花）
HT_SAN_CAI_SHEN			=			0x00000008, -- 三金倒
HT_JIN_QUE				=			0x00000010, -- 金雀
HT_JIN_LONG				=			0x00000020, -- 金龙
HT_HUN_YI_SE			=			0x00000040, -- 混一色
HT_QING_YI_SE			=			0x00004000, -- 清一色
HT_QIANG_JIN			=			0x00010000, -- 抢金
HT_TIAN_HU				=			0x00020000, -- 天胡
HT_ZI_MO				=			0x00040000, -- 自摸
}

CardInfo={
-- 牌资源宽度
CARD_RESOURCE_WIDTH     = 72,
-- 牌资源高度
CARD_RESOURCE_HEIGHT    = 108,
}

ChatDirection = {left_top = 0, left_down = 1, right_top = 2, right_down = 3}

UserStatus = {null = 0, ready = 1}

ROOM_KIND=nil
ROOM_KIND_SCORE     = 0x0001
ROOM_KIND_SCGOLD    = 0x0010
ROOM_KIND_NOCHEAT   = 0x0020
ROOM_KIND_LINEUP    = 0x0080

ROOM_MODE=nil
ROOM_MODE_FRIEND    = 4

TABLE_ID=nil
SELFCHAIRID = -1

MASK_MODULE_SHOP        = 0x00000400
MASK_MODULE_EXCHANGE    = 0x00000100
MASK_MODULE_WECHAT      = 0x00000020

MASK_MODULE2_EXCHANGE_LOOT			= 0x00000010;

MAX_HANDCARD_COUNT=17;
VIEW_INDEX_SELF=3
VIEW_INDEX_COUNT=4
GAME_PLAYER=4

LocalSelfChairId = 2
LocalViewId = 3

Game_Version = 101
--endregion
