--region *.lua
--Date
--此文件由[BabeLua]插件自动生成

--------------------------------------------------------------------------------
-- 退出界面
--------------------------------------------------------------------------------
help_layer = class("help_layer")

function help_layer.extend(target)
	local t = tolua.getpeer(target)
	if not t then
		t = {}
		tolua.setpeer(target, t)
	end
	setmetatable(t, help_layer)
	return target
end

--------------------------------------------------------------------------------
-- 函数
--------------------------------------------------------------------------------

function help_layer:hide_layer()
	self._runing=true
    local array=CCArray:create()
--    array:addObject(CCScaleTo:create(0.1,1.1))
    array:addObject(CCScaleTo:create(0.1,0))
    array:addObject(CCCallFunc:create(function()
         self:setTouchEnabled(false)
         self:setVisible(false)
         self._runing=false
    end))
    local action=CCSequence:create(array)
    self.bg_form:stopAllActions()
    self.bg_form:runAction(action)
end

function help_layer:show_layer()
	self.bg_form:setScale(0)
	self:setVisible(true)
	self:setTouchEnabled(true)
	self._runing=true
	local array=CCArray:create()
--	array:addObject(CCScaleTo:create(0.2,1.1))
--	array:addObject(CCScaleTo:create(0.1,0.9))
	array:addObject(CCScaleTo:create(0.1,1))
	array:addObject(CCCallFunc:create(function()
		self._runing=false
	end))
	local action=CCSequence:create(array)
	self.bg_form:stopAllActions()
	self.bg_form:runAction(action)
end

function help_layer:init(visibleSize)
	self.back_ground = ImageView:create()
	self.back_ground:loadTexture("bg_black.png",1)
	self.back_ground:setScale9Enabled(true)
	self.back_ground:setAnchorPoint(ccp(0, 0))
	self.back_ground:setSize(visibleSize)
	self:addChild(self.back_ground)

	self.bg_form = UIHelper.create_img(self, ccp(visibleSize.width/2, visibleSize.height/2), "resources/Help_bg.png")

	local img_title = UIHelper.create_img(self.bg_form, ccp(0, self.bg_form:getSize().height/2 - 50), "img_hint.png",1)

    self.scroll_view = UIHelper.create_scroll(self.bg_form,ccp(-365,-215),CCSize(730,380))

    local rule_cnt = 2
    local height = 0
    for i=rule_cnt,1,-1 do
        local rule_img=UIHelper.create_img(self.scroll_view, ccp(365,height), "resources/help"..i..".png",0,ccp(0.5,0))
        height=10+height+rule_img:getContentSize().height

    end
    self.scroll_view:setInnerContainerSize(CCSize(720,height))


    local function touchEvent(sender, eventType)
        self:touch_event(sender, eventType)
    end
    self.back_ground:addTouchEventListener(touchEvent)
    self.back_ground:setTouchEnabled(true);
end

function help_layer:touch_event(sender, eventType)
    if eventType ~= _G.TOUCH_EVENT_ENDED then
        return;
    end

    self:hide_layer();
end

function help_layer:create(visibleSize)
	local layer = help_layer.extend(Layout:create())
	layer:setSize(visibleSize)
	layer:setVisible(false)
	layer:setTouchEnabled(false)
	layer:init(visibleSize)
	return layer
end

--endregion
